define(["exports", "./ResizeObserverController.js", "./utils/element.js"], function (_exports, _ResizeObserverController, _element) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.ResizeObserver = void 0;

  var ResizeObserver = function () {
    function ResizeObserver(callback) {
      if (arguments.length === 0) {
        throw new TypeError("Failed to construct 'ResizeObserver': 1 argument required, but only 0 present.");
      }

      if (typeof callback !== 'function') {
        throw new TypeError("Failed to construct 'ResizeObserver': The callback provided as parameter 1 is not a function.");
      }

      _ResizeObserverController.ResizeObserverController.connect(this, callback);
    }

    ResizeObserver.prototype.observe = function (target, options) {
      if (arguments.length === 0) {
        throw new TypeError("Failed to execute 'observe' on 'ResizeObserver': 1 argument required, but only 0 present.");
      }

      if (!(0, _element.isElement)(target)) {
        throw new TypeError("Failed to execute 'observe' on 'ResizeObserver': parameter 1 is not of type 'Element");
      }

      _ResizeObserverController.ResizeObserverController.observe(this, target, options);
    };

    ResizeObserver.prototype.unobserve = function (target) {
      if (arguments.length === 0) {
        throw new TypeError("Failed to execute 'unobserve' on 'ResizeObserver': 1 argument required, but only 0 present.");
      }

      if (!(0, _element.isElement)(target)) {
        throw new TypeError("Failed to execute 'unobserve' on 'ResizeObserver': parameter 1 is not of type 'Element");
      }

      _ResizeObserverController.ResizeObserverController.unobserve(this, target);
    };

    ResizeObserver.prototype.disconnect = function () {
      _ResizeObserverController.ResizeObserverController.disconnect(this);
    };

    ResizeObserver.toString = function () {
      return 'function ResizeObserver () { [polyfill code] }';
    };

    return ResizeObserver;
  }();

  _exports.ResizeObserver = ResizeObserver;
});