define(["exports", "../../../@polymer/polymer/polymer-element.js", "../../../@polymer/paper-menu-button/paper-menu-button.js", "../../../@polymer/paper-button/paper-button.js", "../../../@polymer/paper-listbox/paper-listbox.js", "../../../@polymer/paper-item/paper-item.js", "../../simple-tooltip/simple-tooltip.js", "../../../@polymer/iron-icons/iron-icons.js", "./editable-table-behaviors.js"], function (_exports, _polymerElement, _paperMenuButton, _paperButton, _paperListbox, _paperItem, _simpleTooltip, _ironIcons, _editableTableBehaviors) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.EditableTableEditorRowcol = void 0;

  function _templateObject_c64ed67001a111ebb416cb2b1003c1c5() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style>\n        :host {\n          display: block;\n          --paper-item-min-height: 24px;\n        }\n        :host .sr-only {\n          position: absolute;\n          left: -9999px;\n          font-size: 0;\n          height: 0;\n          width: 0;\n          overflow: hidden;\n        }\n        :host #label {\n          margin: 0;\n          padding: 0;\n        }\n        :host paper-menu-button {\n          margin: 0;\n          padding: 0;\n          width: 100%;\n        }\n        :host paper-listbox {\n          padding: 0;\n          background-color: var(--editable-table-bg-color);\n        }\n        :host paper-button,\n        :host paper-item {\n          margin: 0;\n          text-transform: none;\n          background-color: transparent;\n          text-align: left;\n          font-family: var(--editable-table-secondary-font-family);\n          color: var(--editable-table-color);\n        }\n        :host paper-item {\n          font-size: var(--editable-table-secondary-font-size);\n        }\n        :host paper-button {\n          display: block;\n          padding-top: var(--editable-table-row-vertical-padding);\n          padding-bottom: var(--editable-table-row-vertical-padding);\n        }\n        :host([condensed]) paper-button {\n          padding-top: var(--editable-table-row-vertical-padding-condensed);\n          padding-bottom: var(--editable-table-row-vertical-padding-condensed);\n        }\n      </style>\n      <paper-menu-button id=\"menu\">\n        <paper-button slot=\"dropdown-trigger\">\n          <span class=\"sr-only\">[[_getType(row)]]</span>\n          <span id=\"label\">[[label]]</span>\n          <span class=\"sr-only\">Menu</span>\n          <iron-icon icon=\"arrow-drop-down\"></iron-icon>\n        </paper-button>\n        <paper-listbox\n          slot=\"dropdown-content\"\n          label=\"[_getType(row)]] [[label]] Menu\"\n        >\n          <paper-item role=\"button\" on-click=\"_onInsertBefore\">\n            Insert [[_getType(row)]] Before\n            <span class=\"sr-only\">[[label]]]</span>\n          </paper-item>\n          <paper-item role=\"button\" on-click=\"_onInsertAfter\">\n            Insert [[_getType(row)]] After\n            <span class=\"sr-only\">[[label]]]</span>\n          </paper-item>\n          <paper-item role=\"button\" on-click=\"_onDelete\">\n            Delete [[_getType(row)]]\n            <span class=\"sr-only\">[[label]]]</span>\n          </paper-item>\n        </paper-listbox>\n      </paper-menu-button>\n      <simple-tooltip for=\"menu\"\n        >[[_getType(row)]] [[label]] Menu</simple-tooltip\n      >\n    "]);

    _templateObject_c64ed67001a111ebb416cb2b1003c1c5 = function _templateObject_c64ed67001a111ebb416cb2b1003c1c5() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `editable-table-editor-rowcol`
   * A header label and menu for inserting and deleting a row or a column of the editable-table interface (editable-table.html).
   *
   * @demo ./demo/editor.html
   *
   * @polymer
   * @element editable-table-editor-rowcol
   * @appliesMixin cellBehaviors
   */
  var EditableTableEditorRowcol = /*#__PURE__*/function (_cellBehaviors) {
    babelHelpers.inherits(EditableTableEditorRowcol, _cellBehaviors);

    var _super = _createSuper(EditableTableEditorRowcol);

    function EditableTableEditorRowcol() {
      babelHelpers.classCallCheck(this, EditableTableEditorRowcol);
      return _super.apply(this, arguments);
    }

    babelHelpers.createClass(EditableTableEditorRowcol, [{
      key: "_getType",

      /**
       * Fires Delete Row/Column is clicked
       * @param {boolean} row whether it's row
       * @returns {string} "Row of "Column""
       */
      value: function _getType(row) {
        return row ? "Row" : "Column";
      }
      /**
       * Fires when  selection is made from menu button
       * @event delete-rowcol
       * @param {number} index the index to perform the action
       * @param {boolean} whether the action is to insert
       */

    }, {
      key: "rowColAction",
      value: function rowColAction() {
        var index = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.index;
        var insert = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
        this.dispatchEvent(new CustomEvent("rowcol-action", {
          bubbles: true,
          cancelable: true,
          composed: true,
          detail: {
            insert: insert,
            row: this.row,
            index: index
          }
        }));
      }
      /**
       * Gets the first cell that the menu controls
       * @param {number} index the index of thee row or column
       * @param {boolean} row is this menu for a row
       * @returns {string} the id of the first cell that the menu controls
       */

    }, {
      key: "_getMenuControls",
      value: function _getMenuControls(index, row) {
        return row ? "cell-0-".concat(index) : "cell-".concat(index, "-0");
      }
      /**
       * Handles when Delete Row/Column is clicked
       * @param {event} e the button event
       */

    }, {
      key: "_onDelete",
      value: function _onDelete(e) {
        this.rowColAction(this.index, false);
      }
      /**
       * Handles when Insert Row/Column is clicked
       * @param {event} e the button event
       */

    }, {
      key: "_onInsertBefore",
      value: function _onInsertBefore(e) {
        this.rowColAction(this.row ? this.index - 1 : this.index);
      }
      /**
       * Handles when Insert Row/Column After is clicked
       * @param {event} e the button event
       */

    }, {
      key: "_onInsertAfter",
      value: function _onInsertAfter(e) {
        this.rowColAction(this.row ? this.index : this.index + 1);
      }
    }], [{
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_c64ed67001a111ebb416cb2b1003c1c5());
      }
    }, {
      key: "tag",
      get: function get() {
        return "editable-table-editor-rowcol";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * The cell that the menu controls
           */
          controls: {
            type: String,
            computed: "_getMenuControls(index,row)",
            reflectToAttribute: true
          },

          /**
           * Index of the row or column
           */
          index: {
            type: Number,
            value: null
          },

          /**
           * Label of the row or column
           */
          label: {
            type: String,
            computed: "_getLabel(index,row)"
          },

          /**
           * Whether the menu button controls a row
           */
          row: {
            type: Boolean,
            value: false
          }
        };
      }
    }]);
    return EditableTableEditorRowcol;
  }((0, _editableTableBehaviors.cellBehaviors)(_polymerElement.PolymerElement));

  _exports.EditableTableEditorRowcol = EditableTableEditorRowcol;
  window.customElements.define(EditableTableEditorRowcol.tag, EditableTableEditorRowcol);
});