define(["exports", "../../lit-element/lit-element.js"], function (_exports, _litElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.FullWidthImage = void 0;

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { babelHelpers.defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  function _templateObject2_b4e3ea1001a111ebb416cb2b1003c1c5() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n          background-color: #000000;\n          height: 300px;\n          margin: 0 !important;\n          padding: 0 !important;\n        }\n\n        :host([hidden]) {\n          display: none;\n        }\n\n        #image {\n          left: 0;\n          right: 0;\n          position: absolute;\n          background-repeat: no-repeat;\n          background-position: center center;\n          background-size: cover;\n          width: 100%;\n          text-align: center;\n        }\n\n        :host([hax-preview-mode]) #image {\n          left: unset;\n          right: unset;\n          position: unset;\n        }\n\n        .wrapper {\n          opacity: 1;\n          background-color: rgba(0, 0, 0, 0.6);\n          padding: 100px;\n          height: 100px;\n          transition: 0.5s all ease-in-out;\n          -webkit-transition: 0.5s all ease-in-out;\n          -moz-transition: 0.5s all ease-in-out;\n          -ms-transition: 0.5s all ease-in-out;\n          -o-transition: 0.5s all ease-in-out;\n        }\n\n        .wrapper:hover {\n          opacity: 0;\n          background-color: transparent;\n        }\n\n        .caption {\n          padding: 35px 0;\n          font-size: 25px;\n          line-height: 40px;\n          color: #fff;\n          font-style: italic;\n        }\n      "]);

    _templateObject2_b4e3ea1001a111ebb416cb2b1003c1c5 = function _templateObject2_b4e3ea1001a111ebb416cb2b1003c1c5() {
      return data;
    };

    return data;
  }

  function _templateObject_b4e3ea1001a111ebb416cb2b1003c1c5() {
    var data = babelHelpers.taggedTemplateLiteral([" <div id=\"image\">\n      <div class=\"wrapper\">\n        <div class=\"caption\">\n          ", "\n          <slot></slot>\n        </div>\n      </div>\n    </div>"]);

    _templateObject_b4e3ea1001a111ebb416cb2b1003c1c5 = function _templateObject_b4e3ea1001a111ebb416cb2b1003c1c5() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `full-width-image`
   * `full width image that flows beyond boundaries`
   *
   * @microcopy - language worth noting:
   *  - images are best used when stretched across content
   *
   * @demo demo/index.html
   * @element full-width-image
   */
  var FullWidthImage = /*#__PURE__*/function (_LitElement) {
    babelHelpers.inherits(FullWidthImage, _LitElement);

    var _super = _createSuper(FullWidthImage);

    function FullWidthImage() {
      babelHelpers.classCallCheck(this, FullWidthImage);
      return _super.apply(this, arguments);
    }

    babelHelpers.createClass(FullWidthImage, [{
      key: "render",
      // render function
      value: function render() {
        return (0, _litElement.html)(_templateObject_b4e3ea1001a111ebb416cb2b1003c1c5(), this.caption);
      } // haxProperty definition

    }, {
      key: "updated",

      /**
       * LitElement properties changed
       */
      value: function updated(changedProperties) {
        var _this = this;

        changedProperties.forEach(function (oldValue, propName) {
          if (propName == "source") {
            _this._sourceChanged(_this[propName]);
          }
        });
      }
    }, {
      key: "_sourceChanged",
      value: function _sourceChanged(newValue) {
        if (babelHelpers.typeof(newValue) !== (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined))) {
          this.shadowRoot.querySelector("#image").style.backgroundImage = "url(\"".concat(newValue, "\")");
        }
      }
    }], [{
      key: "styles",
      //styles function
      get: function get() {
        return [(0, _litElement.css)(_templateObject2_b4e3ea1001a111ebb416cb2b1003c1c5())];
      }
    }, {
      key: "haxProperties",
      get: function get() {
        return {
          canScale: false,
          canPosition: false,
          canEditSource: false,
          gizmo: {
            title: "Full width-image",
            description: "full width image that flows beyond boundaries",
            icon: "image:image",
            color: "green",
            groups: ["Width"],
            handles: [{
              type: "image",
              source: "source",
              caption: "caption",
              title: "caption"
            }],
            meta: {
              author: "btopro",
              owner: "The Pennsylvania State University"
            }
          },
          settings: {
            quick: [{
              property: "source",
              description: "",
              inputMethod: "textfield",
              required: true,
              icon: "image:image",
              validationType: "url"
            }],
            configure: [{
              property: "source",
              description: "",
              inputMethod: "haxupload",
              required: true,
              icon: "icons:link",
              validationType: "url"
            }, {
              property: "caption",
              description: "",
              inputMethod: "textfield"
            }],
            advanced: []
          }
        };
      } // properties available to the custom element for data binding

    }, {
      key: "properties",
      get: function get() {
        return _objectSpread(_objectSpread({}, babelHelpers.get(babelHelpers.getPrototypeOf(FullWidthImage), "properties", this)), {}, {
          source: {
            type: String,
            reflect: true
          },
          caption: {
            type: String,
            reflect: true
          }
        });
      }
      /**
       * convention
       */

    }, {
      key: "tag",
      get: function get() {
        return "full-width-image";
      }
    }]);
    return FullWidthImage;
  }(_litElement.LitElement);

  _exports.FullWidthImage = FullWidthImage;
  window.customElements.define("full-width-image", FullWidthImage);
});