define(["exports", "require", "../../../lit-element/lit-element.js"], function (_exports, _require, _litElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.HaxAppPicker = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject3_c7041cb001a111ebb416cb2b1003c1c5() {
    var data = babelHelpers.taggedTemplateLiteral(["\n              <hax-tray-button\n                id=\"picker-item-", "\"\n                @click=\"", "\"\n                data-selected=\"", "\"\n                label=\"", "\"\n                icon=\"", "\"\n                color=\"", "\"\n                ?color-meaning=\"", "\"\n              >\n              </hax-tray-button>\n            "]);

    _templateObject3_c7041cb001a111ebb416cb2b1003c1c5 = function _templateObject3_c7041cb001a111ebb416cb2b1003c1c5() {
      return data;
    };

    return data;
  }

  function _templateObject2_c7041cb001a111ebb416cb2b1003c1c5() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <paper-dialog id=\"dialog\" ?opened=\"", "\">\n        <h3 id=\"title\">", "</h3>\n        <div class=\"button-list\">\n          ", "\n        </div>\n        <paper-button id=\"closedialog\" @click=\"", "\">\n          <iron-icon icon=\"icons:cancel\" title=\"Close dialog\"></iron-icon>\n        </paper-button>\n      </paper-dialog>\n    "]);

    _templateObject2_c7041cb001a111ebb416cb2b1003c1c5 = function _templateObject2_c7041cb001a111ebb416cb2b1003c1c5() {
      return data;
    };

    return data;
  }

  function _templateObject_c7041cb001a111ebb416cb2b1003c1c5() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n        }\n        iron-icon:not(:defined),\n        paper-button:not(:defined),\n        paper-dialog:not(:defined) {\n          display: none;\n        }\n        #closedialog {\n          float: right;\n          top: 15px;\n          right: 0;\n          position: absolute;\n          padding: 8px;\n          margin: 0;\n          background-color: var(--hax-color-menu-heading-bg, #eeeeee);\n          color: var(--hax-color-menu-heading-color, black);\n          background-color: transparent;\n          width: 40px;\n          height: 40px;\n          min-width: unset;\n        }\n        #dialog {\n          min-width: 400px;\n          min-height: 108px;\n          max-height: 60vh;\n          max-width: 50vw;\n          overflow: hidden;\n          border-radius: 16px;\n          z-index: 1000000;\n          border: 2px solid var(--hax-color-border-outline);\n          background-color: #ffffff;\n          --hax-tray-panel-accent-text: var(\n            --simple-colors-default-theme-grey-1,\n            #fff\n          );\n          --hax-tray-panel-accent: var(\n            --simple-colors-default-theme-purple-8,\n            #8a009b\n          );\n        }\n        .button-list {\n          display: block;\n          text-align: left;\n          margin: 0px;\n          max-width: 50vw;\n          overflow-x: hidden;\n          overflow-y: auto;\n          display: flex;\n          justify-content: space-evenly;\n          flex-wrap: wrap;\n        }\n        #title {\n          color: var(--hax-color-menu-heading-color, black);\n        }\n        #title {\n          padding: 16px;\n          border-bottom: 2px solid var(--hax-color-border-outline);\n          margin: 0;\n          width: calc(100% - 32px);\n          background-color: var(--hax-color-menu-heading-bg, #eeeeee);\n          color: var(--hax-color-menu-heading-color, black);\n        }\n      "]);

    _templateObject_c7041cb001a111ebb416cb2b1003c1c5 = function _templateObject_c7041cb001a111ebb416cb2b1003c1c5() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   `hax-app-picker`
   A picker for selecting an item from a list of apps / hax gizmos which require
   a decision to be made. This is used when multiple things match either on upload
   in the add operation of the app or in the gizmo selection to render through,
   such as having multiple ways of presenting an image.
  
  * @demo demo/index.html
  
  @microcopy - the mental model for this element
   - data - this is the app data model for an element which expresses itself to hax
  */
  var HaxAppPicker = /*#__PURE__*/function (_LitElement) {
    babelHelpers.inherits(HaxAppPicker, _LitElement);

    var _super = _createSuper(HaxAppPicker);

    babelHelpers.createClass(HaxAppPicker, null, [{
      key: "styles",
      get: function get() {
        return [(0, _litElement.css)(_templateObject_c7041cb001a111ebb416cb2b1003c1c5())];
      }
    }]);

    function HaxAppPicker() {
      var _this;

      babelHelpers.classCallCheck(this, HaxAppPicker);
      _this = _super.call(this);
      _this._elements = [];
      _this.selectionList = [];
      _this.title = "Pick an options";
      _this.pickerType = "gizmo";
      _this.opened = false;
      new Promise(function (res, rej) {
        return _require.default(["../../../@polymer/paper-button/paper-button.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../../@polymer/iron-icon/iron-icon.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../../@polymer/paper-dialog/paper-dialog.js"], res, rej);
      });
      setTimeout(function () {
        _this.addEventListener("iron-overlay-canceled", _this.close.bind(babelHelpers.assertThisInitialized(_this)));

        _this.addEventListener("iron-overlay-closed", _this.close.bind(babelHelpers.assertThisInitialized(_this)));
      }, 0);
      return _this;
    }

    babelHelpers.createClass(HaxAppPicker, [{
      key: "render",
      value: function render() {
        var _this2 = this;

        return (0, _litElement.html)(_templateObject2_c7041cb001a111ebb416cb2b1003c1c5(), this.opened, this.title, this.selectionList.map(function (element, index) {
          return (0, _litElement.html)(_templateObject3_c7041cb001a111ebb416cb2b1003c1c5(), index, _this2._selected, index, element.title, element.icon, element.color, _this2.selectionList.length === 2);
        }), this.closeEvent);
      }
    }, {
      key: "closeEvent",
      value: function closeEvent(e) {
        this.opened = false;
      }
    }, {
      key: "firstUpdated",
      value: function firstUpdated(changedProperties) {
        this.dispatchEvent(new CustomEvent("hax-register-core-piece", {
          bubbles: true,
          cancelable: true,
          composed: true,
          detail: {
            piece: "haxAppPicker",
            object: this
          }
        }));
      }
    }, {
      key: "updated",
      value: function updated(changedProperties) {
        var _this3 = this;

        changedProperties.forEach(function (oldValue, propName) {
          if (propName == "opened") {
            _this3._openedChanged(_this3[propName], oldValue);
          }
        });
      }
      /**
       * Close the picker and ensure body locking is off.
       */

    }, {
      key: "close",
      value: function close() {
        this.opened = false;
      }
      /**
       * Open status changed
       */

    }, {
      key: "_openedChanged",
      value: function _openedChanged(newValue, oldValue) {
        if (newValue) {
          // lock the background
          document.body.style.overflow = "hidden";
        } else {
          this.selectionList = [];
          document.body.style.overflow = null;
        }
      }
      /**
       * Present options to the user with a modal and selection method that
       * shifts itself to be above everything (stack order)
       * @param  [array] elements  a list of elements for presenting to the user
       * to select between.
       */

    }, {
      key: "presentOptions",
      value: function presentOptions(elements) {
        var _this4 = this;

        var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "element";
        var title = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "Select an option";
        var pickerType = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : "gizmo";
        // wipe existing
        this.title = title;
        this.pickerType = pickerType;
        var tmp = [];

        switch (pickerType) {
          // hax gizmo selector
          case "gizmo":
            for (var i in elements) {
              elements[i].__type = type;
              tmp.push({
                icon: elements[i].gizmo.icon,
                title: elements[i].gizmo.title,
                color: elements[i].gizmo.color
              });
            }

            break;
          // app selector

          case "app":
            for (var i in elements) {
              tmp.push({
                icon: elements[i].details.icon,
                title: elements[i].details.title,
                color: elements[i].details.color
              });
            }

            break;
          // we don't know what to do with this

          default:
            tmp = elements;
            break;
        }

        this._elements = elements;
        this.selectionList = babelHelpers.toConsumableArray(tmp);
        this.opened = true; // try to focus on option 0

        setTimeout(function () {
          _this4.shadowRoot.querySelector("#picker-item-0").focus();
        }, 50);
      }
      /**
       * Handle the user selecting an app.
       */

    }, {
      key: "_selected",
      value: function _selected(e) {
        var key = e.target.getAttribute("data-selected");
        e.preventDefault();
        e.stopPropagation();

        if (babelHelpers.typeof(this._elements[key]) !== (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined))) {
          // haxElement is a unique case
          if (this.pickerType == "gizmo") {
            this._elements[key].replace = true;
            this.dispatchEvent(new CustomEvent("hax-insert-content", {
              bubbles: true,
              cancelable: true,
              composed: true,
              detail: this._elements[key]
            }));
          } else {
            // bubble this up
            this.dispatchEvent(new CustomEvent("hax-app-picker-selection", {
              bubbles: true,
              cancelable: true,
              composed: true,
              detail: this._elements[key]
            }));
          }
        }

        this.opened = false;
      }
    }], [{
      key: "tag",
      get: function get() {
        return "hax-app-picker";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * raw element set
           */
          _elements: {
            type: Array
          },

          /**
           * Refactored list for selection purposes
           */
          selectionList: {
            type: Array
          },

          /**
           * Title for the dialog
           */
          title: {
            type: String
          },

          /**
           * Allow multiple uses
           */
          pickerType: {
            type: String,
            attribute: "picker-type"
          },

          /**
           * Opened status to bind to the dialog box being open
           */
          opened: {
            type: Boolean
          }
        };
      }
    }]);
    return HaxAppPicker;
  }(_litElement.LitElement);

  _exports.HaxAppPicker = HaxAppPicker;
  window.customElements.define(HaxAppPicker.tag, HaxAppPicker);
});