define(["exports", "../../../../../lit-element/lit-element.js", "../../core/haxcms-site-store.js", "../../../../../mobx/lib/mobx.module.js"], function (_exports, _litElement, _haxcmsSiteStore, _mobxModule) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.SiteActiveFields = void 0;

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `site-active-fields`
   * `Title of the active page in the site`
   *
  
   * @demo demo/index.html
   */
  var SiteActiveFields = /*#__PURE__*/function (_LitElement) {
    babelHelpers.inherits(SiteActiveFields, _LitElement);

    var _super = _createSuper(SiteActiveFields);

    function SiteActiveFields() {
      babelHelpers.classCallCheck(this, SiteActiveFields);
      return _super.apply(this, arguments);
    }

    babelHelpers.createClass(SiteActiveFields, [{
      key: "updated",

      /**
       * LitElement life cycle callback
       */
      value: function updated(changedProperties) {
        var _this = this;

        changedProperties.forEach(function (oldValue, propName) {
          if (propName == "fields") {
            _this.dispatchEvent(new CustomEvent("fields-changed", {
              detail: _this[propName]
            }));
          }
        });
      }
      /**
       * VanillaJS life cycle callback
       */

    }, {
      key: "connectedCallback",
      value: function connectedCallback() {
        var _this2 = this;

        babelHelpers.get(babelHelpers.getPrototypeOf(SiteActiveFields.prototype), "connectedCallback", this).call(this);
        this.__disposer = (0, _mobxModule.autorun)(function () {
          _this2.fields = (0, _mobxModule.toJS)(_haxcmsSiteStore.store.activeItemFields);
        });
      }
      /**
       * VanillaJS life cycle callback
       */

    }, {
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        this.__disposer();

        babelHelpers.get(babelHelpers.getPrototypeOf(SiteActiveFields.prototype), "disconnectedCallback", this).call(this);
      }
    }], [{
      key: "tag",

      /**
       * Store the tag name to make it easier to obtain directly.
       */
      get: function get() {
        return "site-active-fields";
      }
      /**
       * LitElement properties decorator
       */

    }, {
      key: "properties",
      get: function get() {
        return {
          fields: {
            type: Object
          }
        };
      }
    }]);
    return SiteActiveFields;
  }(_litElement.LitElement);

  _exports.SiteActiveFields = SiteActiveFields;
  window.customElements.define(SiteActiveFields.tag, SiteActiveFields);
});