define(["exports", "../../../../../lit-element/lit-element.js", "../../core/haxcms-site-store.js", "../../../../../mobx/lib/mobx.module.js"], function (_exports, _litElement, _haxcmsSiteStore, _mobxModule) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.SiteActiveTitle = void 0;

  function _templateObject_dbcbefb001a111ebb416cb2b1003c1c5() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style>\n        :host {\n          display: block;\n        }\n        h1 {\n          text-rendering: optimizelegibility;\n          font-family: sans-serif;\n          color: var(--site-active-title-color);\n          margin: var(--site-active-title-margin);\n          padding: var(--site-active-title-padding);\n        }\n      </style>\n      <h1>", "</h1>\n    "]);

    _templateObject_dbcbefb001a111ebb416cb2b1003c1c5 = function _templateObject_dbcbefb001a111ebb416cb2b1003c1c5() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `site-active-title`
   * `Title of the active page in the site`
   *
   * @demo demo/index.html
   */
  var SiteActiveTitle = /*#__PURE__*/function (_LitElement) {
    babelHelpers.inherits(SiteActiveTitle, _LitElement);

    var _super = _createSuper(SiteActiveTitle);

    babelHelpers.createClass(SiteActiveTitle, [{
      key: "render",

      /**
       * LitElement
       */
      value: function render() {
        return (0, _litElement.html)(_templateObject_dbcbefb001a111ebb416cb2b1003c1c5(), this.__title);
      }
      /**
       * LitElement life cycle - property changed
       */

    }, {
      key: "updated",
      value: function updated(changedProperties) {
        var _this2 = this;

        changedProperties.forEach(function (oldValue, propName) {
          if (propName == "dynamicMethodology") {
            _this2.__title = _this2._makeTitle(_this2.dynamicMethodology, _this2.activeTitle, _this2.parentTitle, _this2.ancestorTitle);
          }
        });
      }
      /**
       * LitElement / popular convention
       */

    }, {
      key: "_makeTitle",

      /**
       * Generate title based on context
       */
      value: function _makeTitle(dynamicMethodology, activeTitle, parentTitle, ancestorTitle) {
        switch (dynamicMethodology) {
          case "above":
            if (parentTitle === "" && !this.noFallback) {
              return activeTitle;
            }

            return parentTitle;
            break;

          case "ancestor":
            if (ancestorTitle === "" && !this.noFallback) {
              return activeTitle;
            }

            return ancestorTitle;
            break;

          default:
            return activeTitle;
            break;
        }
      }
      /**
       * HTMLElement
       */

    }], [{
      key: "tag",

      /**
       * Store the tag name to make it easier to obtain directly.
       */
      get: function get() {
        return "site-active-title";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          __title: {
            type: String
          },
          dynamicMethodology: {
            type: String
          },
          editMode: {
            type: Boolean,
            reflect: true,
            attribute: "edit-mode"
          }
        };
      }
    }]);

    function SiteActiveTitle() {
      var _this;

      babelHelpers.classCallCheck(this, SiteActiveTitle);
      _this = _super.call(this);
      _this.noFallback = false;
      _this.dynamicMethodology = "active";
      _this.__title = "";
      _this.__disposer = [];
      (0, _mobxModule.autorun)(function (reaction) {
        _this.editMode = (0, _mobxModule.toJS)(_haxcmsSiteStore.store.editMode);

        _this.__disposer.push(reaction);
      });
      (0, _mobxModule.autorun)(function (reaction) {
        _this.activeTitle = (0, _mobxModule.toJS)(_haxcmsSiteStore.store.activeTitle);
        _this.__title = _this._makeTitle(_this.dynamicMethodology, _this.activeTitle, _this.parentTitle, _this.ancestorTitle);

        _this.__disposer.push(reaction);
      });
      (0, _mobxModule.autorun)(function (reaction) {
        _this.ancestorTitle = (0, _mobxModule.toJS)(_haxcmsSiteStore.store.ancestorTitle);
        _this.__title = _this._makeTitle(_this.dynamicMethodology, _this.activeTitle, _this.parentTitle, _this.ancestorTitle);

        _this.__disposer.push(reaction);
      });
      (0, _mobxModule.autorun)(function (reaction) {
        _this.parentTitle = (0, _mobxModule.toJS)(_haxcmsSiteStore.store.parentTitle);
        _this.__title = _this._makeTitle(_this.dynamicMethodology, _this.activeTitle, _this.parentTitle, _this.ancestorTitle);

        _this.__disposer.push(reaction);
      });
      return _this;
    }
    /**
     * HTMLElement
     */


    babelHelpers.createClass(SiteActiveTitle, [{
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        // clean up state
        for (var i in this.__disposer) {
          this.__disposer[i].dispose();
        }

        babelHelpers.get(babelHelpers.getPrototypeOf(SiteActiveTitle.prototype), "disconnectedCallback", this).call(this);
      }
      /**
       * Break shadowRoot
       */

    }, {
      key: "createRenderRoot",
      value: function createRenderRoot() {
        return this;
      }
    }]);
    return SiteActiveTitle;
  }(_litElement.LitElement);

  _exports.SiteActiveTitle = SiteActiveTitle;
  window.customElements.define(SiteActiveTitle.tag, SiteActiveTitle);
});