define(["exports", "require", "../../lit-element/lit-element.js"], function (_exports, _require, _litElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrnAside = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject2_bd4e749001a111ebb416cb2b1003c1c5() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: flex;\n          padding: 8px;\n        }\n        :host([sticky]) {\n          top: 0;\n          position: sticky;\n        }\n        :host([direction=\"left\"]) {\n          float: left;\n          max-width: 480px;\n        }\n        :host([direction=\"right\"]) {\n          float: right;\n          max-width: 480px;\n        }\n      "]);

    _templateObject2_bd4e749001a111ebb416cb2b1003c1c5 = function _templateObject2_bd4e749001a111ebb416cb2b1003c1c5() {
      return data;
    };

    return data;
  }

  function _templateObject_bd4e749001a111ebb416cb2b1003c1c5() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <aside>\n        <lrndesign-panelcard title=\"", "\">\n          <slot></slot>\n        </lrndesign-panelcard>\n      </aside>\n    "]);

    _templateObject_bd4e749001a111ebb416cb2b1003c1c5 = function _templateObject_bd4e749001a111ebb416cb2b1003c1c5() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `lrn-aside`
   * A content aside as a panel
   * @demo demo/index.html
   * @element lrn-aside
   */
  var LrnAside = /*#__PURE__*/function (_LitElement) {
    babelHelpers.inherits(LrnAside, _LitElement);

    var _super = _createSuper(LrnAside);

    function LrnAside() {
      var _this;

      babelHelpers.classCallCheck(this, LrnAside);
      _this = _super.call(this);
      _this.title = "Related content";
      _this.sticky = false;
      _this.direction = "";
      setTimeout(function () {
        new Promise(function (res, rej) {
          return _require.default(["../lrndesign-panelcard/lrndesign-panelcard.js"], res, rej);
        });
      }, 0);
      return _this;
    }

    babelHelpers.createClass(LrnAside, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject_bd4e749001a111ebb416cb2b1003c1c5(), this.title);
      }
    }], [{
      key: "styles",
      get: function get() {
        return [(0, _litElement.css)(_templateObject2_bd4e749001a111ebb416cb2b1003c1c5())];
      }
    }, {
      key: "tag",
      get: function get() {
        return "lrn-aside";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * Title for the aside.
           */
          title: {
            type: String
          },

          /**
           * Apply CSS sticky styling
           */
          sticky: {
            type: Boolean,
            reflect: true
          },

          /**
           * Direction to hang off UI if sticky, left or right.
           */
          direction: {
            type: String,
            reflect: true
          }
        };
      }
      /**
       * Attached to the DOM, now fire.
       */

    }, {
      key: "haxProperties",
      get: function get() {
        return {
          canScale: true,
          canPosition: true,
          canEditSource: false,
          gizmo: {
            title: "Sticky note",
            description: "A sticky note to present some basic info offset on the page.",
            icon: "av:note",
            color: "yellow",
            groups: ["Content"],
            handles: [{
              type: "text",
              title: "title"
            }],
            meta: {
              author: "ELMS:LN"
            }
          },
          settings: {
            quick: [{
              property: "title",
              title: "Title",
              description: "Enter title for sticky note",
              inputMethod: "textfield",
              required: true
            }],
            configure: [{
              property: "title",
              title: "Title",
              description: "Enter title for sticky note.",
              inputMethod: "textfield",
              required: true
            }, {
              slot: "",
              title: "Content",
              description: "Content of the sticky note",
              inputMethod: "code-editor",
              required: true
            }, {
              property: "sticky",
              title: "Stick to page on scroll",
              description: "Appear sticky when the user scrolls past it",
              inputMethod: "boolean"
            }, {
              property: "direction",
              title: "Direction to hang",
              description: "Location of the sticky note to hang",
              inputMethod: "select",
              options: {
                "": "none",
                right: "Right",
                left: "Left"
              }
            }],
            advanced: []
          }
        };
      }
    }]);
    return LrnAside;
  }(_litElement.LitElement);

  _exports.LrnAside = LrnAside;
  window.customElements.define(LrnAside.tag, LrnAside);
});