define(["exports", "../../lit-element/lit-element.js", "../simple-colors/simple-colors.js", "../../@polymer/iron-icons/iron-icons.js", "../../@polymer/iron-icon/iron-icon.js"], function (_exports, _litElement, _simpleColors, _ironIcons, _ironIcon) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrndesignSidenote = void 0;

  function _templateObject2_c1312d0001a111ebb416cb2b1003c1c5() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n        }\n\n        #container {\n          display: block;\n          background-color: var(\n            --simple-colors-default-theme-accent-1,\n            #ffffff\n          );\n          padding: var(--lrndesign-sidenote-container-padding, 16px);\n          margin-left: var(--lrndesign-sidenote-container-margin-left, 0px);\n          color: var(--simple-colors-default-theme-accent-12, #000);\n        }\n\n        #header {\n          display: flex;\n          align-items: center;\n        }\n\n        #icon {\n          margin-right: 8px;\n        }\n\n        #label {\n          font-size: 20.8px;\n          margin: 12.8px 0;\n          flex: 1 1 auto;\n        }\n      "]);

    _templateObject2_c1312d0001a111ebb416cb2b1003c1c5 = function _templateObject2_c1312d0001a111ebb416cb2b1003c1c5() {
      return data;
    };

    return data;
  }

  function _templateObject_c1312d0001a111ebb416cb2b1003c1c5() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <div id=\"container\">\n        <div id=\"header\">\n          <iron-icon id=\"icon\" icon=", "></iron-icon>\n          <div id=\"label\">", "</div>\n        </div>\n        <slot></slot>\n      </div>\n    "]);

    _templateObject_c1312d0001a111ebb416cb2b1003c1c5 = function _templateObject_c1312d0001a111ebb416cb2b1003c1c5() {
      return data;
    };

    return data;
  }

  function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

  function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { babelHelpers.defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
  `lrndesign-sidenote`
  A basic side note
  
  * @demo demo/index.html
  */
  var LrndesignSidenote = /*#__PURE__*/function (_SimpleColors) {
    babelHelpers.inherits(LrndesignSidenote, _SimpleColors);

    var _super = _createSuper(LrndesignSidenote);

    babelHelpers.createClass(LrndesignSidenote, null, [{
      key: "properties",
      get: function get() {
        return _objectSpread(_objectSpread({}, babelHelpers.get(babelHelpers.getPrototypeOf(LrndesignSidenote), "properties", this)), {}, {
          label: {
            type: String
          },
          icon: {
            type: String
          }
        });
      }
    }, {
      key: "haxProperties",
      get: function get() {
        return {
          canScale: false,
          canPosition: true,
          canEditSource: false,
          gizmo: {
            title: "Side-Note",
            description: "A .",
            icon: "icons:bookmark",
            color: "blue",
            groups: [""],
            meta: {
              author: "ELMS:LN"
            }
          },
          settings: {
            configure: [{
              property: "label",
              title: "Label",
              description: "The label of the sidenote.",
              inputMethod: "textfield",
              icon: "editor:title"
            }, {
              property: "dark",
              title: "Dark",
              inputMethod: "boolean"
            }, {
              property: "icon",
              title: "Icon",
              description: "The icon of the sidenote.",
              inputMethod: "iconpicker",
              options: ["icons:announcement", "icons:book", "icons:bookmark", "icons:check-circle", "icons:feedback", "icons:thumb-down", "icons:thumb-up", "icons:warning"]
            }, {
              property: "accentColor",
              title: "Color",
              description: "The background color of the sidenote.",
              inputMethod: "colorpicker",
              icon: "editor:format-color-fill"
            }, {
              slot: "",
              title: "Content",
              description: "Content of the side note.",
              inputMethod: "code-editor"
            }],
            advanced: []
          },
          demoSchema: [{
            tag: "lrndesign-sidenote",
            content: "<p>Content goes here...</p>",
            properties: {
              label: "Label",
              icon: "bookmark"
            }
          }]
        };
      }
    }]);

    function LrndesignSidenote() {
      var _this;

      babelHelpers.classCallCheck(this, LrndesignSidenote);
      _this = _super.call(this);
      _this.label = "";
      _this.icon = "";
      return _this;
    }

    babelHelpers.createClass(LrndesignSidenote, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject_c1312d0001a111ebb416cb2b1003c1c5(), this.icon, this.label);
      }
    }], [{
      key: "styles",
      get: function get() {
        return [].concat(babelHelpers.toConsumableArray(babelHelpers.get(babelHelpers.getPrototypeOf(LrndesignSidenote), "styles", this)), [(0, _litElement.css)(_templateObject2_c1312d0001a111ebb416cb2b1003c1c5())]);
      }
    }, {
      key: "tag",
      get: function get() {
        return "lrndesign-sidenote";
      }
    }]);
    return LrndesignSidenote;
  }(_simpleColors.SimpleColors);

  _exports.LrndesignSidenote = LrndesignSidenote;
  customElements.define("lrndesign-sidenote", LrndesignSidenote);
});