define(["exports", "../../../@polymer/polymer/polymer-element.js", "../../../@polymer/polymer/lib/legacy/class.js", "./material-progress-behavior.js"], function (_exports, _polymerElement, _class, _materialProgressBehavior) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.MaterialProgressBars = void 0;

  function _templateObject_c973bd2001a111ebb416cb2b1003c1c5() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style>\n        #barsContainer {\n          overflow: hidden;\n          background-color: var(\n            --material-progress-bars-background-color,\n            #e0e0e0\n          );\n          border-radius: calc(var(--material-progress-bar-height) / 2);\n          min-width: var(--material-progress-bar-height);\n          height: var(--material-progress-bar-height);\n          @apply --layout;\n          @apply --material-progress-bars-style;\n        }\n        :host > #barsContainer > ::content > .bar {\n          margin-left: calc(-var(--material-progress-bar-height) / 2);\n          border-radius: 0 calc(var(--material-progress-bar-height) / 2)\n            calc(var(--material-progress-bar-height) / 2) 0;\n        }\n        :host([animated]) > #barsContainer > ::content > .entry {\n          -webkit-transition: width 850ms cubic-bezier(0.4, 0, 0.2, 1);\n          -ms-transition: width 850ms cubic-bezier(0.4, 0, 0.2, 1);\n          -moz-transition: width 850ms cubic-bezier(0.4, 0, 0.2, 1);\n          -o-transition: width 850ms cubic-bezier(0.4, 0, 0.2, 1);\n          transition: width 850ms cubic-bezier(0.4, 0, 0.2, 1);\n        }\n        :host > #barsContainer > ::content > * > span {\n          margin: 0 calc(var(--material-progress-bar-height) * 1 / 3) 0\n            calc(var(--material-progress-bar-height) * 5 / 6);\n        }\n      </style>\n      <div id=\"barsContainer\">\n        <slot id=\"content\" name=\".bar[data-value]\"></slot>\n      </div>\n      <div class=\"legend\" hidden$=\"[[_legendNeeded]]\">\n        <template is=\"dom-repeat\" items=\"[[_legendItems]]\" as=\"l\">\n          <span style$=\"color: [[l.color]];\">[[l.label]]</span>\n        </template>\n      </div>\n    "]);

    _templateObject_c973bd2001a111ebb416cb2b1003c1c5 = function _templateObject_c973bd2001a111ebb416cb2b1003c1c5() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  var MaterialProgressBars = /*#__PURE__*/function (_mixinBehaviors) {
    babelHelpers.inherits(MaterialProgressBars, _mixinBehaviors);

    var _super = _createSuper(MaterialProgressBars);

    function MaterialProgressBars() {
      babelHelpers.classCallCheck(this, MaterialProgressBars);
      return _super.apply(this, arguments);
    }

    babelHelpers.createClass(MaterialProgressBars, [{
      key: "_getWidthForBar",
      value: function _getWidthForBar(barValue, barValuesSum, maxBarValue, barHeight) {
        var realMax = Math.max(barValuesSum, this.max),
            width = (realMax > 0 ? Math.floor(barValue / realMax * 10000) / 100 : "0") + "%",
            negativeMargin = barHeight / 2;
        return "calc(" + width + " + " + negativeMargin + "px" + ")";
      }
    }], [{
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_c973bd2001a111ebb416cb2b1003c1c5());
      }
    }, {
      key: "tag",
      get: function get() {
        return "material-progress-bars";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * Maximum value represented by all progress bars.
           * Bars will be scaled according to their `data-value` attribute
           * and this maximum.
           * Note that, if the sum of all the bars' values are superior to this
           * `max`
           * @element max, it will override it.
           */
          max: {
            type: Number,
            value: 100,
            observer: "_refresh"
          }
        };
      }
    }]);
    return MaterialProgressBars;
  }((0, _class.mixinBehaviors)([MaterialProgressBehaviorImpl], _polymerElement.PolymerElement));

  _exports.MaterialProgressBars = MaterialProgressBars;
  window.customElements.define(MaterialProgressBars.tag, MaterialProgressBars);
});