define(["exports", "./lib/MutationObserverImportMixin.js"], function (_exports, _MutationObserverImportMixin) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.MutationObserverImportElement = void 0;

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `mutation-observer-import-mixin`
   * `a SuperClass mixin that dynamically imports undefined custom element definitions`
   * @demo demo/index.html
   * @element mutation-observer-import-mixin
   */
  var MutationObserverImportElement = /*#__PURE__*/function (_MutationObserverImpo) {
    babelHelpers.inherits(MutationObserverImportElement, _MutationObserverImpo);

    var _super = _createSuper(MutationObserverImportElement);

    function MutationObserverImportElement() {
      babelHelpers.classCallCheck(this, MutationObserverImportElement);
      return _super.apply(this, arguments);
    }

    babelHelpers.createClass(MutationObserverImportElement, [{
      key: "connectedCallback",
      value: function connectedCallback() {
        babelHelpers.get(babelHelpers.getPrototypeOf(MutationObserverImportElement.prototype), "connectedCallback", this).call(this);
        this.processElementList(this.children);
      }
    }], [{
      key: "tag",
      get: function get() {
        return "mutation-observer-import";
      }
    }]);
    return MutationObserverImportElement;
  }((0, _MutationObserverImportMixin.MutationObserverImportMixin)(HTMLElement));

  _exports.MutationObserverImportElement = MutationObserverImportElement;
  customElements.define(MutationObserverImportElement.tag, MutationObserverImportElement);
});