define(["exports", "require", "../../../../lit-element/lit-element.js", "./rich-text-editor-button-styles.js", "../../../../@polymer/paper-button/paper-button.js", "../../../../@polymer/iron-a11y-keys/iron-a11y-keys.js", "../singletons/rich-text-editor-selection.js"], function (_exports, _require, _litElement, _richTextEditorButtonStyles, _paperButton, _ironA11yKeys, _richTextEditorSelection) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.RichTextEditorButtonBehaviors = _exports.RichTextEditorButton = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject2_d793c44001a111ebb416cb2b1003c1c5() {
    var data = babelHelpers.taggedTemplateLiteral(["\n          .rtebutton {\n            min-width: var(--rich-text-editor-button-min-width);\n            height: var(--rich-text-editor-button-height);\n            margin: var(--rich-text-editor-button-margin);\n            padding: var(--rich-text-editor-button-padding);\n          }\n  \xA0\xA0\xA0\xA0\xA0\xA0"]);

    _templateObject2_d793c44001a111ebb416cb2b1003c1c5 = function _templateObject2_d793c44001a111ebb416cb2b1003c1c5() {
      return data;
    };

    return data;
  }

  function _templateObject_d793c44001a111ebb416cb2b1003c1c5() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        <iron-a11y-keys\n          id=\"a11y\"\n          .target=\"", "\"\n          keys=\"enter\"\n          @keys-pressed=\"", "\"\n        >\n        </iron-a11y-keys>\n        <paper-button\n          id=\"button\"\n          class=\"rtebutton\"\n          ?disabled=\"", "\"\n          ?controls=\"", "\"\n          @click=\"", "\"\n          tabindex=\"0\"\n          ?toggled=\"", "\"\n        >\n          <iron-icon id=\"icon\" aria-hidden=\"true\" icon=\"", "\">\n          </iron-icon>\n          <span id=\"label\" class=\"", "\"\n            >", "</span\n          >\n        </paper-button>\n        <simple-tooltip id=\"tooltip\" for=\"button\"\n          >", "</simple-tooltip\n        >\n      "]);

    _templateObject_d793c44001a111ebb416cb2b1003c1c5 = function _templateObject_d793c44001a111ebb416cb2b1003c1c5() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  var RichTextEditorButtonBehaviors = function RichTextEditorButtonBehaviors(SuperClass) {
    return /*#__PURE__*/function (_RichTextEditorButton) {
      babelHelpers.inherits(_class, _RichTextEditorButton);

      var _super = _createSuper(_class);

      babelHelpers.createClass(_class, [{
        key: "render",
        value: function render() {
          return (0, _litElement.html)(_templateObject_d793c44001a111ebb416cb2b1003c1c5(), this.__a11y, this._buttonTap, this.disabled, this.controls, this._buttonTap, this.isToggled, this.currentIcon, this.labelStyle, this.currentLabel, this.currentLabel);
        }
      }], [{
        key: "tag",

        /**
         * Store the tag name to make it easier to obtain directly.
         */
        get: function get() {
          return "rich-text-editor-button";
        }
      }, {
        key: "styles",
        get: function get() {
          return [].concat(babelHelpers.toConsumableArray(babelHelpers.get(babelHelpers.getPrototypeOf(_class), "styles", this)), [(0, _litElement.css)(_templateObject2_d793c44001a111ebb416cb2b1003c1c5())]);
        }
      }, {
        key: "properties",
        get: function get() {
          return {
            /**
             * The `id` of the `rich-text-editor` that the toolbar controls.
             */
            controls: {
              type: String
            },

            /**
             * The command used for document.execCommand.
             */
            command: {
              type: String
            },

            /**
             * Optional parameter for the command.
             */
            commandVal: {
              attribute: "command-val",
              type: Object
            },

            /**
             * Is the button disabled? Default is false.
             */
            disabled: {
              type: Boolean
            },

            /**
             * Optional iron icon name for the button.
             */
            icon: {
              type: String
            },

            /**
             * Label for the icon.
             */
            label: {
              type: String
            },

            /**
             * The active selected range, inherited from the toolbar
             */
            range: {
              type: Object
            },

            /**
             * Optional space-sperated list of keyboard shortcuts for the editor
             * to fire this button, see iron-a11y-keys for more info.
             */
            shortcutKeys: {
              attribute: "shortcut-keys",
              type: String
            },

            /**
             * Show text label even if an icon is named?
             */
            showTextLabel: {
              attribute: "show-text-label",
              type: Boolean
            },

            /**
             * The active selected range, inherited from the toolbar
             */
            tag: {
              type: String
            },

            /**
             * The active selected range, inherited from the toolbar
             */
            target: {
              type: Object
            },

            /**
             * The command used for document.execCommand when toggled.
             */
            toggledCommand: {
              attribute: "toggled-command",
              type: String
            },

            /**
             * Optional parameter for the command when toggled.
             */
            toggledCommandVal: {
              attribute: "toggled-command-val",
              type: Object
            },

            /**
             * Optional iron icon name for the button if it is toggled.
             */
            toggledIcon: {
              attribute: "toggled-icon",
              type: String
            },

            /**
             * Label for the icon, if button is toggled.
             */
            toggledLabel: {
              attribute: "toggled-label",
              type: String
            },

            /**
             * Can this button toggle?
             */
            toggles: {
              type: Boolean
            },

            /**
             * highlight surrounding selected range
             */
            __selection: {
              type: Object
            }
          };
        }
      }]);

      function _class() {
        var _this;

        babelHelpers.classCallCheck(this, _class);
        _this = _super.call(this);
        _this.__selection = window.RichTextEditorSelection.requestAvailability();
        _this.disabled = false;
        _this.showTextLabel = false;
        _this.toggles = false;
        new Promise(function (res, rej) {
          return _require.default(["../../../../@polymer/iron-icons/iron-icons.js"], res, rej);
        });
        new Promise(function (res, rej) {
          return _require.default(["../../../../@polymer/iron-icons/editor-icons.js"], res, rej);
        });
        new Promise(function (res, rej) {
          return _require.default(["../../../../@polymer/iron-icons/image-icons.js"], res, rej);
        });
        new Promise(function (res, rej) {
          return _require.default(["../../../md-extra-icons/md-extra-icons.js"], res, rej);
        });
        new Promise(function (res, rej) {
          return _require.default(["../../../simple-tooltip/simple-tooltip.js"], res, rej);
        });
        /*this.addEventListener("mousedown", function(e) {
          //console.log("mousedown", e);
        });
        this.addEventListener("keypress", function(e) {
          e.preventDefault();
        });*/

        return _this;
      }

      babelHelpers.createClass(_class, [{
        key: "updated",
        value: function updated(changedProperties) {
          var _this2 = this;

          babelHelpers.get(babelHelpers.getPrototypeOf(_class.prototype), "updated", this).call(this, changedProperties);
          changedProperties.forEach(function (oldValue, propName) {
            if (propName === "controls") _this2._editorChanged();
            if (propName === "range") _this2._rangeChanged();
            if (propName === "commandVal") _this2._commandValChanged();
            if (propName === "toggledCommandVal") _this2._toggledCommandValChanged();
          });
        }
        /**
         * life cycle, element is afixed to the DOM
         */

      }, {
        key: "connectedCallback",
        value: function connectedCallback() {
          babelHelpers.get(babelHelpers.getPrototypeOf(_class.prototype), "connectedCallback", this).call(this);
          this.__a11y = this.shadowRoot.querySelector("#button");
        }
        /**
         * life cycle, element is detatched
         */

      }, {
        key: "disconnectedCallback",
        value: function disconnectedCallback() {
          babelHelpers.get(babelHelpers.getPrototypeOf(_class.prototype), "disconnectedCallback", this).call(this);
        }
        /**
         * gets command param for document.execCommand
         *
         * @readonly
         */

      }, {
        key: "execCommand",

        /**
         * executes button command on current range
         *
         */
        value: function execCommand() {
          if (this.range) {
            document.execCommand(this.operationCommand, false, this.operationCommandVal);
            this.dispatchEvent(new CustomEvent(this.operationCommand + "-button", {
              bubbles: true,
              cancelable: true,
              composed: true,
              detail: this
            }));
          }
        }
        /**
         * expands range to selection's parent block
         */

      }, {
        key: "setRange",
        value: function setRange() {
          /* if command is formatBlock expand selection to entire block */
          var block = this._getSelectedBlock();

          if (block) this.__selection.selectNode(block);
        }
        /**
         * Handles button tap
         */

      }, {
        key: "_buttonTap",
        value: function _buttonTap(e) {
          e.preventDefault();
          if (this.command === "formatBlock") this.setRange();
          this.execCommand();
        }
        /**
         * fires when command value changes
         * @event command-val-changed
         */

      }, {
        key: "_commandValChanged",
        value: function _commandValChanged() {
          this.dispatchEvent(new CustomEvent("command-val-changed", {
            bubbles: true,
            cancelable: true,
            composed: true,
            detail: this
          }));
        }
        /**
         * gets appplicable selection
         * @returns {*}
         */

      }, {
        key: "_getSelection",
        value: function _getSelection() {
          return this.command === "formatBlock" ? this._getSelectedBlock() : this._getSelectedHtml();
        }
        /**
         * gets appplicable selection
         * @returns {*}
         */

      }, {
        key: "_getSelectionType",
        value: function _getSelectionType() {
          return this.command === "formatBlock" ? this._getSelectedTag() : this._getSelectedHtml();
        }
        /**
         * get selection's parent block
         * @returns {object}
         */

      }, {
        key: "_getSelectedBlock",
        value: function _getSelectedBlock() {
          var selector = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.blockSelectors;
          console.log("_getSelectedBlock", this.range, !this.range || !this.range.cloneContents() || this.range.cloneContents().childNodes, !this.range || this.range.commonAncestorContainer.childNodes);
          var children = this.range && this.range.cloneContents() ? this.range.cloneContents().childNodes : false,
              tagNames = selector && selector !== "" ? selector.split(",") : false;
          console.log("_getSelectedBlock 1", children, tagNames);

          if (tagNames && children && children.length === 1 && children[0].tagName && tagNames.includes(children[0].tagName.toLowerCase())) {
            var start = this.range.startContainer;
            console.log("_getSelectedBlock 1a", start, start.childNodes[this.range.startOffset]);
            return start.childNodes[this.range.startOffset];
          } else if (this.range) {
            var node = this.range.commonAncestorContainer,
                closest = node.nodeType === 1 ? node.closest(selector) : node.parentNode.nodeType === 1 ? node.parentNode.closest(selector) : undefined;
            console.log("_getSelectedBlock 2", this.range, node, closest);
            return closest;
          }

          return undefined;
        }
        /**
         * gets selected html
         * @returns {string}
         */

      }, {
        key: "_getSelectedHtml",
        value: function _getSelectedHtml() {
          if (this.range) {
            var div = document.createElement("div"),
                contents = this.range.cloneContents(),
                val;
            div.appendChild(contents);
            val = div.innerHTML;
            div.remove();
            return val ? val.trim() : undefined;
          }

          return undefined;
        }
        /**
         * get selection's parent block
         *
         * @returns
         */

      }, {
        key: "_getSelectedTag",
        value: function _getSelectedTag() {
          var block = this._getSelectedBlock(),
              tag = !!block && !!block.tagName ? block.tagName.toLowerCase() : false;

          return tag;
        }
        /**
         * Handles editor change
         * @param {string} newVal the new editor's id
         * @param {string} oldVal the old editor's id
         * @returns {void}
         */

      }, {
        key: "_editorChanged",
        value: function _editorChanged(newVal, oldVal) {
          this.dispatchEvent(new CustomEvent(this.command + "-button-editor-change", {
            bubbles: true,
            cancelable: true,
            composed: true,
            detail: this
          }));
        }
        /**
         * Handles keys the same way a button is handled
         * @param {event} e the  event
         */

      }, {
        key: "_keysPressed",
        value: function _keysPressed(e) {
          e.preventDefault();

          this._buttonTap(e);
        }
        /**
         * handles range changes by getting
         * @event range-changed
         */

      }, {
        key: "_rangeChanged",
        value: function _rangeChanged() {
          this.dispatchEvent(new CustomEvent("range-changed", {
            bubbles: true,
            cancelable: true,
            composed: true,
            detail: this
          }));
        }
        /**
         * updates a button value based on whether or not button is toggled
         *
         * @param {string} the value when toggled off
         * @param {string} the value when toggled on
         * @param {boolean} whether the button is toggled
         * @returns {string} the correct value based on
         * whether or not the button is toggled
         */

      }, {
        key: "_regOrToggled",
        value: function _regOrToggled(toggledOff, toggledOn, toggled) {
          return !!toggledOn && toggled ? toggledOn : toggledOff;
        }
        /**
         * fires when toggled command value changes
         * @event toggled-command-val-changed
         */

      }, {
        key: "_toggledCommandValChanged",
        value: function _toggledCommandValChanged() {
          this.dispatchEvent(new CustomEvent("toggled-command-val-changed", {
            bubbles: true,
            cancelable: true,
            composed: true,
            detail: this
          }));
        }
      }, {
        key: "blockSelectors",
        get: function get() {
          return "p,h1,h2,h3,h4,h5,h6,div,address,blockquote,pre";
        }
        /**
         * current label based on toggled state
         *
         * @readonly
         * @memberof RichTextEditorButton
         */

      }, {
        key: "currentLabel",
        get: function get() {
          return this._regOrToggled(this.label, this.toggledLabel, this.isToggled);
        }
        /**
         * current icon based on toggled state
         *
         * @readonly
         * @memberof RichTextEditorButton
         */

      }, {
        key: "currentIcon",
        get: function get() {
          return this._regOrToggled(this.icon, this.toggledIcon, this.isToggled);
        }
        /**
         * label is offscreen (screenreader-only)
         *
         * @readonly
         * @memberof RichTextEditorButton
         */

      }, {
        key: "labelStyle",
        get: function get() {
          return !!this.icon && this.icon !== "" && this.showTextLabel === false ? "offscreen" : null;
        }
        /**
         * whether button is toggled
         *
         * @readonly
         * @memberof RichTextEditorButton
         */

      }, {
        key: "isToggled",
        get: function get() {
          var command = !!this.range && !!this.command ? document.queryCommandState(this.command) : false,

          /* workaround because queryCommandState("underline") returns true on links */
          block = this.command === "underline" ? this._getSelectedBlock("u") !== null : command;
          return !!this.range && this.toggles && !!block ? true : false;
        }
        /**
         * gets valid commands list
         *
         * @readonly
         * @memberof RichTextEditorButton
         */

      }, {
        key: "validCommands",
        get: function get() {
          return ["backColor", "bold", "createLink", "copy", "cut", "defaultParagraphSeparator", "delete", "fontName", "fontSize", "foreColor", "formatBlock", "forwardDelete", "insertHorizontalRule", "insertHTML", "insertImage", "insertLineBreak", "insertOrderedList", "insertParagraph", "insertText", "insertUnorderedList", "justifyCenter", "justifyFull", "justifyLeft", "justifyRight", "outdent", "paste", "redo", "selectAll", "strikethrough", "styleWithCss", "superscript", "undo", "unlink", "useCSS"];
        }
      }, {
        key: "operationCommand",
        get: function get() {
          return this.isToggled && !!this.toggledCommand ? this.toggledCommand : this.command;
        }
        /**
         * gets value param for document.execCommand
         *
         * @readonly
         */

      }, {
        key: "operationCommandVal",
        get: function get() {
          return this.isToggled && !!this.toggledCommand ? this.toggledCommandVal || "" : this.commandVal;
        }
      }]);
      return _class;
    }((0, _richTextEditorButtonStyles.RichTextEditorButtonStyles)(SuperClass));
  };
  /**
   * `rich-text-editor-button`
   * a button for rich text editor (custom buttons can extend this)
   *
   * @element rich-text-editor-button
   * @demo ./demo/buttons.html
   */


  _exports.RichTextEditorButtonBehaviors = RichTextEditorButtonBehaviors;

  var RichTextEditorButton = /*#__PURE__*/function (_RichTextEditorButton2) {
    babelHelpers.inherits(RichTextEditorButton, _RichTextEditorButton2);

    var _super2 = _createSuper(RichTextEditorButton);

    function RichTextEditorButton() {
      babelHelpers.classCallCheck(this, RichTextEditorButton);
      return _super2.apply(this, arguments);
    }

    return RichTextEditorButton;
  }(RichTextEditorButtonBehaviors(_litElement.LitElement));

  _exports.RichTextEditorButton = RichTextEditorButton;
  window.customElements.define(RichTextEditorButton.tag, RichTextEditorButton);
});