define(["exports", "require", "../../lit-element/lit-element.js", "../../@polymer/iron-ajax/iron-ajax.js"], function (_exports, _require, _litElement, _ironAjax) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.WikipediaQuery = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject3_c53d8d8001a111ebb416cb2b1003c1c5() {
    var data = babelHelpers.taggedTemplateLiteral(["\n            <iron-ajax\n              auto\n              url=\"https://en.wikipedia.org/w/api.php?origin=*&amp;action=query&amp;titles=", "&amp;prop=extracts&amp;format=json\"\n              handle-as=\"json\"\n              @response=\"", "\"\n              debounce-duration=\"25\"\n              @last-response-changed=\"", "\"\n            ></iron-ajax>\n            <h3 .hidden=\"", "\">", "</h3>\n            <div id=\"result\"></div>\n            <citation-element\n              creator=\"{Wikipedia contributors}\"\n              scope=\"sibling\"\n              license=\"by-sa\"\n              title=\"", " --- {Wikipedia}{,} The Free Encyclopedia\"\n              source=\"https://en.wikipedia.org/w/index.php?title=", "\"\n              date=\"", "\"\n            ></citation-element>\n          "]);

    _templateObject3_c53d8d8001a111ebb416cb2b1003c1c5 = function _templateObject3_c53d8d8001a111ebb416cb2b1003c1c5() {
      return data;
    };

    return data;
  }

  function _templateObject2_c53d8d8001a111ebb416cb2b1003c1c5() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      ", "\n    "]);

    _templateObject2_c53d8d8001a111ebb416cb2b1003c1c5 = function _templateObject2_c53d8d8001a111ebb416cb2b1003c1c5() {
      return data;
    };

    return data;
  }

  function _templateObject_c53d8d8001a111ebb416cb2b1003c1c5() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n          --wikipedia-query-body-height: 160px;\n        }\n        :host [hidden] {\n          display: none;\n        }\n        #result {\n          height: var(--wikipedia-query-body-height);\n          overflow: scroll;\n          border: 1px grey solid;\n          padding: 8px 16px;\n        }\n        citation-element {\n          background-color: #f8f8f8;\n          padding: 16px 8px;\n          font-size: 12px;\n        }\n      "]);

    _templateObject_c53d8d8001a111ebb416cb2b1003c1c5 = function _templateObject_c53d8d8001a111ebb416cb2b1003c1c5() {
      return data;
    };

    return data;
  }

  function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = babelHelpers.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = babelHelpers.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return babelHelpers.possibleConstructorReturn(this, result); }; }

  function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

  /**
   * `wikipedia-query`
   * `Query and present information from wikipedia.`
   * @demo demo/index.html
   * @element wikipedia-query
   */
  var WikipediaQuery = /*#__PURE__*/function (_LitElement) {
    babelHelpers.inherits(WikipediaQuery, _LitElement);

    var _super = _createSuper(WikipediaQuery);

    babelHelpers.createClass(WikipediaQuery, null, [{
      key: "styles",

      /**
       * LitElement constructable styles enhancement
       */
      get: function get() {
        return [(0, _litElement.css)(_templateObject_c53d8d8001a111ebb416cb2b1003c1c5())];
      }
    }]);

    function WikipediaQuery() {
      var _this;

      babelHelpers.classCallCheck(this, WikipediaQuery);
      _this = _super.call(this);
      _this.hideTitle = false;
      var date = new Date(Date.now());
      _this.__now = date.getDate() + "/" + (date.getMonth() + 1) + "/" + date.getFullYear();
      setTimeout(function () {
        new Promise(function (res, rej) {
          return _require.default(["../citation-element/citation-element.js"], res, rej);
        });
      }, 0);
      return _this;
    }
    /**
     * Store the tag name to make it easier to obtain directly.
     * @notice function name must be here for tooling to operate correctly
     */


    babelHelpers.createClass(WikipediaQuery, [{
      key: "render",
      // LitElement render function
      value: function render() {
        return (0, _litElement.html)(_templateObject2_c53d8d8001a111ebb416cb2b1003c1c5(), this.search ? (0, _litElement.html)(_templateObject3_c53d8d8001a111ebb416cb2b1003c1c5(), this.search, this.handleResponse, this.searchResponseChanged, this.hideTitle, this._title, this.search, this.search, this.__now) : "");
      }
    }, {
      key: "searchResponseChanged",
      value: function searchResponseChanged(e) {
        this.searchResponse = e.detail.value;
      }
      /**
       * LitElement properties updated
       */

    }, {
      key: "updated",
      value: function updated(changedProperties) {
        var _this2 = this;

        changedProperties.forEach(function (oldValue, propName) {
          if (propName == "search") {
            if (_this2.title) {
              _this2._title = _this2.title;
            } else {
              _this2._title = _this2[propName].replace("_", " ") + " Wikipedia article";
            }
          }

          if (propName == "title") {
            if (_this2.title) {
              _this2._title = _this2.title;
            }
          }
        });
      }
    }, {
      key: "handleResponse",

      /**
       * Process response from wikipedia.
       */
      value: function handleResponse(response) {
        // the key of pages is a number so need to look for it
        if (babelHelpers.typeof(this.searchResponse) !== (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined)) && this.searchResponse.query) {
          for (var key in this.searchResponse.query.pages) {
            // skip anything that's prototype object
            if (!this.searchResponse.query.pages.hasOwnProperty(key)) continue; // load object response, double check we have an extract

            if (this.searchResponse.query.pages[key].extract) {
              var _html = this.searchResponse.query.pages[key].extract;
              _html = _html.replace(/<script[\s\S]*?>/gi, "&lt;script&gt;");
              _html = _html.replace(/<\/script>/gi, "&lt;/script&gt;");
              _html = _html.replace(/<style[\s\S]*?>/gi, "&lt;style&gt;");
              _html = _html.replace(/<\/style>/gi, "&lt;/style&gt;"); // need to innerHTML this or it won't set

              this.shadowRoot.querySelector("#result").innerHTML = _html;
            }
          }
        }
      }
    }], [{
      key: "tag",
      get: function get() {
        return "wikipedia-query";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          title: {
            type: String
          },
          __now: {
            type: String
          },
          _title: {
            type: String
          },

          /**
           * hideTitle
           */
          hideTitle: {
            type: Boolean,
            attribute: "hide-title"
          },

          /**
           * Search string.
           */
          search: {
            type: String
          }
        };
      }
      /**
       * HAXproperties
       */

    }, {
      key: "haxProperties",
      get: function get() {
        return {
          canScale: true,
          canPosition: true,
          canEditSource: false,
          gizmo: {
            title: "Wikipedia article",
            description: "This can display a wikipedia article in context in a variety of formats.",
            icon: "book",
            color: "green",
            groups: ["Content", "Creative Commons"],
            handles: [{
              type: "wikipedia",
              type_exclusive: true,
              title: "search"
            }, {
              type: "content",
              title: "search"
            }],
            meta: {
              author: "ELMS:LN"
            }
          },
          settings: {
            quick: [{
              property: "search",
              title: "Search term",
              description: "Word to search wikipedia for.",
              inputMethod: "textfield",
              icon: "editor:title",
              required: true
            }, {
              property: "hideTitle",
              title: "Hide title",
              description: "Whether or not to render the title of the article.",
              inputMethod: "boolean",
              icon: "editor:title"
            }],
            configure: [{
              property: "search",
              title: "Article name",
              description: "Word to search wikipedia for.",
              inputMethod: "textfield",
              icon: "editor:title",
              required: true
            }, {
              property: "hideTitle",
              title: "Hide title",
              description: "Whether or not to render the title of the article.",
              inputMethod: "boolean",
              icon: "editor:title"
            }]
          },
          saveOptions: {
            wipeSlot: true,
            unsetAttributes: ["_title"]
          },
          demoSchema: [{
            tag: "wikipedia-query",
            properties: {
              hideTitle: false,
              search: "Internet"
            },
            content: ""
          }]
        };
      }
    }]);
    return WikipediaQuery;
  }(_litElement.LitElement);

  _exports.WikipediaQuery = WikipediaQuery;
  window.customElements.define(WikipediaQuery.tag, WikipediaQuery);
});