define(["exports", "../../../../@polymer/polymer/polymer-element.js", "../../../../@polymer/marked-element/marked-element.js"], function (_exports, _polymerElement, _markedElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrnappStudioAssignmentDisplay = void 0;

  class LrnappStudioAssignmentDisplay extends _polymerElement.PolymerElement {
    static get template() {
      return (0, _polymerElement.html)`
      <style>
        :host {
          display: block;
          padding: 16px;
        }
        #assignment-body {
          font-size: 21px;
        }
      </style>
      <h1>[[assignment.attributes.title]]</h1>
      <marked-element
        id="assignment-body"
        markdown="[[assignment.attributes.body]]"
      ></marked-element>
    `;
    }

    static get tag() {
      return "lrnapp-studio-assignment-display";
    }

    static get properties() {
      return {
        elmslnCourse: {
          type: String
        },
        elmslnSection: {
          type: String
        },
        basePath: {
          type: String
        },
        csrfToken: {
          type: String
        },
        endPoint: {
          type: String
        },
        assignment: {
          type: Object
        }
      };
    }

  }

  _exports.LrnappStudioAssignmentDisplay = LrnappStudioAssignmentDisplay;
  window.customElements.define(LrnappStudioAssignmentDisplay.tag, LrnappStudioAssignmentDisplay);
});