define(["exports", "../../../../@polymer/polymer/polymer-element.js", "../../../../@polymer/paper-button/paper-button.js", "../../../../@polymer/iron-icon/iron-icon.js", "../../../../@polymer/paper-ripple/paper-ripple.js"], function (_exports, _polymerElement, _paperButton, _ironIcon, _paperRipple) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrnappStudioSubmissionEditAddAsset = void 0;

  class LrnappStudioSubmissionEditAddAsset extends _polymerElement.PolymerElement {
    static get template() {
      return (0, _polymerElement.html)`
      <style>
        :host {
          cursor: pointer;
        }
        :host([display="box"]) {
          display: block;
          width: 200px;
          height: 200px;
          background: lightgray;
          display: flex;
          align-items: center;
          justify-content: center;
          position: relative;
        }
        :host([display="pill"]) {
          display: block;
          background: lightgray;
          display: inline-flex;
          align-items: center;
          justify-content: center;
          position: relative;
        }
        iron-icon {
          color: gray;
          --iron-icon-height: 50px;
          --iron-icon-width: 50px;
        }
        :host([display="pill"]) iron-icon {
          --iron-icon-height: 50px;
          --iron-icon-width: 50px;
        }
      </style>
      <paper-button>
        <iron-icon icon="[[icon]]"></iron-icon>
        <paper-ripple></paper-ripple>
      </paper-button>
    `;
    }

    static get tag() {
      return "lrnapp-studio-submission-edit-add-asset";
    }

    static get properties() {
      return {
        icon: {
          type: String,
          value: "add"
        },

        /**
         * Change the display of the add asset element
         *
         * @type String Options: 'box', 'pill'
         */
        display: {
          type: String,
          value: "box",
          reflectToAttribute: true
        }
      };
    }

  }

  _exports.LrnappStudioSubmissionEditAddAsset = LrnappStudioSubmissionEditAddAsset;
  window.customElements.define(LrnappStudioSubmissionEditAddAsset.tag, LrnappStudioSubmissionEditAddAsset);
});