define(["exports", "require", "../../../../../lit-element/lit-element.js", "../../core/haxcms-site-store.js", "../../../../../mobx/lib/mobx.module.js", "../../../../../@polymer/polymer/lib/elements/custom-style.js"], function (_exports, _require, _litElement, _haxcmsSiteStore, _mobxModule, _customStyle) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.SiteTitle = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  /**
   * Copyright 2019 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   */

  /**
   * @deprecatedApply - required for @apply / invoking @apply css var convention
   */

  /**
   * `site-title`
   * `Title of the site`
   *
  
   * @demo demo/index.html
   */
  class SiteTitle extends _litElement.LitElement {
    /**
     * LitElement constructable styles enhancement
     */
    static get styles() {
      return [(0, _litElement.css)`
        :host {
          display: block;
          text-rendering: optimizelegibility;
          position: relative;
        }
      `];
    }
    /**
     * Store the tag name to make it easier to obtain directly.
     */


    static get tag() {
      return "site-title";
    }

    constructor() {
      super();
      this.__disposer = [];
      this.label = "Home";
      this.notitle = false;
      new Promise((res, rej) => _require.default(["../../../../../@polymer/iron-icon/iron-icon.js"], res, rej));
      (0, _mobxModule.autorun)(reaction => {
        this.siteTitle = (0, _mobxModule.toJS)(_haxcmsSiteStore.store.siteTitle);

        this.__disposer.push(reaction);
      });
      (0, _mobxModule.autorun)(reaction => {
        this.homeLink = (0, _mobxModule.toJS)(_haxcmsSiteStore.store.homeLink);

        this.__disposer.push(reaction);
      });
    }
    /**
     * LitElement
     */


    render() {
      return (0, _litElement.html)`
      <custom-style>
        <style>
          a {
            @apply --site-title-link;
          }
          a:hover,
          a:focus,
          a:active {
            @apply --site-title-link-hover;
          }
          a h1 {
            text-rendering: optimizelegibility;
            @apply --site-title-heading;
          }
          iron-icon {
            @apply --site-title-icon;
          }
        </style>
      </custom-style>
      <a
        href="${this.homeLink}"
        title="${this.label}"
        ?disabled="${this.disabled}"
      >
        <iron-icon
          ?hidden="${this.icon ? false : true}"
          icon="${this.icon}"
        ></iron-icon>
        ${this.notitle ? (0, _litElement.html)`` : (0, _litElement.html)` <h1>${this.siteTitle}</h1> `}
      </a>
    `;
    }
    /**
     * Props
     */


    static get properties() {
      return {
        disabled: {
          type: Boolean,
          reflect: true
        },

        /**
         * Site title
         */
        siteTitle: {
          type: String,
          attribute: "site-title"
        },

        /**
         * HREF to the home page
         */
        homeLink: {
          type: String,
          attribute: "home-link"
        },

        /**
         * Label
         */
        label: {
          type: String
        },

        /**
         * optional icon
         */
        icon: {
          type: String
        },

        /**
         * If the title should be displayed or not
         */
        notitle: {
          type: Boolean,
          reflect: true
        }
      };
    }

    disconnectedCallback() {
      for (var i in this.__disposer) {
        this.__disposer[i].dispose();
      }

      super.disconnectedCallback();
    }

  }

  _exports.SiteTitle = SiteTitle;
  window.customElements.define(SiteTitle.tag, SiteTitle);
});