define(["exports", "./lib/MutationObserverImportMixin.js"], function (_exports, _MutationObserverImportMixin) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.MutationObserverImportElement = void 0;

  /**
   * Copyright 2020 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   */

  /**
   * `mutation-observer-import-mixin`
   * `a SuperClass mixin that dynamically imports undefined custom element definitions`
   * @demo demo/index.html
   * @element mutation-observer-import-mixin
   */
  class MutationObserverImportElement extends (0, _MutationObserverImportMixin.MutationObserverImportMixin)(HTMLElement) {
    static get tag() {
      return "mutation-observer-import";
    }

    connectedCallback() {
      super.connectedCallback();
      this.processElementList(this.children);
    }

  }

  _exports.MutationObserverImportElement = MutationObserverImportElement;
  customElements.define(MutationObserverImportElement.tag, MutationObserverImportElement);
});