import{LitElement as e,html as t,css as i}from"../../../lit-element/lit-element.js";import{A11yCollapse as o}from"../a11y-collapse.js";class A11yCollapseGroup extends e{static get styles(){return[i`
        :host {
          display: block;
          margin: var(--a11y-collapse-group-margin, 15px 0);
          --a11y-collapse-margin: 15px;
        }
        :host([hidden]) {
          display: none;
        }
        #heading {
          font-weight: bold;
        }
        .wrapper {
          border-radius: 0;
          --a11y-collapse-margin: 0 0;
          --a11y-collapse-border-between: none;
        }
      `]}render(){return t` <div class="wrapper"><slot></slot></div> `}constructor(){super(),this.globalOptions={},this.radio=!1,this.__items=[],this.addEventListener("a11y-collapse-attached",e=>{e.stopPropagation(),e.stopImmediatePropagation(),this._attachItem(e.detail)}),this.addEventListener("a11y-collapse-detached",e=>{e.stopPropagation(),e.stopImmediatePropagation(),this._detachItem(e.detail)}),this.addEventListener("a11y-collapse-click",e=>{e.stopPropagation(),e.stopImmediatePropagation(),this.radioToggle(e.detail)}),this.addEventListener("toggle",e=>{e.stopPropagation(),e.stopImmediatePropagation(),this.radioToggle(e.detail)})}static get tag(){return"a11y-collapse-group"}static get properties(){return{...super.properties,...o.properties,globalOptions:{type:Object,attribute:"global-options",reflect:!0},radio:{type:Boolean,attribute:"radio"},__items:{type:Array}}}static get haxProperties(){return{canScale:!1,canPosition:!0,canEditSource:!1,gizmo:{title:"Expand Collapse Group",description:"A group of expand collapse elements.",icon:"view-day",color:"grey",groups:["Content","Presentation","Collapse"]},settings:{quick:[{property:"radio",title:"Expand only one",description:"Only one item can be expanded.",inputMethod:"boolean"},{property:"disabled",title:"Disabled",description:"Disable items.",inputMethod:"boolean"}],configure:[{property:"radio",title:"Expand only one",description:"Only one item can be expanded.",inputMethod:"boolean"},{property:"disabled",title:"Disabled",description:"Disable items.",inputMethod:"boolean"},{slot:"",title:"Collapse Items",description:"The collapse items.",inputMethod:"code-editor"}],advanced:[{property:"hidden",title:"Hidden",inputMethod:"boolean"}]}}}get items(){return this.__items}_attachItem(e){this.__items.push(e),Object.keys(A11yCollapseGroup.properties||{}).forEach(t=>this._updateItem(e,t))}updated(e){e.forEach((e,t)=>{this.__items.forEach(i=>this._updateItem(i,t,e))})}_updateItem(e,t,i){if("globalOptions"===t||"__items"===t){if(this.globalOptions!=={})for(let t in this.globalOptions)this.globalOptions.hasOwnProperty(t)&&(e[t]=this.globalOptions[t])}else"radio"===t&&this.radio?e.expanded=!1:null===this[t]&&void 0===this[t]||(e[t]=this[t])}_detachItem(e){if(this.__items&&e)for(let t=0;t<this.__items.length;t++)this.__items[t]===e&&this.__items.splice(t,1)}radioToggle(e){if(this.radio&&e.expanded)for(let t=0;t<this.__items.length;t++)this.__items[t]!==e&&this.__items[t].toggle(!1)}disconnectedCallback(){this.removeEventListener("a11y-collapse-click",e=>{e.stopPropagation(),this.radioToggle(e.detail)}),this.removeEventListener("a11y-collapse-attached",e=>{e.stopPropagation(),this.push("__items",e.detail)}),this.removeEventListener("a11y-collapse-detached",e=>{e.stopPropagation(),this._detachItem(e.detail)}),super.disconnectedCallback()}}window.customElements.define(A11yCollapseGroup.tag,A11yCollapseGroup);export{A11yCollapseGroup};