/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as a,css as e}from"../../lit-element/lit-element.js";import{ResponsiveUtilityBehaviors as o}from"../responsive-utility/lib/responsive-utility-behaviors.js";import"../../@polymer/paper-button/paper-button.js";import"../../@polymer/iron-icons/iron-icons.js";import"../simple-tooltip/simple-tooltip.js";import"./lib/a11y-tab.js";class A11yTabs extends(o(t)){static get styles(){return[e`
        :host {
          display: block;
          height: var(--a11y-tabs-height);
          overflow: var(--a11y-tabs-overflow);
          font-size: var(--a11y-tabs-font-size, unset);
          font-family: var(--a11y-tabs-font-family, unset);
          --a11y-tabs-width: 100%;
          --a11y-tabs-background: white;
          --a11y-tabs-border-color: #ddd;
          --a11y-tabs-color: #000;
          --a11y-tabs-faded-color: #333;
          --a11y-tabs-focus-color: var(-a11y-tabs-color);
          --a11y-tabs-faded-background: #f8f8f8;
          --a11y-tabs-disabled-color: #999;
          --a11y-tabs-disabled-background: #eee;
          --a11y-tabs-border-radius: 2px;
          --a11y-tabs-horizontal-background: var(--a11y-tabs-background, white);
          --a11y-tabs-horizontal-border-radius: var(
            --a11y-tabs-border-radius,
            2px
          );
          --a11y-tabs-vertical-border-radius: var(
            --a11y-tabs-border-radius,
            2px
          );
          --a11y-tabs-content-background: var(--a11y-tabs-background, white);
          --a11y-tabs-content-padding: 16px;
          --a11y-tabs-button-padding: 8px;
          --a11y-tabs-vertical-button-padding: var(
            --a11y-tabs-button-padding,
            8px
          );
          --a11y-tabs-horizontal-border-radius: unset;
          --a11y-tabs-vertical-border-radius: unset;
          --a11y-tabs-horizontal-button-padding: var(
            --a11y-tabs-button-padding,
            8px
          );
          --a11y-tabs-width: auto;
        }

        :host([vertical]) {
          border: 1px solid var(--a11y-tabs-border-color);
          border-radius: var(--a11y-tabs-vertical-border-radius);
          display: flex;
          justify-content: space-between;
          align-items: stretch;
        }

        :host([hidden]) {
          display: none;
        }

        :host #tabs {
          align-items: stretch;
          flex-wrap: var(--a11y-tabs-wrap, unset);
          margin: 0;
          display: flex;
          list-style: none;
          padding: 0;
          overflow: auto;
          max-width: 100%;
          overflow-x: auto;
          z-index: 1;
          justify-content: var(--a11y-tabs-horizontal-justify-tabs);
          background-color: var(--a11y-tabs-horizontal-background);
          font-family: var(
            --a11y-tabs-tab-font-family,
            var(--a11y-tabs-font-family, unset)
          );
          font-size: var(
            --a11y-tabs-tab-font-size,
            var(--a11y-tabs-font-size, unset)
          );
        }

        :host([vertical]) #tabs {
          border-left: none;
          flex: 0 0 auto;
          flex-direction: column;
          overflow-y: auto;
          max-width: unset;
          overflow-x: unset;
          z-index: unset;
          background-color: var(--a11y-tabs-vertical-background);
          justify-content: var(--a11y-tabs-vertical-justify-tabs);
          flex-wrap: var(--a11y-tabs-vertical-wrap);
        }

        :host([sticky]) #tabs {
          position: sticky;
          top: 0;
        }

        :host #tabs li {
          display: flex;
          align-items: stretch;
        }

        :host([vertical]) #tabs li {
          flex-direction: column;
        }

        :host #tabs .flag-type {
          position: absolute;
          left: -99999px;
          height: 0;
          overflow: hidden;
        }

        :host #content {
          padding: var(--a11y-tabs-content-padding);
          background-color: var(--a11y-tabs-content-background);
          border: 1px solid var(--a11y-tabs-border-color);
          flex: 1 1 calc(100% - 2 * var(--a11y-tabs-content-padding));
          overflow: auto;
        }

        :host([vertical]) #content {
          border: none;
        }

        :host(:not([vertical])) #content {
          border-radius: var(--a11y-tabs-horizontal-border-radius);
          margin-top: -1px;
        }

        :host #tabs paper-button {
          margin: 0;
          text-transform: unset;
          color: var(--a11y-tabs-faded-color);
          border: 1px solid var(--a11y-tabs-border-color);
          background-color: var(--a11y-tabs-faded-background);
          padding: var(--a11y-tabs-horizontal-button-padding);
          border-radius: var(--a11y-tabs-horizontal-border-radius)
            var(--a11y-tabs-horizontal-border-radius) 0 0;
        }

        :host([vertical]) #tabs paper-button {
          border-top: none;
          border-left: none;
          border-radius: 0;
          display: flex;
          justify-content: space-between;
          align-items: center;
          padding: var(--a11y-tabs-vertical-button-padding);
        }

        :host(:not([vertical])) #tabs li:not(:first-of-type) paper-button {
          border-left: none;
        }

        :host #tabs paper-button:active,
        :host #tabs paper-button:focus,
        :host #tabs paper-button:hover {
          color: var(--a11y-tabs-focus-color);
        }

        :host #tabs paper-button.active[disabled] {
          color: var(--a11y-tabs-focus-color);
          background-color: var(--a11y-tabs-background);
        }

        :host(:not([vertical])) #tabs paper-button.active {
          border-bottom: var(--a11y-tabs-background);
        }

        :host([vertical]) #tabs paper-button.active {
          border-right: var(--a11y-tabs-background);
        }

        :host #tabs paper-button:not(.active)[disabled] {
          color: var(--a11y-tabs-disabled-color);
          background-color: var(--a11y-tabs-disabled-background);
          cursor: not-allowed;
        }

        :host #tabs span.label,
        :host #tabs .flag-icon {
          margin-right: 8px;
        }

        :host([icons-only]) #tabs paper-button {
          justify-content: center;
        }

        :host([icons-only]) #tabs span.label {
          display: none;
        }

        :host(:not([icons-only])) #tabs #tabs simple-tooltip {
          display: none;
        }

        iron-icon:not([hidden]) {
          display: inline-block;
        }
      `]}render(){return a` <ul id="tabs">
        ${this.tabs.map((t,e)=>a` <li>${this._tabButton(t)}</li> `)}
      </ul>
      <div id="content">
        <slot></slot>
      </div>`}static get haxProperties(){return{canScale:!1,canPosition:!0,canEditSource:!1,gizmo:{title:"Tabs",description:"A set of tabs.",icon:"view-day",color:"grey",groups:["Content","Presentation","Tabs"]},settings:{quick:[{property:"disabled",title:"Disabled",inputMethod:"boolean"},{property:"hidden",title:"Hidden",inputMethod:"boolean"},{property:"sticky",title:"Sticky",desc:"Horizontal tabs stick to the top of the window when scrolling.",inputMethod:"boolean"}],configure:[{property:"disabled",title:"Disabled",inputMethod:"boolean"},{property:"hidden",title:"Hidden",inputMethod:"boolean"},{property:"sticky",title:"Sticky.",desc:"Horizontal tabs stick to the top of the window when scrolling.",inputMethod:"boolean"},{property:"layoutBreakpoint",title:"Layout Breakpoint",inputMethod:"Number",descripton:"Optional minimum breakpoint for horizontal layout of tabs. Default is unset (always horizontal). Setting `-1` forces vertical-only mode."},{property:"iconBreakpoint",title:"Icon Breakpoint",inputMethod:"Number",descripton:"Optional minimum breakpoint for showing tab text with icons. Default is always text with icons (0). Setting to -1 forces icon-only mode."},{slot:"",title:"Tabs",description:"A series of <a11y-tab/> elements.",inputMethod:"code-editor"}],advanced:[{property:"id",title:"Unique ID",inputMethod:"textfield"}]}}}static get properties(){return{...super.properties,activeTab:{type:String,reflect:!0,attribute:"active-tab"},disabled:{type:Boolean,reflect:!0,attribute:"disabled"},hidden:{type:Boolean,reflect:!0,attribute:"hidden"},iconBreakpoint:{type:Number,attribute:"icon-breakpoint"},id:{type:String,reflect:!0},layoutBreakpoint:{type:Number,attribute:"layout-breakpoint"},responsiveSize:{type:String,reflect:!0,attribute:"responsive-size"},sticky:{type:Boolean,reflect:!0,attribute:"sticky"},__tabs:{type:Array}}}static get tag(){return"a11y-tabs"}constructor(){super(),this.disabled=!1,this.hidden=!1,this.__tabs=[]}get iconsOnly(){return this.iconBreakpoint&&(this.tabs||[]).filter(t=>!t.icon).length<1&&this.responsiveWidth<this.iconBreakpoint}get observer(){return new MutationObserver(()=>this.updateTabs())}get tabQuery(){return"a11y-tab"}get tabs(){return Object.keys(this.__tabs||{}).map(t=>(this.__tabs[t].order=t+1,this.__tabs[t].total=this.__tabs.length,this.__tabs[t]))}get vertical(){return this.layoutBreakpoint&&this.layoutBreakpoint<this.responsiveWidth}connectedCallback(){super.connectedCallback(),this.updateTabs(),this.observer.observe(this,{attributes:!1,childList:!0,subtree:!1}),this.addEventListener("a11y-tab-changed",t=>this.updateTabs())}disconnectedCallback(){this.observer&&this.observer.disconnect&&this.observer.disconnect(),this.removeEventListener("a11y-tab-changed",t=>this.updateTabs()),super.disconnectedCallback()}firstUpdated(){super.firstUpdated()&&super.firstUpdated(),window.ResponsiveUtility.requestAvailability(),window.dispatchEvent(new CustomEvent("responsive-element",{detail:{element:this}}))}updated(t){t.forEach((t,a)=>{"id"===a&&this._idChanged(this.id,t),"activeTab"===a&&this.activeTab!==t&&this._activeTabChanged(this.activeTab,t),"responsiveWidth"===a&&(this.vertical?this.setAttribute("vertical",!0):this.removeAttribute("vertical")),["iconsBreakpoint","responsiveWidth","__tabs"].includes(a)&&(this.iconsOnly?this.setAttribute("icons-only",!0):this.removeAttribute("icons-only"))})}selectTab(t){let a=this.querySelectorAll(this.tabQuery);if(a&&a.length>0){let e=Object.keys(a||[]).filter(t=>!a[t].disabled).map(t=>a[t].id),o=e.filter(a=>a===t)[0]||e[0];a.forEach(t=>{t.hidden=t.id!==o}),this.activeTab=o}}updateTabs(t){this.__tabs=this.querySelectorAll(this.tabQuery),this.selectTab(this.activeTab)}_activeTabChanged(t,a){t!==a&&this.selectTab(t),window.dispatchEvent(new CustomEvent("active-tab-changed",{bubbles:!0,cancelable:!0,composed:!0,detail:this}))}_generateUUID(){return"ss-s-s-s-sss".replace(/s/g,Math.floor(65536*(1+Math.random())).toString(16).substring(1))}_handleTab(t){t.disabled||(this.activeTab=t.id)}_idChanged(t,a){t||(this.id="a11y-tabs"+this._generateUUID())}_tabButton(t){return a`
      <paper-button
        id="${t.id}-button"
        controls="${t.id}"
        class="${t.id!==this.activeTab||this.disabled?"":"active"}"
        @click="${a=>this._handleTab(t)}"
        ?disabled="${t.id===this.activeTab||t.disabled||this.disabled}"
        .flag="${t.flag}"
      >
        ${this._tabIcon(t,"flagIcon")} ${this._tabLabel(t)}
        ${this._tabFlag(t)} ${this._tabIcon(t,"icon")}
      </paper-button>
      ${this._tabTooltip(t)}
    `}_tabFlag(t){return a`
      <span class="flag-type" ?hidden="${!t.flag}"> ${t.flag} </span>
    `}_tabIcon(t,e){return a`
      <iron-icon
        class="icon"
        ?hidden="${!t[e]}"
        .icon="${t[e]}"
        .title="${t[flag]}"
      >
      </iron-icon>
    `}_tabLabel(t){return a` <span class="label">${t.label}</span> `}_tabTooltip(t){return a`
      <simple-tooltip for="${t.id}-button"> ${t.label} </simple-tooltip>
    `}}window.customElements.define(A11yTabs.tag,A11yTabs);export{A11yTabs};