/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as e,css as i}from"../../../lit-element/lit-element.js";import"../../../@polymer/iron-icons/iron-icons.js";class A11yTab extends t{static get styles(){return[i`
        :host {
          display: block;
          height: var(--a11y-tabs-tab-height, --a11y-tabs-height);
          overflow: var(--a11y-tabs-tab-overflow, --a11y-tabs-overflow);
        }
        :host([hidden]) {
          display: none;
        }
        .sr-only {
          position: absolute;
          left: -99999px;
          height: 0;
          overflow: hidden;
        }
        #content-inner {
          max-width: 100%;
          overflow: auto;
        }
        ::slotted(*[slot="label"]) {
          display: none;
        }
      `]}render(){return e`
      <span class="sr-only">Tab ${this.xOfY}</span>
      <slot name="label"></slot>
      <div id="content-inner"><slot></slot></div>
      <span class="sr-only">
        End of tab ${this.xOfY}. Back to <a href="#${this.id}">tabs</a>.
      </span>
    `}static get haxProperties(){return{canScale:!1,canPosition:!0,canEditSource:!1,gizmo:{title:"Tab",description:"A single tab.",icon:"view-day",color:"grey",groups:["Content","Presentation","Tabs"]},settings:{quick:[{property:"disabled",title:"Disabled",inputMethod:"boolean"},{property:"sticky",title:"Sticky.",desc:"Horizontal tabs stick to the top of the window when scrolling.",inputMethod:"boolean"}],configure:[{property:"icon",title:"Tab Icon",inputMethod:"iconpicker"},{property:"disabled",title:"Disabled",inputMethod:"boolean"},{property:"label",title:"Tab Label",inputMethod:"textfield"},{slot:"",title:"Tab Content",description:"A content of the tab.",inputMethod:"code-editor"}],advanced:[{property:"id",title:"Unique ID",inputMethod:"textfield"},{property:"flag",title:"Optional Flag Text",inputMethod:"textfield"},{property:"flagIcon",title:"Optional Flag Icon",inputMethod:"iconpicker"}]}}}static get properties(){return{flag:{type:String,reflect:!0},flagIcon:{type:String,attribute:"flag-icon"},disabled:{type:Boolean,reflect:!0,attribute:"disabled"},hidden:{type:Boolean,reflect:!0,attribute:"hidden"},icon:{type:String},id:{type:String,reflect:!0,attribute:"id"},label:{type:String},order:{type:Number},total:{type:Number}}}constructor(){super(),this.disabled=!1,this.hidden=!1,this.order=1,this.total=1,this.addEventListener("a11y-tab-flag",t=>this.handleFlag(t))}get observer(){return new MutationObserver(t=>this._labelChanged())}get xOfY(){return`${this.order} of ${this.total}`}connectedCallback(){super.connectedCallback(),this._labelChanged(),this.observer.observe(this,{childList:!0})}disconnectedCallback(){this.observer.disconnect(),this.removeEventListener("a11y-tab-flag",t=>this.handleFlag(t)),this._fireTabChanged(),super.disconnectedCallback()}updated(t){t.forEach((t,e)=>{["id","order"].includes(e)&&!this.id&&(this.id="tab-"+this.order),["label","order"].includes(e)&&!this.label&&this._labelChanged(),"flag"===e&&this._fireTabChanged(),"flagIcon"===e&&this._fireTabChanged(),"icon"===e&&this._fireTabChanged(),"id"===e&&this._fireTabChanged(),"label"===e&&this._fireTabChanged(),"disabled"===e&&this.disabled&&this._fireTabChanged()})}static get tag(){return"a11y-tab"}_handleFlag(t){this.flag=t.detail.flag,this.flagIcon=t.detail.flagIcon}_labelChanged(){this.label&&""!==this.label.trim()||(this.label=this.querySelector('*[slot="label"]')?this.querySelector('*[slot="label"]').innerHTML:"Tab "+this.order)}_fireTabChanged(){this.dispatchEvent(new CustomEvent("a11y-tab-changed",{bubbles:!0,cancelable:!0,composed:!1,detail:this}))}}window.customElements.define(A11yTab.tag,A11yTab);export{A11yTab};