/**
 * Copyright 2020 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as s,html as t,css as e}from"../../lit-element/lit-element.js";import{router as i}from"../../lit-element-router/lit-element-router.js";import{ElmslnStudioUtilities as o}from"./lib/elmsln-studio-utilities.js";import{ElmslnStudioStyles as r}from"./lib/elmsln-studio-styles.js";import"../../@polymer/iron-ajax/iron-ajax.js";import"./lib/elmsln-studio-main.js";import"./lib/elmsln-studio-link.js";import"./lib/elmsln-studio-button.js";import"./lib/elmsln-studio-dashboard.js";import"./lib/elmsln-studio-submissions.js";import"./lib/elmsln-studio-assignments.js";import"./lib/elmsln-studio-portfolio.js";class ElmslnStudio extends(i(o(r(s)))){static get tag(){return"elmsln-studio"}render(){return t`
      <div id="studio-nav">
        <elmsln-studio-link ?active="${"dashboard"===this.route}" href="/"
          >Dashboard</elmsln-studio-link
        >
        <elmsln-studio-link
          ?active="${"submissions"===this.route||"portfolios"===this.route}"
          href="/submissions"
          >Submissions</elmsln-studio-link
        >
        <elmsln-studio-link
          ?active="${"assignments"===this.route}"
          href="/assignments"
          >Assignments</elmsln-studio-link
        >
        <elmsln-studio-link
          ?active="${"activity"===this.route}"
          href="/activity"
          >Activity Index</elmsln-studio-link
        >
      </div>
      <br />
      <elmsln-studio-main active-route="${this.route}">
        <elmsln-studio-dashboard
          ?demo-mode="${this.demoMode}"
          route="dashboard"
          .profile="${this.profile}"
          .activity="${this.activity}"
          route="dashboard"
        >
        </elmsln-studio-dashboard>
        <elmsln-studio-submissions
          ?demo-mode="${this.demoMode}"
          route="submissions"
          .submissions="${Object.keys(this.submissions||{}).map(s=>this.submissions[s])}"
          .comments="${Object.keys(this.discussion||{}).map(s=>this.discussion[s])}"
          ?grid="${this.query.grid||!1}"
          student-filter="${this.query.student||""}"
          assignment-filter="${this.query.assignment||""}"
          project-filter="${this.query.project||""}"
        >
        </elmsln-studio-submissions>
        <elmsln-studio-portfolio
          ?demo-mode="${this.demoMode}"
          route="portfolios"
          .portfolio="${this.portfolio}"
          .submission="${this.submissionFeedback}"
          ?sort-latest="${"latest"===this.query.sort}"
          submission-filter="${this.query.submission||""}"
          comment="${this.query.comment||""}"
        >
        </elmsln-studio-portfolio>
        <elmsln-studio-assignments
          ?demo-mode="${this.demoMode}"
          route="assignments"
          .lessons="${this.lessons||{}}"
          .profile="${this.profile||{}}"
        >
        </elmsln-studio-assignments>
      </elmsln-studio-main>
    `}static get properties(){return{...super.properties,activity:{type:Array},activitySource:{type:String,reflect:!0,attribute:"activity-source"},assignments:{type:Object},assignmentsSource:{type:String,reflect:!0,attribute:"assignments-source"},discussion:{type:Object},discussionSource:{type:String,reflect:!0,attribute:"discussion-source"},lessons:{type:Object},lessonsSource:{type:String,reflect:!0,attribute:"lessons-source"},portfolios:{type:Object},portfoliosSource:{type:String,reflect:!0,attribute:"portfolios-source"},profile:{type:Object},profileSource:{type:String,reflect:!0,attribute:"profile-source"},projects:{type:Array},projectsSource:{type:String,reflect:!0,attribute:"projects-source"},sourcePath:{type:String,reflect:!0,attribute:"source-path"},submissions:{type:Object},submissionsSource:{type:String,reflect:!0,attribute:"submissions-source"},users:{type:Object},usersSource:{type:String,reflect:!0,attribute:"users"},route:{type:String},params:{type:Object},query:{type:Object},data:{type:Object}}}static get routes(){return[{name:"assignments",pattern:"assignments"},{name:"submissions",pattern:"submissions"},{name:"portfolios",pattern:"portfolios/:portfolio"},{name:"dashboard",pattern:"*",data:{title:"Home"}}]}constructor(){super(),this.activity=[],this.assignments={},this.discussion={},this.lessons={},this.portfolios={},this.projects={},this.profile={},this.submissions={},this.users={},this.route="",this.params={},this.query={},this.data={}}router(s,t,e,i){this.route=s,this.params=t,this.query=e,this.data=i}updated(s){super.updated&&super.updated(s),s.forEach((s,t)=>{"params"===t&&console.log("params",this.params),"query"===t&&console.log("query",this.query),"usersSource"===t&&this.fetchData(this.usersSource,"users"),"profileSource"===t&&this.fetchData(this.profileSource,"profile"),"activitySource"===t&&this.fetchData(this.activitySource,"activity"),"lessonsSource"===t&&this.fetchData(this.lessonsSource,"lessons"),"projectsSource"===t&&this.fetchData(this.projectsSource,"projects"),"assignmentsSource"===t&&this.fetchData(this.assignmentsSource,"assignments"),"portfoliosSource"===t&&this.fetchData(this.portfoliosSource,"portfolios"),"submissionsSource"===t&&this.fetchData(this.submissionsSource,"submissions"),"discussionSource"===t&&this.fetchData(this.discussionSource,"discussion")})}get portfolio(){return this.params.portfolio?this.portfolios[this.params.portfolio]:{}}get submissionFeedback(){return this.query.submission?Object.keys(this.discussion||{}).filter(s=>this.discussion[s].submissionId==this.query.submission).map(s=>this.discussion[s]):[]}_filterBy(s,t,e=""){return s&&t&&s[`${e}${t}`]?s[`${e}${t}`]:{}}fetchData(s,t,e){fetch(this._getPath(s,e)).then(s=>s.json()).then(s=>{this[t]=s,console.log(t+" Loaded",s,this[t])})}_getPath(s,t){let e=Object.keys(t||{}).map(s=>`${encodeURI(s)}=${encodeURI(t[s])}`).join("&");return e?`${s}?${e}`:s}}customElements.define(ElmslnStudio.tag,ElmslnStudio);export{ElmslnStudio};