/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as e,css as i}from"../../../../../lit-element/lit-element.js";import{store as a}from"../../core/haxcms-site-store.js";import{autorun as s,toJS as r}from"../../../../../mobx/lib/mobx.module.js";import"../../../../map-menu/map-menu.js";import{HAXCMSThemeParts as o}from"../../core/utils/HAXCMSThemeParts.js";class SiteMenu extends(o(t)){static get styles(){return[...super.styles,i`
        :host {
          display: block;
          height: 100vh;
        }
        map-menu {
          padding: var(--site-menu-padding);
          background-color: var(--site-menu-background-color);
          color: var(--site-menu-color);
          --map-menu-active-color: var(--site-menu-active-color);
          --map-menu-container-padding: var(--site-menu-container-padding);
          --map-menu-container-background-color: var(
            --site-menu-container-background-color
          );
          --map-menu-container-color: var(--site-menu-container-color);
          --map-menu-item-active-item-color: var(
            --site-menu-item-active-item-color
          );
          --map-menu-font-size: var(--site-menu-font-size);
        }
        map-menu:not(:defined) {
          display: none;
        }

        map-menu::-webkit-scrollbar-track {
          border-radius: 0;
        }
        map-menu::-webkit-scrollbar {
          width: 2px;
        }
        map-menu::-webkit-scrollbar-thumb {
          border-radius: 1px;
        }
      `]}static get tag(){return"site-menu"}constructor(){super(),this.hideActiveIndicator=!1,this.preventAutoScroll=!1,this.trackIcon="",this.__disposer=[],s(t=>{this.routerManifest=Object.assign({},r(a.routerManifest)),this.__disposer.push(t)})}render(){return e`
      <map-menu
        .part="${this.editMode?"edit-mode-active":""}"
        .manifest="${this.routerManifest}"
        ?active-indicator="${!this.hideActiveIndicator}"
        ?auto-scroll="${!this.preventAutoScroll}"
        @active-item="${this.mapMenuActiveChanged}"
      ></map-menu>
    `}firstUpdated(t){super.firstUpdated&&super.firstUpdated(t),s(t=>{this.activeId=r(a.activeId),this.__disposer.push(t),setTimeout(()=>{this.shadowRoot.querySelector("map-menu").selected=this.activeId},100)})}static get properties(){return{...super.properties,routerManifest:{type:Object},activeId:{type:String,attribute:"active-id"},hideActiveIndicator:{type:Boolean,attribute:"hide-active-indicator"},preventAutoScroll:{type:Boolean,attribute:"prevent-auto-scroll"},trackIcon:{type:String,attribute:"track-icon"}}}disconnectedCallback(){for(var t in this.__disposer)this.__disposer[t].dispose();super.disconnectedCallback()}mapMenuActiveChanged(t){t.detail.trackIcon=this.trackIcon;let e=JSON.parse(window.localStorage.getItem("HAXCMSSystemData"));for(var i in e.manifests&&void 0===e.manifests[this.routerManifest.id]&&(e.manifests[this.routerManifest.id]={accessData:{}}),e.manifests[this.routerManifest.id].accessData||(e.manifests[this.routerManifest.id].accessData={}),e.manifests[this.routerManifest.id].accessData[t.detail.id]={timestamp:Math.floor(Date.now()/1e3),trackIcon:this.trackIcon},this.routerManifest.items)this.routerManifest.items[i].id===t.detail.id&&(this.routerManifest.items[i].metadata.accessData=e.manifests[this.routerManifest.id].accessData[t.detail.id]);window.localStorage.setItem("HAXCMSSystemData",JSON.stringify(e))}}window.customElements.define(SiteMenu.tag,SiteMenu);export{SiteMenu};