/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{html as t,css as e,LitElement as i}from"../../lit-element/lit-element.js";import{SchemaBehaviors as o}from"../schema-behaviors/schema-behaviors.js";class LrndesignAbbreviation extends(o(i)){constructor(){super(),setTimeout(()=>{import("../simple-tooltip/simple-tooltip.js")},0)}static get styles(){return[e`
        :host {
          display: inline-block;
        }
        abbr {
          transition: 0.6s all ease;
          padding: 2px 4px;
          font-style: italic;
          background-color: var(--abbreviation-bg, #f9f9f9);
          text-underline-position: under;
          text-decoration: underline double;
          cursor: help;
          outline: var(--abbreviation-selection, #ffff33);
        }
        abbr:focus,
        abbr:active,
        abbr:hover {
          text-decoration: none;
          background-color: var(--abbreviation-selection, #ffff33);
        }
        abbr::-moz-selection,
        abbr::selection {
          text-decoration: none;
          background-color: var(--abbreviation-selection, #ffff33);
        }
        simple-tooltip {
          --simple-tooltip-background: #000000;
          --simple-tooltip-opacity: 1;
          --simple-tooltip-text-color: #ffffff;
          --simple-tooltip-delay-in: 0;
        }
      `]}render(){return t`
      <abbr tabindex="0" title="${this.phrase}" id="abbr">${this.abbr}</abbr>
      <simple-tooltip for="abbr" position="top" offset="2" animation-delay="300"
        >${this.phrase}</simple-tooltip
      >
    `}static get tag(){return"lrndesign-abbreviation"}static get properties(){return{...super.properties,abbr:{type:String},phrase:{type:String}}}static get haxProperties(){return{canScale:!1,canPosition:!1,canEditSource:!1,gizmo:{title:"Abbreviation",description:"Simple abbreviation with tooltip of full word",icon:"editor:title",color:"grey",groups:["Instructional","Term"],handles:[{type:"inline",text:"text"}],meta:{author:"ELMS:LN"}},settings:{quick:[{property:"abbr",title:"Abbreviation",description:"Abbreviation word",inputMethod:"textfield",icon:"editor:title"},{property:"phrase",title:"Phrase",description:"The phrase / original words",inputMethod:"textfield",icon:"editor:title"}],configure:[{property:"abbr",title:"Abbreviation",description:"Abbreviation word",inputMethod:"textfield",icon:"editor:title"},{property:"phrase",title:"Phrase",description:"The phrase / original words",inputMethod:"textfield",icon:"editor:title"}],advanced:[]}}}}window.customElements.define(LrndesignAbbreviation.tag,LrndesignAbbreviation);export{LrndesignAbbreviation};