/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as e,html as r,css as i}from"../../../lit-element/lit-element.js";import{LrndesignGalleryBehaviors as l}from"./lrndesign-gallery-behaviors.js";import"./lrndesign-gallery-zoom.js";import"./lrndesign-gallery-details.js";class LrndesignGalleryGrid extends l{static get tag(){return"lrndesign-gallery-grid"}static get styles(){return[...super.styles,i`
        :host {
          margin: 15px 0;
          padding: 0;
          max-width: 100%;
          display: block;
        }
        #galleryscreen {
          display: grid;
          grid-gap: 7.5px;
          grid-template-columns: repeat(2, 1fr);
        }
        :host([responsive-size="sm"]) #galleryscreen {
          grid-template-columns: repeat(3, 1fr);
        }
        :host([responsive-size="md"]) #galleryscreen {
          grid-template-columns: repeat(4, 1fr);
        }
        :host([responsive-size="lg"]) #galleryscreen {
          grid-template-columns: repeat(5, 1fr);
        }
        :host([responsive-size="xl"]) #galleryscreen {
          grid-template-columns: repeat(6, 1fr);
        }
        lrndesign-gallery-zoom {
          position: relative;
          overflow: hidden;
          transition: outline 0.25s ease-in-out;
          outline: 1px solid var(--lrndesign-gallery-color);
        }
        lrndesign-gallery-zoom:hover,
        lrndesign-gallery-zoom:focus,
        lrndesign-gallery-zoom:focus-within {
          transition: outline 0.25s ease-in-out;
          outline: 2px solid var(--lrndesign-gallery-focus-color);
        }
        lrndesign-gallery-zoom img {
          position: absolute;
          opacity: 0 !important;
        }
        .imgbg {
          width: 100%;
          padding-top: var(--lrndesign-gallery-grid-paddingTop, 75%);
          background-image: var(--lrndesign-gallery-grid-backgroundImage, none);
          background-position: var(
            --lrndesign-gallery-grid-backgroundPosition,
            center
          );
          background-size: var(--lrndesign-gallery-grid-backgroundSize, cover);
        }
        .zoombg,
        .zoomicon {
          top: unset;
          bottom: 5px;
          left: 5px;
        }
      `]}static get properties(){return{...super.properties}}constructor(){super();let e=this.shadowRoot.querySelector("#carouselitem");this.selected.scroll&&e&&(this._scrollIntoView([this._getParentOffset(e)]),this.selected.zoomed||e.focus())}render(){return r`
      <div id="grid">
        <p class="sr-only">A list of columns buttons items:</p>
        <div id="galleryscreen">
          ${this.sources.map(e=>r`
              <lrndesign-gallery-zoom
                .id="${e.id}"
                .details="${e.details}"
                .heading="${e.heading}"
                .src="${e.large}"
                .tooltip="${e.tooltip}"
                .zoom-alt="${e.zoomAlt}"
              >
                <span class="sr-only">${e.zoomAlt}</span>
                <div class="imgbg" .style="${this._getStyle(e)}"></div>
                <div class="zoombg"></div>
                <iron-icon icon="zoom-in" class="zoomicon"></iron-icon>
              </lrndesign-gallery-zoom>
            `)}
        </div>
      </div>
    `}_getStyle(e){return[`--lrndesign-gallery-grid-paddingTop: ${100/this.aspectRatio}%;`,`--lrndesign-gallery-grid-backgroundImage: url(${e.src});`,`--lrndesign-gallery-grid-backgroundPosition: ${e.gravity||"center"};`,"--lrndesign-gallery-grid-backgroundSize: "+(e.sizing||"cover"===this.sizing||"contain")].join("")}}window.customElements.define(LrndesignGalleryGrid.tag,LrndesignGalleryGrid);export{LrndesignGalleryGrid};