/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as e,html as t,css as s}from"../../../lit-element/lit-element.js";import{LrndesignGalleryBehaviors as i}from"./lrndesign-gallery-behaviors.js";import"./lrndesign-gallery-zoom.js";import"./lrndesign-gallery-details.js";class LrndesignGalleryMasonry extends i{static get tag(){return"lrndesign-gallery-masonry"}static get styles(){return[...super.styles,s`
        :host {
          margin: 15px 0;
          padding: 0;
          max-width: 100%;
          display: block;
        }
        #galleryscreen > div {
          display: flex;
          align-items: stretch;
          justify-content: center;
          margin: 20px 0;
        }
        lrndesign-gallery-zoom {
          position: relative;
          margin: 0 10px;
          flex: 0 1 var(--lrndesign-gallery-image-width, 200px);
          max-width: 35%;
        }
        lrndesign-gallery-zoom,
        lrndesign-gallery-zoom:hover,
        lrndesign-gallery-zoom:focus,
        lrndesign-gallery-zoom:focus-within {
          border: 0px solid transparent;
        }
        lrndesign-gallery-zoom img {
          width: 100%;
          transition: outline 0.25s ease-in-out;
          outline: 1px solid var(--lrndesign-gallery-color);
        }
        lrndesign-gallery-zoom:hover img,
        lrndesign-gallery-zoom:focus img,
        lrndesign-gallery-zoom:focus-within img {
          transition: outline 0.25s ease-in-out;
          outline: 2px solid var(--lrndesign-gallery-focus-color);
        }
        .zoombg,
        .zoomicon {
          top: unset;
          bottom: 5px;
          left: 5px;
        }
      `]}static get properties(){return{...super.properties,__aspects:{type:Object},__columns:{type:Array},__items:{type:Array}}}constructor(){super(),this.__aspects={},this.__items=[];let e=this.shadowRoot.querySelector("#carouselitem");this.selected.scroll&&e&&(this._scrollIntoView([this._getParentOffset(e)]),this.selected.zoomed||e.focus())}render(){return t`
      <div id="grid">
        <p class="sr-only">A list of columns buttons items:</p>
        <div id="galleryscreen">
          ${(this.__items||[]).map((e,s)=>t`
              <div>
                ${(e.cols||[]).map((s,i)=>t`
                    <lrndesign-gallery-zoom
                      .id="${s.id}"
                      .details="${s.details}"
                      .heading="${s.heading}"
                      .src="${s.large}"
                      .tooltip="${s.tooltip}"
                      .zoom-alt="${s.zoomAlt}"
                      style="${this._getStyle(s.aspect,e.aspect)}"
                    >
                      <img
                        .alt="${s.alt}"
                        fade
                        .src="${s.src}"
                        @load="${e=>this._handleImgLoad(e)}"
                      />
                      <div class="zoombg"></div>
                      <iron-icon icon="zoom-in" class="zoomicon"></iron-icon>
                    </lrndesign-gallery-zoom>
                  `)}
              </div>
            `)}
        </div>
      </div>
    `}updated(e){super.updated(e),e.forEach((e,t)=>{"sources"===t&&this._updateItems(),"responsiveSize"===t&&this._updateItems()})}_getStyle(e,t){return[`--lrndesign-gallery-image-aspect:${e||100/75};`,`--lrndesign-gallery-image-height:${100/e||75}%;`,`--lrndesign-gallery-image-width:${100*e/t||.75}%`].join("")}_handleImgLoad(e){(e.path&&e.path[0]?e.path[0]:e.originalTarget?e.originalTarget:e.target).naturalWidth>0&&this._updateItems()}_updateItems(){let e=[],t={xs:2,sm:3,md:4,lg:5,xl:6}[this.responsiveSize||"xs"],s=Math.ceil(this.sources.length/t);for(let i=0;i<s;i++){let s={aspect:0,cols:[]};console.log("row",i);for(let e=i*t;e<Math.min(this.sources.length,(i+1)*t);e++){let t=JSON.parse(JSON.stringify(this.sources[e])),i=this.shadowRoot.querySelector(`img[src="${t.src}"]`);t.aspect=i&&i.naturalWidth>0?i.naturalWidth/i.naturalHeight:100/75,s.aspect+=t.aspect,s.cols.push(t)}e.push(s)}this.__items=e,console.log("this.__items",this.__items)}}window.customElements.define(LrndesignGalleryMasonry.tag,LrndesignGalleryMasonry);export{LrndesignGalleryMasonry};