/**
 * Copyright 2020 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as e,html as t,css as i}from"../../lit-element/lit-element.js";import{LrndesignGalleryBehaviors as r}from"./lib/lrndesign-gallery-behaviors.js";import"../responsive-utility/responsive-utility.js";import"./lib/lrndesign-gallery-carousel.js";import"./lib/lrndesign-gallery-grid.js";import"./lib/lrndesign-gallery-masonry.js";class LrndesignGallery extends r{static get styles(){return[...super.styles,i`
        :host {
          display: block;
        }

        :host([hidden]) {
          display: none;
        }

        ::slotted(figure) {
          display: block;
          margin-top: 15px;
          margin-bottom: 15px;
          max-width: 400px;
          max-height: 400px;
          display: block;
          border: 1px solid #ddd;
          page-break-inside: avoid;
        }

        @media screen {
          ::slotted(figure) {
            display: none;
          }
        }
      `]}render(){return t` <div
        id="gallery"
        style="--lrndesign-gallery-image-aspect:${this.aspectRatio};--lrndesign-gallery-image-height:${100/this.aspectRatio}%"
      >
        <div slot="title"><slot name="title"></slot></div>
        <div slot="description"><slot name="description"></slot></div>
        ${"masonry"===this.layout?t`
              <lrndesign-gallery-masonry
                accent-color="${this.accentColor}"
                .aspect-ratio="${this.aspect}"
                .extra-wide="${this.extra}"
                ?dark="${this.dark}"
                .gallery-id="${this.id}"
                @item-changed="${e=>this.goToItem(e.detail)}"
                responsive-size="${this.responsiveSize}"
                .selected="${this.selected}"
                .sources="${this.items}"
              >
              </lrndesign-gallery-masonry>
            `:this.grid||"grid"===this.layout?t`
              <lrndesign-gallery-grid
                accent-color="${this.accentColor}"
                .aspect-ratio="${this.aspect}"
                .extra-wide="${this.extra}"
                ?dark="${this.dark}"
                .gallery-id="${this.id}"
                @item-changed="${e=>this.goToItem(e.detail)}"
                responsive-size="${this.responsiveSize}"
                .selected="${this.selected}"
                sizing="${"cover"===this.sizing||"contain"}"
                .sources="${this.items}"
              >
              </lrndesign-gallery-grid>
            `:t` <lrndesign-gallery-carousel
              accent-color="${this.accentColor}"
              .aspect-ratio="${this.aspect}"
              .extra-wide="${this.extra}"
              ?dark="${this.dark}"
              .gallery-id="${this.id}"
              @item-changed="${e=>this.goToItem(e.detail)}"
              responsive-size="${this.responsiveSize}"
              .selected="${this.selected}"
              sizing="${"cover"===this.sizing||"contain"}"
              .sources="${this.items}"
            >
            </lrndesign-gallery-carousel>`}
      </div>
      <slot hidden></slot>`}static get haxProperties(){return{canScale:!1,canPosition:!1,canEditSource:!0,gizmo:{title:"Image Gallery",description:"An image gallery displayed as a carousel or a grid",icon:"image:collections",color:"cyan",groups:["Content","Instructional","Media","Image"],handles:[{type:"image",source:"image"}],meta:{author:"ELMS:LN"}},settings:{quick:[{property:"accentColor",title:"Accent Color",description:"An optional accent color.",inputMethod:"colorpicker",icon:"editor:format-color-fill"},{property:"dark",title:"Dark Theme",description:"Enable Dark Theme",inputMethod:"boolean",icon:"icons:invert-colors"},{property:"layout",title:"Layout",description:"Display as grid?",inputMethod:"select",itemsList:["carousel","grid","masonry"]}],configure:[{slot:"title",title:"Optional Gallery Title",description:"Am optional title for the gallery.",inputMethod:"textfield"},{slot:"description",title:"OptionalGallery Description",description:"An optional description for the gallery.",inputMethod:"textfield"},{property:"accentColor",title:"Accent Color",description:"An optional accent color.",inputMethod:"colorpicker"},{property:"dark",title:"Dark Theme",description:"Enable Dark Theme",inputMethod:"boolean"},{property:"layout",title:"Layout",description:"Display as grid?",inputMethod:"select",itemsList:["carousel","grid","masonry"]},{property:"sources",title:"Gallery Images",description:"The images for the gallery.",inputMethod:"array",itemLabel:"title",properties:[{property:"title",title:"Image Title",description:"The heading for the image.",inputMethod:"textfield"},{property:"details",title:"Image Details",description:"The body text with details for the image.",inputMethod:"textfield"},{property:"src",title:"Image",description:"Default Image",inputMethod:"haxupload"},{property:"thumbnail",title:"Optional Thumbnail Image",description:"Optional smaller thumbnail version of the image.",inputMethod:"haxupload"},{property:"large",title:"Optional Full Image",description:"Optional larger full-sized version of the image for zooming.",inputMethod:"haxupload"}]}],advanced:[{property:"aspectRatio",title:"Aspect Ratio",description:"Custom aspect ratio, default is calculated based on the first image's aspect ratio",inputMethod:"textfield"},{property:"sizing",title:"Fit to Aspect Ratio",description:"Fit images to aspect ratio",inputMethod:"select",options:{cover:"crop",contain:"letterbox"}}]}}}static get properties(){return{...super.properties,id:{type:String,reflect:!0,attribute:"id"},responsiveSize:{type:String,reflect:!0,attribute:"responsive-size"}}}static get tag(){return"lrndesign-gallery"}constructor(){super(),this.sources=[],this.sizing="cover"}connectedCallback(){super.connectedCallback(),window.ResponsiveUtility.requestAvailability(),this.updateGallery(),this.observer.observe(this,{attributes:!1,childList:!0,subtree:!1})}disconnectedCallback(){this.observer&&this.observer.disconnect&&this.observer.disconnect(),super.disconnectedCallback&&super.disconnectedCallback()}firstUpdated(){super.firstUpdated(),window.dispatchEvent(new CustomEvent("responsive-element",{detail:{element:this,attribute:"responsive-size",sm:300,md:600,lg:1e3,xl:1500}})),this.anchorData=this._getAnchorData(),this.anchorData.gallery===this.id?this.goToItem(this.anchorData.id):this.goToItem()}updated(e){super.updated(e),e.forEach((e,t)=>{"id"!==t||this.id||(this.id="gallery-"+this._generateUUID())})}get aspect(){let e=(this.items||[]).filter(e=>e.src&&""!=e.src),t=!(!e||!e[0])&&e[0].src;if(t){let e=new Image;return e.src=t,e.naturalWidth>0&&e.naturalHeight>0?e.naturalWidth/e.naturalHeight:1.33333333}return 1.33333333}get extra(){return this.aspect>2}get items(){let e=this.sources||[],t="string"==typeof e?JSON.parse(e):e,i=t.length;return(t||[]).map((e,t)=>({alt:e.alt,details:e.details,index:t,id:e.id||`gallery-${this.id}-item-${t}`,src:e.src,large:e.large&&""!==e.large?e.large:e.src,thumbnail:e.thumbnail&&""!=e.thumbnail?e.thumbnail:e.src,xofy:`${t+1} of ${i}`,next:t+1<i?t+1:-1,prev:t-1>-1?t-1:-1,sizing:e.sizing&&""!=e.sizing?e.sizing:this.sizing,gravity:e.gravity||"center",title:e.title,tooltip:(e.title||"Image "+t)+" (Zoom In)",heading:(e.title||"Image "+t)+" (Full-Sized)"}))}get observer(){return new MutationObserver(()=>this.updateGallery())}goToItem(e){let t=this.items[0]||{};if("number"==typeof e&&e>=0&&e<this.items.length)this.selected=this.items[e]||t;else{let i=this.items.filter(t=>t.id===e);this.selected=i.length>0?i[0]:t}}updateGallery(){let e=[];this.querySelectorAll("figure").forEach(t=>{let i=t.getAttribute("id"),r=t.querySelector("img"),s=t.getAttribute("sizing"),l=[1,2,3,4,5,6].map(e=>`h${e}:first-child`).join(","),o=r&&r.getAttribute("src")?r.getAttribute("src"):void 0,a=r&&r.getAttribute("srcset")?r.getAttribute("srcset").split(","):void 0,n=a&&a[0]?a[0].split(" "):void 0,d=a&&a[a.length-1]?a[a.length-1].split(" "):void 0,c=n&&n[0]?n[0]:void 0,p=d&&d[0]?d[0]:void 0,g=t.querySelector("figcaption")?t.querySelector("figcaption").cloneNode(!0):void 0,h=r&&r.getAttribute("alt")?r.getAttribute("alt"):void 0,u=g&&g.querySelector(l)?g.querySelector(l):void 0,m=u.innerHTML;u&&u.remove(),e.push({alt:h,id:i,src:o,thumbnail:c,large:p,title:m,details:g.innerHTML,sizing:s})}),e.length>0&&(!this.sources||this.sources.length<1)&&(this.sources=e)}_getAnchorData(){let e=null!==window.location.hash&&""!==window.location.hash&&window.location.hash.replace("#",""),t=e?e.split("---"):[];return{id:t.length>1?t[1]:-1,gallery:t.length>0?t[0]:-1,zoom:scroll&&t.length>2&&"zoom"===t[2]}}}customElements.define("lrndesign-gallery",LrndesignGallery);export{LrndesignGallery};