/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{html as t,PolymerElement as e}from"../../@polymer/polymer/polymer-element.js";import{afterNextRender as s}from"../../@polymer/polymer/lib/utils/render-status.js";import"../../@polymer/paper-progress/paper-progress.js";import"./lib/lrnsys-progress-circle.js";class LrnsysProgress extends e{constructor(){super(),this.completeSound=this.pathFromUrl(decodeURIComponent(import.meta.url))+"lib/assets/complete.mp3",this.finishedSound=this.pathFromUrl(decodeURIComponent(import.meta.url))+"lib/assets/finished.mp3"}static get template(){return t`
      <style include="paper-material-styles">
        :host {
          display: block;
          margin-top: 24px;
        }
        :host([size="tiny"]) {
          font-size: 12.8px;
        }
        :host([size="small"]) {
          font-size: 19.2px;
        }
        :host([size="medium"]) {
          font-size: 25.6px;
        }
        :host([size="large"]) {
          font-size: 44.8px;
        }
        :host([size="x-large"]) {
          font-size: 64px;
        }
        :host([size="epic"]) {
          font-size: 96px;
        }
        #circle-container {
          display: flex;
          justify-content: space-between;
          margin: -24px 0 0 0;
          padding: 0;
          list-style: none;
        }
        .progress-title {
          position: absolute !important;
          clip: rect(1px 1px 1px 1px); /* IE6, IE7 */
          clip: rect(1px, 1px, 1px, 1px);
          overflow: hidden;
          height: 1px;
        }
        paper-progress {
          --paper-progress-height: 8px;
          --paper-progress-transition-duration: 0.5s;
          --paper-progress-transition-timing-function: ease;
          --paper-progress-transition-delay: 0.4s;
          width: 100%;
        }
        /* required to get the box shadow above the progress bar */
        .circle-node {
          z-index: 1;
        }
        ul#circle-container li.circle-node {
          list-style-type: none;
        }

        :host([vertical]) {
          width: max-content;
        }
        :host([vertical]) #circle-container {
          display: block;
        }
        :host([vertical]) paper-progress {
          display: none !important;
        }
        :host([vertical]) lrnsys-progress-circle {
          margin: 16px 0;
          padding: 0;
          width: 100%;
        }

        lrnsys-progress-circle {
          width: 40px;
          height: 40px;
          --lrnsys-progress-circle-size: 40px;
          --lrnsys-progress-spinner-size: 32px;
          --lrnsys-progress-icon-size: 24px;
          --paper-spinner-stroke-width: 1.2px;
        }
      </style>

      <iron-ajax
        id="ajax"
        url="[[activeNodeURL]]"
        handle-as="json"
        last-error="{{nodeDataError}}"
        on-response="handleNodeResponse"
      ></iron-ajax>
      <h3 class="progress-title">[[title]]</h3>
      <paper-progress
        id="progress"
        value="[[overallPercentage]]"
      ></paper-progress>
      <ul id="circle-container">
        <template is="dom-repeat" items="[[items]]" as="item">
          <li class="circle-node">
            <lrnsys-progress-circle
              play-finish-sound="[[soundFinish]]"
              play-sound="[[sound]]"
              complete-sound="[[completeSound]]"
              finished-sound="[[finishedSound]]"
              active="[[_isActive(index, active)]]"
              step="[[index]]"
              label="[[item.title]]"
              icon="[[item.metadata.icon]]"
              icon-complete="[[item.metadata.iconComplete]]"
              data-url="[[item.metadata.dataUrl]]"
              url="[[item.slug]]"
              status="[[item.metadata.status]]"
              value="[[item.metadata.value]]"
              max="[[item.metadata.max]]"
              stroke-width="[[strokeWidth]]"
              tool-tip="[[!vertical]]"
              list-view="[[vertical]]"
              class$="[[size]]"
            >
              <span slot="description">[[item.description]]</span>
            </lrnsys-progress-circle>
          </li>
        </template>
      </ul>
    `}static get tag(){return"lrnsys-progress"}connectedCallback(){super.connectedCallback(),s(this,(function(){this.addEventListener("node-is-active",this._bubbleUpChangeActive.bind(this)),this.addEventListener("node-status-change",this._statusChanged.bind(this))}))}disconnectedCallback(){this.removeEventListener("node-is-active",this._bubbleUpChangeActive.bind(this)),this.removeEventListener("node-status-change",this._statusChanged.bind(this)),super.disconnectedCallback()}pathFromUrl(t){return t.substring(0,t.lastIndexOf("/")+1)}static get properties(){return{disableAjaxCalls:{type:Boolean,value:!1,reflectToAttribute:!0},items:{type:Array,value:[],notify:!0,observer:"_itemsChanged"},sound:{type:Boolean,value:!1,reflectToAttribute:!0},soundFinish:{type:Boolean,value:!1,reflectToAttribute:!0},completeSound:{type:String,reflectToAttribute:!0},finishedSound:{type:String,reflectToAttribute:!0},title:{type:String,value:"Steps to completion",reflectToAttribute:!0},keyItems:{type:Array,value:[],notify:!0},active:{type:Number,value:0,notify:!0,reflectToAttribute:!0,observer:"_activeChanged"},progressiveUnlock:{type:Boolean,value:!0,reflectToAttribute:!0,notify:!0},state:{type:String,value:null,reflectToAttribute:!0,observer:"_reportState"},overallPercentage:{type:Number,computed:"_overallPercentageCompute(items, active)",reflectToAttribute:!0},_responseList:{type:Array,value:[]},activeNodeResponse:{type:String,value:"",observer:"_activeResponseChanged"},manifest:{type:Object,value:{},notify:!0,observer:"_manifestChanged"},nodeDataError:{type:Object,value:[],observer:"_handleNodeError"},vertical:{type:Boolean,value:!1},size:{type:String,value:"medium",notify:!0,reflectToAttribute:!0},strokeWidth:{type:Number,computed:"_getStrokeWidth(size)"}}}_getStrokeWidth(t){var e=4;return"tiny"==t?e=3:"small"==t?e=4:"medium"==t?e=5:"large"==t?e=6:"x-large"==t?e=7:"epic"==t&&(e=8),e}_reportState(t,e){null!=t&&this.items.length>0&&this.dispatchEvent(new CustomEvent("progress-state-change",{bubbles:!0,cancelable:!0,composed:!0,detail:{state:this.state,active:this.items[this.active]}}))}_itemsChanged(t,e){void 0!==e&&void 0!==t&&t.length!=e.length&&void 0===this._responseList[this.active]&&(t[this.active].metadata.status="loading",this.set("items."+this.active+".metadata.status","loading"),this.notifyPath("items."+this.active+".metadata.status"),void 0===t[this.active].dataUrl||this.disableAjaxCalls?setTimeout(()=>{t[this.active].metadata.status="available",this.set("items."+this.active+".metadata.status","available"),this.notifyPath("items."+this.active+".metadata.status"),this._responseList[this.active]={},this.activeNodeResponse=this._responseList[this.active]},1200):(this.shadowRoot.querySelector("#ajax").url=t[this.active].dataUrl,this.shadowRoot.querySelector("#ajax").generateRequest()))}_isActive(t,e){return t===e}_activeResponseChanged(t){this.dispatchEvent(new CustomEvent("progress-response-loaded",{bubbles:!0,cancelable:!0,composed:!0,detail:{response:t}}))}_bubbleUpChangeActive(t){this.active=t.detail.target.step,this.dispatchEvent(new CustomEvent("json-outline-schema-active-item-changed",{bubbles:!0,cancelable:!0,composed:!0,detail:this.items[this.active]}))}_manifestChanged(t,e){t&&(this.set("items",t.items),this.notifyPath("items.*"))}_activeChanged(t,e){this.state="active item is "+this.active,this.items.forEach((t,e,s)=>{"disabled"==this.items[e].metadata.status?0!=e&&this.progressiveUnlock&&"complete"==this.items[e-1].metadata.status&&(this.items[e].metadata.status="loading",this.set("items."+e+".metadata.status","loading"),this.notifyPath("items."+e+".metadata.status")):this.items[e].metadata.value>=this.items[e].metadata.max&&e==this.items.length-1?(this.items[e].metadata.status="finished",this.set("items."+e+".metadata.status","finished"),this.notifyPath("items."+e+".metadata.status")):this.items[e].metadata.value>=this.items[e].metadata.max?(this.items[e].metadata.status="complete",this.set("items."+e+".metadata.status","complete"),this.notifyPath("items."+e+".metadata.status")):e==this.active?void 0===this._responseList[e]?(this.items[e].metadata.status="loading",this.set("items."+e+".metadata.status","loading"),this.notifyPath("items."+e+".metadata.status")):(this.activeNodeResponse=this._responseList[e],this.items[e].metadata.status="available",this.set("items."+e+".metadata.status","available"),this.notifyPath("items."+e+".metadata.status")):(this.items[e].metadata.status="available",this.set("items."+e+".metadata.status","available"),this.notifyPath("items."+e+".metadata.status"))})}_statusChanged(t){"loading"==t.target.status?void 0===this.items[this.active].metadata.dataUrl||this.disableAjaxCalls?setTimeout(()=>{this.items[this.active].metadata.status="available",this.set("items."+this.active+".metadata.status","available"),this.notifyPath("items."+this.active+".metadata.status"),this._responseList[this.active]={},this.activeNodeResponse=this._responseList[this.active]},1500):(this.shadowRoot.querySelector("#ajax").url=this.items[this.active].metadata.dataUrl,this.shadowRoot.querySelector("#ajax").generateRequest()):"complete"==t.target.status&&this.items.length===this.active+1&&setTimeout(()=>{this.items[this.active].metadata.status="finished",this.set("items."+this.active+".metadata.status","finished"),this.notifyPath("items."+this.active+".metadata.status")},100)}handleNodeResponse(t){const e=t.detail;"object"==typeof e.response?setTimeout(()=>{this.items[this.active].metadata.status="available",this.set("items."+this.active+".metadata.status","available"),this.notifyPath("items."+this.active+".metadata.status"),this._responseList[this.active]=e.response,this.activeNodeResponse=this._responseList[this.active]},1500):(this.items[this.active].metadata.status="available",this.set("items."+this.active+".metadata.status","available"),this.notifyPath("items."+this.active+".metadata.status"),this._responseList[this.active]=e.response,this.activeNodeResponse=this._responseList[this.active])}_handleNodeError(t,e){void 0!==e&&null!=t&&0!=t.length&&(this._responseList[this.active]=t,this.activeNodeResponse=this._responseList[this.active],this.items[this.active].metadata.status="available",this.set("items."+this.active+".metadata.status","available"),this.notifyPath("items."+this.active+".metadata.status"),this.dispatchEvent(new CustomEvent("node-load-failed",{bubbles:!0,cancelable:!0,composed:!0,detail:this.items[this.active]})))}_overallPercentageCompute(t,e){return void 0!==t?(this.shadowRoot.querySelector("#progress").classList.add("transiting"),e/(t.length-1)*100):0}changePercentage(t,e){var s=0;(s="add"==e?this.items[this.active].metadata.value+t:"subtract"==e?this.items[this.active].metadata.value-t:t)>=this.items[this.active].metadata.max?(this.items.length==this.active+1?(this.state="finished",this.items[this.active].metadata.status="finished",this.set("items."+this.active+".metadata.status","finished"),this.notifyPath("items."+this.active+".metadata.status"),this.items[this.active].metadata.value=this.items[this.active].metadata.max,this.set("items."+this.active+".metadata.value",this.items[this.active].metadata.max),this.notifyPath("items."+this.active+".metadata.value")):(this.items[this.active].metadata.value=this.items[this.active].metadata.max,this.set("items."+this.active+".metadata.value",this.items[this.active].metadata.max),this.notifyPath("items."+this.active+".metadata.value")),this.items.length>this.active+1&&((this.progressiveUnlock&&"complete"==this.items[this.active].metadata.status&&"disabled"==this.items[this.active+1].metadata.status||void 0===this._responseList[this.active+1])&&(this.items[this.active+1].metadata.status="loading",this.set("items."+(this.active+1)+".metadata.status","loading"),this.notifyPath("items."+(this.active+1)+".metadata.status")),this.state="active item is "+(this.active+1),this.active=this.active+1)):(this.items[this.active].metadata.value=s,this.set("items."+this.active+".metadata.value",s),this.notifyPath("items."+this.active+".metadata.value"))}updateItems(t,e){var s=!1;"push"==t?(this.push("items",e),s=!0):"pop"==t?s=this.pop("items"):"splice"==t&&(this.splice("items",this.items.length,0,e),s=!0);const i=this.active;return this.set("active",0),this.set("active",i),this.notifyPath("active"),s}}window.customElements.define(LrnsysProgress.tag,LrnsysProgress);export{LrnsysProgress};