/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as e,html as t,css as i}from"../../lit-element/lit-element.js";import{RelativeHeadingLite as n}from"./lib/relative-heading-lite.js";import"../anchor-behaviors/anchor-behaviors.js";class RelativeHeading extends n{static get styles(){return[i`
        :host {
          display: flex;
          flex-wrap: var(--relative-heading-wrap, wrap);
          align-items: var(--relative-heading-align, center);
          justify-content: flex-start;
        }

        :host([hidden]) {
          display: none;
        }

        ::slotted(*) {
          flex: 0 0 auto;
        }

        :host([link-align-right]) {
          justify-content: space-between;
        }

        :host([link-align-right]) ::slotted(*) {
          flex: 1 1 auto;
        }

        :host > paper-icon-button:not(:defined) {
          opacity: 0;
        }

        :host > paper-icon-button {
          flex: 0 0 auto;
        }

        paper-icon-button {
          color: var(--relative-heading-button-color, #666);
          background: var(--relative-heading-button-bg);
          border: var(--relative-heading-button-border);
          outline: var(--relative-heading-button-outline);
          margin: var(--relative-heading-button-margin, 0 0 0 8px);
          padding: var(--relative-heading-button-padding, 8px);
          opacity: var(--relative-heading-button-opacity, 0);
          transition: var(--relative-heading-button-transition, all 0.5s);
        }

        :host([link-align-right]) paper-icon-button,
        :host(:not([link-align-right]):focus) paper-icon-button,
        :host(:not([link-align-right]):focus-within) paper-icon-button,
        :host(:not([link-align-right]):hover) paper-icon-button {
          opacity: var(--relative-heading-button-active-opacity, 1);
        }

        paper-icon-button:focus-within,
        paper-icon-button:focus,
        paper-icon-button:hover {
          color: var(--relative-heading-button-focus-color, #000);
          background: var(--relative-heading-button-focus-bg);
          border: var(--relative-heading-button-focus-border);
          outline: var(--relative-heading-button-focus-outline);
          opacity: var(--relative-heading-button-focus-opacity, 1);
        }
      `]}render(){return t` ${this.template} ${this.button}`}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!1,gizmo:{title:"Relative heading",description:"outputs the correct heading hierarchy based on parent's heading",icon:"icons:android",color:"green",groups:["Heading"],handles:[{type:"todo:read-the-docs-for-usage"}],meta:{author:"nikkimk",owner:"The Pennsylvania State University"}},settings:{quick:[],configure:[{property:"parent",description:"Parent Heading's Resource ID",inputMethod:"textfield",required:!1},{property:"disableLink",description:"Disables link button feature.",inputMethod:"boolean",required:!1},{property:"linkAlignRight",description:"Aligns copy link button to far right of heading.",inputMethod:"boolean",required:!1}],advanced:[{property:"defaultLevel",description:"Heading level if parent is not found.",inputMethod:"number",required:!1},{property:"copyMessage",description:"Overrides default text for copy link's toast message.",inputMethod:"textfield",required:!1},{property:"linkLabel",description:"Overrides default label copy link button.",inputMethod:"textfield",required:!1},{property:"linkIcon",description:"Overrides default icon copy link button.",inputMethod:"iconpicker",required:!1},{property:"closeLabel",description:"Overrides default label for copy link's toast's close button.",inputMethod:"textfield",required:!1},{property:"closeIcon",description:"Overrides default icon for copy link's toast's close button.",inputMethod:"iconpicker",required:!1}]}}}static get properties(){return{...super.properties,closeIcon:{type:String},closeLabel:{type:String},copyMessage:{type:String},disableLink:{type:Boolean,attribute:"disable-link"},linkAlignRight:{type:Boolean,attribute:"link-align-right",reflect:!0},linkIcon:{type:String},linkLabel:{type:String}}}static get tag(){return"relative-heading"}constructor(){super(),this.linkAlignRight=!1,this.disableLink=!1,this.linkIcon="link",this.linkLabel="Get link",import("../../@polymer/iron-icons/iron-icons.js"),import("../../@polymer/paper-icon-button/paper-icon-button.js")}connectedCallback(){super.connectedCallback(),this.disableLink||this.manager.useCopyLink()}get anchored(){return!(!window.AnchorBehaviors||!window.AnchorBehaviors.getTarget)&&window.AnchorBehaviors.getTarget(this)}get button(){return console.log(this.disableLink),this.disableLink?t``:t`
          <paper-icon-button
            controls="relative-heading-toast"
            .aria-describedby="${this.id}"
            .icon="${this.linkIcon}"
            .title="${this.linkLabel}"
            ?hidden="${this.disableLink}"
            ?disabled="${this.disableLink}"
            @click="${this._handleCopyClick}"
          >
          </paper-icon-button>
        `}_handleCopyClick(){!this.disableLink&&this.manager&&this.manager.copyLink&&this.manager.copyLink(this)}}window.customElements.define(RelativeHeading.tag,RelativeHeading);export{RelativeHeading};