/**
 * Copyright 2019 Penn State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as e,html as t,css as i}from"../../../../lit-element/lit-element.js";import{RichTextEditorStyles as n}from"../rich-text-editor-styles.js";class RichTextEditorSelection extends(n(e)){static get tag(){return"rich-text-editor-selection"}static get styles(){return[...super.styles,i`
        :host {
          background-color: var(--rich-text-editor-selection-bg);
          margin: 0;
          padding: 0;
          display: inline;
        }
        :host([hidden]) {
          display: none;
        }
        :host([collapsed]):after {
          content: '|';
          color: var(--rich-text-editor-selection-bg);
          background-color: transparent;
        }
      `]}render(){return t` <slot></slot> `}static get properties(){return{editor:{type:Object},collapsed:{type:Boolean,reflect:!0,attribute:"collapsed"},hidden:{type:Boolean,reflect:!0,attribute:"hidden"},observer:{type:Object},range:{type:Object},toolbar:{type:Object}}}constructor(){super(),this.hidden=!0,document.addEventListener("selectionchange",e=>{this.range=this.getRange()}),document.addEventListener("select-rich-text-editor-editor",e=>{this._editorChange(e)}),document.addEventListener("deselect-rich-text-editor-editor",e=>{this._editorChange(e)}),this.setAttribute("id",this._generateUUID())}updated(e){super.updated(e),e.forEach((e,t)=>{"range"===t&&this._updateToolbar()})}disconnectedCallback(){super.disconnectedCallback(),document.removeEventListener("selectionchange",e=>{this.range=root.getRange()}),document.removeEventListener("select-rich-text-editor-editor",e=>{this._editorChange(e)}),document.removeEventListener("deselect-rich-text-editor-editor",e=>{this._editorChange(e)})}expandSelection(e,t=this.range,i){return this.selectAncestor(e,t)||this.wrap(i?document.createElement(i):void 0)}getRange(){let e=window.getSelection();return e.getRangeAt&&e.rangeCount?e.getRangeAt(0):e||void 0}addHighlight(){this.hidden&&(this.hidden=!this.range||this.range.collapsed,this.hidden||(this.range.surroundContents(this),this.normalize(),this.innerHTML=this.innerHTML.trim(),this.range.selectNodeContents(this),this.dispatchEvent(new CustomEvent("highlight",{detail:this})),this.hidden=!1))}getRangeContents(){return this.range?this.range.cloneContents():null}getAncestor(e,t=this.range){let i,n=e.toLowerCase().split(","),getMatchingTag=t=>t&&t.tagName&&(!e||n.includes(t.tagName.toLowerCase()))?t:t&&t.parentNode&&1===t.parentNode.childNodes.length?getMatchingTag(t.parentNode):void 0;if(t){let e=t.commonAncestorContainer;i=getMatchingTag(e)}return i}selectAncestor(e,t=this.range){let i=this.getAncestor(e,t);return i&&t.selectNode(i),i}selectNode(e=null){if(e){if(!this.range){let e=window.getSelection();this.range=document.createRange(),e.removeAllRanges(),e.addRange(this.range)}this.range.selectNode(e)}return this.range}selectNodeContents(e=null){if(e){if(!this.range){let e=window.getSelection();this.range=document.createRange(),e.removeAllRanges(),e.addRange(this.range)}this.range.selectNodeContents(e)}}selectRange(e){if(e){let t=window.getSelection();t.removeAllRanges(),t.addRange(e)}}deselectRange(){let e=this.getRange();e.isCollapsed||e.collapse()}removeHighlight(){if(this.hidden)return;this.normalize();let e=this.childNodes;e.length>0?e.forEach((e,t)=>{this.parentNode.insertBefore(e,this),0===t&&this.range.setStart(e,0),this.range.setEnd(e,0)}):this.previousSibling?(this.range.selectNode(this.previousSibling),this.range.collapse()):this.nextSibling?(this.range.selectNode(this.nextSibling),this.range.collapse(!0)):this.parentNode&&(this.range.selectNode(this.c),this.range.collapse(!0)),this.hidden=!0}wrap(e){return e=e||document.createElement("span"),this.range.surroundContents(e),e}_editorChange(e,t=!1){let i=this,n=i.editor!==e.detail.editor,r=i.toolbar!==e.detail.toolbar;if(t||n||r){window.getSelection().removeAllRanges(),i.editor=e.detail.editor,i.toolbar=e.detail.toolbar,i.observer&&i.observer.disconnect(),!t&&e.detail.editor&&(i.observer=new MutationObserver(e=>{i.range=i.getRange()}),i.observer.observe(e.detail.editor,{attributes:!1,childList:!0,subtree:!0,characterData:!1}))}}_generateUUID(){let e=Math.floor(65536*(1+Math.random())).toString(16).substring(1);return"rte-"+"ss-s-s-s-sss".replace(/s/g,e)}_updateToolbar(){this.toolbar&&(this.toolbar.range=this.range)}}window.customElements.define(RichTextEditorSelection.tag,RichTextEditorSelection);export{RichTextEditorSelection};window.RichTextEditorSelection={},window.RichTextEditorSelection.instance=null,window.RichTextEditorSelection.requestAvailability=function(){return null==window.RichTextEditorSelection.instance&&(window.RichTextEditorSelection.instance=new RichTextEditorSelection,document.body.appendChild(window.RichTextEditorSelection.instance)),window.RichTextEditorSelection.instance};