/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as e,css as r}from"../../../../lit-element/lit-element.js";import{RichTextEditorStyles as o}from"../rich-text-editor-styles.js";import"./rich-text-editor-breadcrumb.js";class RichTextEditorBreadcrumbs extends(o(t)){static get tag(){return"rich-text-editor-breadcrumbs"}static get styles(){return[...super.styles,r`
        :host {
          display: block;
          background-color: var(--rich-text-editor-bg);
          color: var(--rich-text-editor-button-color);
          border: var(--rich-text-editor-border);
          padding: 3px 10px;
        }
        :host([sticky]) {
          position: sticky;
          bottom: 0;
        }
        .selectednode {
          background-color: var(--rich-text-editor-bg);
        }
      `]}render(){return e`
      ${this.label}
      ${this.ancestorNodes?(this.ancestorNodes||[]).map((t,r)=>e`
              <rich-text-editor-breadcrumb
                controls="${this.controls}"
                tag="${t.tag}"
                .target="${t.target}"
              >
              </rich-text-editor-breadcrumb>
              ${r+1>=this.ancestorNodes.length?"":e` <span class="divider"> &gt; </span> `}
            `):""}
    `}static get properties(){return{controls:{type:String},hidden:{type:Boolean,attribute:"hidden",reflect:!0},label:{type:String},range:{type:Object},sticky:{type:Boolean,reflect:!0}}}constructor(){super(),this.hidden=!1,this.sticky=!1,this.label="Expand selection: "}get ancestorNodes(){let t=[],e=!1,r=!1;this.controls;for(this.range&&(e=this.range.commonAncestorContainer),e&&(r=e),this.hidden=!e;r&&"RICH-TEXT-EDITOR"!==r.nodeName;)t.unshift({tag:r.nodeName.toLowerCase(),target:r}),r=r.parentNode;return t}}window.customElements.define(RichTextEditorBreadcrumbs.tag,RichTextEditorBreadcrumbs);export{RichTextEditorBreadcrumbs};