/**
 * Copyright 2019 Penn State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as e,css as o}from"../../../../lit-element/lit-element.js";import{RichTextEditorStyles as i}from"../rich-text-editor-styles.js";import"../../../responsive-utility/responsive-utility.js";import"../../rich-text-editor.js";import"../singletons/rich-text-editor-selection.js";const RichTextEditorToolbarBehaviors=function(t){return class extends(i(t)){static get tag(){return"rich-text-editor-toolbar"}static get stickyStyles(){return[o`
          :host([sticky]) {
            position: sticky;
            top: 0;
          }
        `]}static get baseStyles(){return[...super.styles,o`
          :host([hidden]) {
            display: none;
          }
          #toolbar {
            display: flex;
            opacity: 1;
            z-index: 1;
            margin: 0;
            align-items: stretch;
            flex-wrap: wrap;
            justify-content: flex-start;
            background-color: var(--rich-text-editor-bg);
            border: var(--rich-text-editor-border);
            font-size: 12px;
            transition: all 0.5s;
          }
          #toolbar[aria-hidden="true"] {
            visibility: hidden;
            opacity: 0;
            height: 0;
          }
          #toolbar .group {
            display: flex;
            flex-wrap: nowrap;
            justify-content: space-evenly;
            align-items: stretch;
            padding: 0 3px;
          }
          #toolbar .group:not(:last-of-type) {
            margin-right: 3px;
            border-right: var(--rich-text-editor-border);
          }
          #toolbar .button {
            display: flex;
            flex: 0 0 auto;
            align-items: stretch;
          }
          #toolbar #morebutton {
            flex: 1 0 auto;
            justify-content: flex-end;
          }
          /* hide more button if all buttons are displayed */
          #toolbar[responsive-size="xs"] #morebutton[collapse-max="xs"],
          #toolbar[responsive-size="sm"] #morebutton[collapse-max*="s"],
          #toolbar[responsive-size="md"] #morebutton:not([collapse-max*="l"]),
          #toolbar[responsive-size="lg"] #morebutton:not([collapse-max="xl"]),
          #toolbar[responsive-size="xl"] #morebutton,
          /* hide buttons if they should be collaped until */
          #toolbar[responsive-size="xs"][collapsed] *[collapsed-until*="m"],
          #toolbar[responsive-size="xs"][collapsed] *[collapsed-until*="l"],
          #toolbar[responsive-size="sm"][collapsed] *[collapsed-until="md"],
          #toolbar[responsive-size="sm"][collapsed] *[collapsed-until*="l"],
          #toolbar[responsive-size="md"][collapsed] *[collapsed-until*="l"],
          #toolbar[responsive-size="lg"][collapsed] *[collapsed-until="xl"] {
            display: none;
          }
        `]}static get styles(){return[...this.baseStyles,...this.stickyStyles]}get toolbarTemplate(){return e`
        <div
          id="toolbar"
          aria-live="polite"
          aria-hidden="${this.controls?"false":"true"}"
          ?collapsed="${this.collapsed}"
          @focus="${this._addHighlight}"
        >
          <rich-text-editor-more-button
            id="morebutton"
            class="button"
            controls="toolbar"
            icon="${this.moreIcon}"
            label="${this.moreLabel}"
            ?show-text-label="${this.moreShowTextLabel}"
            ?label-toggled="${this.moreLabelToggled}"
            ?toggled="${!this.collapsed}"
            @click="${this._toggleMore}"
          >
          </rich-text-editor-more-button>
        </div>
      `}render(){return e` ${this.toolbarTemplate} `}static get properties(){return{canceled:{type:Object},collapsed:{name:"collapsed",type:Boolean,attribute:"collapsed"},config:{name:"config",type:Object,attribute:"config"},controls:{name:"controls",type:String,attribute:"controls"},editor:{name:"editor",type:Object,attribute:"editor"},id:{name:"id",type:String,attribute:"id",reflect:!0},moreIcon:{name:"moreIcon",type:String,attribute:"more-icon"},moreLabel:{name:"moreLabel",type:String,attribute:"more-label"},moreLabelToggled:{name:"moreLabelToggled",type:String,attribute:"more-label-toggled",value:"Fewer Buttons"},moreShowTextLabel:{name:"moreShowTextLabel",type:Boolean,attribute:"more-show-text-label"},responsiveSize:{name:"responsiveSize",type:String,attribute:"responsive-size",reflect:!0},savedSelection:{name:"savedSelection",type:Object},range:{name:"range",type:Object},sticky:{name:"sticky",type:Boolean,attribute:"sticky",reflect:!0},__buttons:{name:"__buttons",type:Array},__inlineWidgets:{name:"__inlineWidgets",type:Array},__selection:{type:Object},__shortcutKeys:{name:"__shortcutKeys",type:Array}}}constructor(){super(),import("../buttons/rich-text-editor-button.js"),import("../buttons/rich-text-editor-more-button.js"),import("../buttons/rich-text-editor-heading-picker.js"),import("../buttons/rich-text-editor-symbol-picker.js"),import("../buttons/rich-text-editor-underline.js"),import("../buttons/rich-text-editor-image.js"),import("../buttons/rich-text-editor-link.js"),import("../buttons/rich-text-editor-button-styles.js"),import("../../../../@polymer/iron-icons/iron-icons.js"),import("../../../../@polymer/iron-icons/editor-icons.js"),import("../../../../@polymer/iron-icons/image-icons.js"),import("../../../md-extra-icons/md-extra-icons.js"),this.__selection=window.RichTextEditorSelection.requestAvailability(),this.canceled=!0,this.collapsed=!0,this.config=[{label:"History",type:"button-group",buttons:[{command:"undo",icon:"undo",label:"Undo",shortcutKeys:"ctrl+z",type:"rich-text-editor-button"},{command:"redo",icon:"redo",label:"Redo",shortcutKeys:"ctrl+shift+z",type:"rich-text-editor-button"}]},{label:"Basic Inline Operations",type:"button-group",buttons:[{label:"Format",type:"rich-text-editor-heading-picker"},{command:"bold",icon:"editor:format-bold",label:"Bold",shortcutKeys:"ctrl+b",toggles:!0,type:"rich-text-editor-button"},{command:"italic",icon:"editor:format-italic",label:"Italics",shortcutKeys:"ctrl+i",toggles:!0,type:"rich-text-editor-button"},{command:"removeFormat",icon:"editor:format-clear",label:"Erase Format",type:"rich-text-editor-button"}]},{label:"Links",type:"button-group",buttons:[{icon:"link",label:"Link",shortcutKeys:"ctrl+k",type:"rich-text-editor-link"}]},{label:"Clipboard Operations",type:"button-group",buttons:[{command:"cut",icon:"content-cut",label:"Cut",shortcutKeys:"ctrl+x",type:"rich-text-editor-button"},{command:"copy",icon:"content-copy",label:"Copy",shortcutKeys:"ctrl+c",type:"rich-text-editor-button"},{command:"paste",icon:"content-paste",label:"Paste",shortcutKeys:"ctrl+v",type:"rich-text-editor-button"}]},{collapsedUntil:"md",label:"Subscript and Superscript",type:"button-group",buttons:[{command:"subscript",icon:"mdextra:subscript",label:"Subscript",toggles:!0,type:"rich-text-editor-button"},{command:"superscript",icon:"mdextra:superscript",label:"Superscript",toggles:!0,type:"rich-text-editor-button"}]},{collapsedUntil:"sm",icon:"editor:functions",label:"Insert Symbol",symbolTypes:["symbols"],type:"rich-text-editor-symbol-picker"},{collapsedUntil:"sm",label:"Lists and Indents",type:"button-group",buttons:[{command:"insertOrderedList",icon:"editor:format-list-numbered",label:"Ordered List",toggles:!0,type:"rich-text-editor-button"},{command:"insertUnorderedList",icon:"editor:format-list-bulleted",label:"Unordered List",toggles:!0,type:"rich-text-editor-button"},{collapsedUntil:"lg",command:"formatBlock",commandVal:"blockquote",label:"Blockquote",icon:"editor:format-quote",shortcutKeys:"ctrl+'",type:"rich-text-editor-button"},{command:"indent",icon:"editor:format-indent-increase",event:"text-indent",label:"Increase Indent",shortcutKeys:"ctrl+]",type:"rich-text-editor-button"},{command:"outdent",event:"text-outdent",icon:"editor:format-indent-decrease",label:"Decrease Indent",shortcutKeys:"ctrl+[",type:"rich-text-editor-button"}]}],this.moreIcon="more-vert",this.moreLabel="More Buttons",this.moreLabelToggled="Fewer Buttons",this.moreShowTextLabel=!1,this.responsiveSize="xs",this.sticky=!1,this.__inlineWidgets=[],this.__shortcutKeys=[],this.__clipboard=document.createElement("textarea"),this.__clipboard.setAttribute("aria-hidden",!0),this.__clipboard.style.position="absolute",this.__clipboard.style.left="-9999px",this.__clipboard.style.top="0px",this.__clipboard.style.width="0px",this.__clipboard.style.height="0px",document.body.appendChild(this.__clipboard),window.addEventListener("paste",this._handlePaste.bind(this)),navigator.clipboard&&this.addEventListener("paste-button",this._handlePasteButton)}firstUpdated(t){super.firstUpdated(t),this.__buttons=this._getButtons(),window.ResponsiveUtility.requestAvailability(),window.dispatchEvent(new CustomEvent("responsive-element",{detail:{element:this.shadowRoot.querySelector("#toolbar")}}))}updated(t){super.updated(t),t.forEach((t,e)=>{"sticky"===e&&this._stickyChanged(this.sticky,t),"range"===e&&this._rangeChange()})}connectedCallback(){super.connectedCallback()}get buttons(){return this.__buttons}_getButtons(){let t=this.shadowRoot&&this.shadowRoot.querySelector("#toolbar")?this.shadowRoot.querySelector("#toolbar"):void 0;if(t){let e=t.querySelector("#morebutton"),o=0,i=["xs","sm","md","lg","xl"],r=[];return t.innerHTML="",this.__shortcutKeys=[],this.config.forEach(s=>{if("button-group"===s.type){let e=document.createElement("div");e.setAttribute("class","group"),void 0!==s.collapsedUntil&&null!==s.collapsedUntil&&e.setAttribute("collapsed-until",s.collapsedUntil),o=Math.max(o,i.indexOf(s.collapsedUntil)),s.buttons.forEach(t=>{o=Math.max(o,i.indexOf(t.collapsedUntil)),(navigator.clipboard||"paste"!==t.command)&&r.push(this._addButton(t,e))}),t.appendChild(e)}else o=Math.max(o,i.indexOf(s.collapsedUntil)),(navigator.clipboard||"paste"!==s.command)&&r.push(this._addButton(s,t));t.appendChild(e),e.collapseMax=i[o]}),r}return[]}disconnectedCallback(){super.disconnectedCallback(),this.dispatchEvent(new CustomEvent("deselect-rich-text-editor-editor",{bubbles:!0,cancelable:!0,composed:!0,detail:{toolbar:this,editor:this.editor}}))}addEditableRegion(t){t.addEventListener("mousedown",e=>{this.editTarget(t)}),t.addEventListener("focus",e=>{this.editTarget(t)}),t.addEventListener("keydown",e=>{this._handleShortcutKeys(t,e)}),t.addEventListener("blur",t=>{null!==t.relatedTarget&&"rich-text-editor"!==!t.relatedTarget.startsWith||this.editTarget(null)}),t.addEventListener("click",e=>this._handleEditorClick(t,e))}_handleEditorClick(t,e){if(t.contentEditable&&e.path[0]!==t){let t=this.buttons.filter(t=>t.tag===e.path[0].tagName.toLowerCase()),o=!(!this.__selection||!this.__selection.range)&&this.__selection.range,i=!(!o||!o.startContainer)&&o.startContainer.childNodes[o.startOffset],r=!(!o||!o.endContainer)&&o.endContainer.childNodes[o.endOffset-1];t&&t[0]&&i===r&&i===e.path[0]?t[0]._buttonTap(e):t&&t[0]&&this.__selection.selectNode(e.path[0])}}cancel(){this.editor.innerHTML=this.canceled,this.editTarget(null)}editTarget(t){this.editor!==t&&(this.editor&&(this.editor.contentEditable=!1,this.editor=null),this.dispatchEvent(new CustomEvent("select-rich-text-editor-editor",{bubbles:!0,cancelable:!0,composed:!0,detail:{toolbar:this,editor:this.editor}})),this.editor=t,t?(t.parentNode.insertBefore(this,t),this.canceled=t.innerHTML,this.editor.contentEditable=!0,this.controls=t.getAttribute("id"),this._removeHighlight()):this.controls=null,console.log("editor change"),this.buttons.forEach(e=>{e.target=t,e.controls=this.controls,e.range=null,e.range=this.range}))}getRange(){let t=window.getSelection();return t.getRangeAt&&t.rangeCount?t.getRangeAt(0):t||void 0}getSanitizeClipboard(t){let e="<body(.*\n)*>(.*\n)*</body>";return t.match(e)&&t.match(e).length>0&&(t=t.match(e)[0].replace(/<\?body(.*\n)*\>/i)),t}makeEditableRegion(t){let e=document.createElement("rich-text-editor");t.parentNode.insertBefore(e,t),e.appendChild(t),this.addEditableRegion(e)}pasteIntoRange(t,e){let o=document.createElement("div"),i=(window.getSelection(),t.commonAncestorContainer.parentNode.closest("[contenteditable=true]:not([disabled]),input:not([disabled]),textarea:not([disabled])"));if(this.editor=i){for(o.innerHTML=e,t&&t.extractContents&&t.extractContents(),t.insertNode(o);o.firstChild;)o.parentNode.insertBefore(o.firstChild,o);o.parentNode.removeChild(o)}}removeEditableRegion(t){t.removeEventListener("mouseout",t=>{this.getUpdatedSelection()}),t.removeEventListener("focus",e=>{this.editTarget(t)}),t.removeEventListener("mousedown",e=>{this.editTarget(t)}),t.removeEventListener("keydown",e=>{this._handleShortcutKeys(t,e)}),t.removeEventListener("blur",t=>{null!==t.relatedTarget&&"rich-text-editor"!==!t.relatedTarget.startsWith||this.editTarget(null),this.getUpdatedSelection()})}_addButton(t,e){let o=document.createElement(t.type),i=o.shortcutKeys?o.shortcutKeys.replace(/ctrl\+[xcv]/g,""):"";for(var r in this.__shortcutKeys[i]=o,t)o[r]=t[r];return o.setAttribute("class","button"),o.addEventListener("deselect",t=>{console.log("button deselect",this.range,this.range.isCollapsed),this._removeHighlight(),console.log("button deselect 2",this.range,this.range.isCollapsed)}),o.inlineWidget&&this.push("__inlineWidgets",o.tag),e.appendChild(o),o}_addHighlight(){console.log("_addHighlight",this.range),this.__selection&&this.__selection.addHighlight()}_removeHighlight(){console.log("_removeHighlight",this.range),this.__selection&&this.__selection.removeHighlight()}_handleKeyboardShortcuts(t){console.log("_handleKeyboardShortcuts",t)}_handleShortcutKeys(t,e){if(t.contentEditable){let t=e.key;e.shiftKey&&(t="shift+"+t),e.altKey&&(t="alt+"+t),("MacIntel"===window.navigator.platform&&e.metaKey||e.ctrlKey)&&(t="ctrl+"+t),this.__shortcutKeys[t]&&this.__shortcutKeys[t]._keysPressed(e)}}_handlePaste(t){let e="";t&&(t.clipboardData||t.originalEvent.clipboardData)?e=(t.originalEvent||t).clipboardData.getData("text/html"):window.clipboardData&&(e=window.clipboardData.getData("Text")),this.pasteIntoRange(this.__selection.getRange(),this.getSanitizeClipboard(e)),t.preventDefault()}_handlePasteButton(t){setTimeout(async()=>{let e=t.detail.range,o=window.getSelection(),i=await navigator.clipboard.readText();this.__clipboard.value=i,this.__clipboard.focus(),this.__clipboard.select(),document.execCommand("paste"),o.removeAllRanges(),o.addRange(e),this.pasteIntoRange(e,this.getSanitizeClipboard(this.__clipboard.value))},2e3),t.preventDefault()}_rangeChange(){document.activeElement===this.editor&&(console.log("toolbar _rangeChange",this.range),this.buttons.forEach(t=>{t.range=null,t.range=this.range}))}_stickyChanged(t,e){this.__breadcrumbs&&(this.__breadcrumbs.sticky=this.sticky)}_toggleMore(t){this.collapsed=!this.collapsed}}};class RichTextEditorToolbar extends(RichTextEditorToolbarBehaviors(t)){}window.customElements.define(RichTextEditorToolbar.tag,RichTextEditorToolbar);export{RichTextEditorToolbar,RichTextEditorToolbarBehaviors};