/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as e,css as r}from"../../lit-element/lit-element.js";import{RichTextEditorStyles as o}from"./lib/rich-text-editor-styles.js";import"../../@polymer/iron-a11y-keys/iron-a11y-keys.js";import"./lib/toolbars/rich-text-editor-toolbar.js";import"./lib/toolbars/rich-text-editor-toolbar-mini.js";import"./lib/toolbars/rich-text-editor-toolbar-full.js";class RichTextEditor extends(o(t)){static get styles(){return[...super.styles,r`
        :host([hidden]) {
          display: none;
        }

        :host {
          display: block;
          min-height: 20px;
          cursor: pointer;
        }

        :host([contenteditable="true"]) {
          border: var(--rich-text-editor-border);
          overflow: auto;
        }

        :host([contenteditable="true"]):focus-within,
        :host([contenteditable="true"]):focus {
          padding: 2px;
          margin-bottom: 2px;
        }

        :host(.heightmax[contenteditable="true"]) {
          max-height: calc(100vh - 200px);
          overflow-y: scroll;
        }

        :host(:empty) {
          border: 1px dashed var(--rich-text-editor-border-color);
        }

        :host(:not([contenteditable="true"]):empty):before {
          content: attr(placeholder);
          padding: 0 5px;
          display: block;
          color: var(--rich-text-editor-button-disabled-color);
        }
      `]}render(){return e` <slot></slot>`}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!1,gizmo:{title:"Rich text-editor",description:"a standalone rich text editor",icon:"icons:android",color:"green",groups:["Text"],handles:[{type:"todo:read-the-docs-for-usage"}],meta:{author:"nikkimk",owner:"Penn State University"}},settings:{quick:[],configure:[{property:"title",description:"",inputMethod:"textfield",required:!1,icon:"icons:android"}],advanced:[]}}}static get properties(){return{...super.properties,id:{name:"id",type:String,reflect:!0,attribute:"id"},placeholder:{name:"placeholder",type:String,reflect:!0,attribute:"placeholder"},toolbar:{name:"toolbar",type:String,reflect:!0,attribute:"toolbar"},type:{name:"type",type:String,reflect:!0,attribute:"type"}}}static get tag(){return"rich-text-editor"}constructor(){super(),this.placeholder="Click to edit",this.toolbar="",this.type="rich-text-editor-toolbar",this.id=""}connectedCallback(){super.connectedCallback(),this.id||(this.id=this._generateUUID()),this.getEditor(),window.RichTextEditorStyleManager.requestAvailability()}getEditor(){let t=this.toolbar?"#"+this.toolbar:"",e=document.querySelector(this.type+t),r=t?document.querySelector(t):null,o=document.querySelector(this.type),i=e||r||o;this.toolbar||(this.toolbar=this._generateUUID()),i&&i.addEditableRegion||(i=document.createElement(this.type),i.id=this.toolbar,this.parentNode.appendChild(i)),i.addEditableRegion(this)}_getRange(){let t=window.getSelection();return t.getRangeAt&&t.rangeCount?t.getRangeAt(0):t||void 0}_generateUUID(){let t=Math.floor(65536*(1+Math.random())).toString(16).substring(1);return"rte-"+"ss-s-s-s-sss".replace(/s/g,t)}}window.customElements.define(RichTextEditor.tag,RichTextEditor);export{RichTextEditor};