/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 *
 * Based on https://github.com/TherapyChat/rss-items
 */
import{LitElement as e,html as t,css as i}from"../../lit-element/lit-element.js";import"../es-global-bridge/es-global-bridge.js";import"../../@polymer/iron-ajax/iron-ajax.js";class RssItems extends e{static get styles(){return[i`
        :host([hidden]) {
          display: none;
        }

        :host {
          display: flex;
          flex-wrap: wrap;
          flex-direction: row;
          align-items: flex-start;
          justify-content: space-between;
        }

        :host * {
          box-sizing: border-box;
        }

        h3,
        p {
          margin: 0;
        }

        a {
          color: var(--primary-color, inherit);
          text-decoration: none;
        }

        article {
          margin-bottom: 2em;
        }

        .thumbnail-container {
          display: block;
          overflow: hidden;
          width: 100%;
          height: 180px;
        }

        .thumbnail {
          width: 100%;
          height: 100%;
          transition: transform 0.5s ease-out;
        }

        .thumbnail-container:hover .thumbnail,
        .thumbnail-container:focus .thumbnail {
          transform: scale3d(1.3, 1.3, 1);
        }

        .title {
          min-height: 3em;
          margin: 1em 0 0.5em;
        }

        .excerpt {
          min-height: 6em;
          margin: 0.5em 0 2em;
        }

        @media (max-width: 599px) {
          .title,
          .excerpt {
            min-height: 0;
          }
        }

        @media (min-width: 600px) {
          article {
            flex: 1 1 40%;
            margin-right: 2em;
          }

          article:nth-of-type(2n),
          article:last-of-type {
            margin-right: 0;
          }
        }

        @media (min-width: 900px) {
          article {
            flex: 1 1 30%;
          }

          article:nth-of-type(2n) {
            margin-right: 2em;
          }

          article:nth-of-type(3n) {
            margin-right: 0;
          }
        }
      `]}render(){return t` <iron-ajax
        id="rssajax"
        url="${this.url}"
        handle-as="xml"
        @last-response-changed="${this.xmlEvent}"
      ></iron-ajax>
      ${this.items.map(e=>t`
          <article>
            ${e.imageSrc?t`
                  <a
                    class="thumbnail-container"
                    href="${e.link}"
                    title="${e.title}"
                  >
                    <iron-image
                      class="thumbnail"
                      src="${e.imageSrc}"
                      alt="${e.title}"
                      sizing="cover"
                    ></iron-image>
                  </a>
                `:""}
            <a href="${e.link}" title="${e.title}">
              <span class="title"
                >${this._truncateText(e.title,this.maxTitleLength)}</span
              >
            </a>
            <div class="excerpt">
              ${this._truncateText(e.excerpt,this.maxExcerptLength)}
            </div>
            ${this.showReadMore?t`
                  <a
                    tabindex="-1"
                    href="${e.link}"
                    class="read-more"
                    title="${e.title}"
                    >${this.readMoreAnchorText}
                    <paper-icon-button
                      icon="icons:arrow-forward"
                      class="read-more-icon"
                      alt="${this.readMoreImageAlt}"
                    ></paper-icon-button>
                  </a>
                `:""}
          </article>
        `)}`}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!1,gizmo:{title:"Rss feed",description:"visualize RSS items",icon:"communication:rss-feed",color:"orange",groups:["RSS"],handles:[{type:"rss",source:"source"}],meta:{author:"btopro",owner:"The Pennsylvania State University"}},settings:{quick:[],configure:[{property:"url",title:"Feed URL",description:"URL to the XML feed",inputMethod:"textfield"},{property:"max",title:"Max items",description:"Max number of feed items to display",inputMethod:"number"}],advanced:[]}}}static get properties(){return{...super.properties,auto:{type:Boolean},items:{type:Array},max:{type:Number},maxExcerptLength:{type:Number,attribute:"max-excerpt-length"},maxTitleLength:{type:Number,attribute:"max-title-length"},readMoreAnchorText:{type:Boolean,attribute:"read-more-anchor-text"},readMoreImageAlt:{type:Boolean,attribute:"read-more-image-alt"},showReadMore:{type:Boolean,attribute:"show-read-more"},url:{type:String},xml:{type:Object}}}static get tag(){return"rss-items"}initRequest(){this.shadowRoot.querySelector("#rssajax").generateRequest()}_maxChanged(e){this.xml&&e&&this._x2js&&this.__ready&&this.xmlToItems(this.xml)}xmlToItems(e){if(e&&this._x2js&&this.__ready){var t=(new X2JS).xml2json(e);if(t){var i=t.rss?t.rss.channel.item:t.channel.item;i=void 0===this.max?i:i.splice(0,this.max),this.items=[...this._parseItems(i)]}}}_urlChanged(e){e&&this._x2js&&this.__ready&&this.initRequest()}xmlEvent(e){this.xml={},setTimeout(()=>{this.xml=e.detail.value},0)}_parseItems(e){return e.map(e=>(e.excerpt=this._getItemExcerpt(e),e.imageSrc=this._getItemImageScr(e),e))}_getItemExcerpt(e){var t=document.createElement("div");return t.innerHTML=e.description,t.textContent.trim()}_getItemImageScr(e){if(e.thumbnail&&e.thumbnail._url)return e.thumbnail._url;var t=document.createElement("div");return t.innerHTML=e.description,(t.querySelector("img")||{}).src||""}_truncateText(e,t){if(e)return t&&e.length>t?e.substr(0,t)+"...":e}pathFromUrl(e){return e.substring(0,e.lastIndexOf("/")+1)}updated(e){e.forEach((e,t)=>{if(["items"].includes(t)){let e=t.replace(/([a-z0-9]|(?=[A-Z]))([A-Z])/g,"$1-$2").toLowerCase()+"-changed";this.dispatchEvent(new CustomEvent(e,{detail:{value:this[t]}}))}"max"==t&&this._maxChanged(this[t],e),"url"==t&&this._urlChanged(this[t],e),"xml"==t&&this.xmlToItems(this[t],e)})}constructor(){super(),this.items=[],this.auto=!1,this.max=10,this.maxExcerptLength=100,this.maxTitleLength=50,this.readMoreAnchorText="Read more",this.readMoreImageAlt="",this.showReadMore=!1,import("../../@polymer/iron-image/iron-image.js"),import("../../@polymer/paper-icon-button/paper-icon-button.js"),import("../../@polymer/iron-icons/iron-icons.js");const e="x2js",t=this.pathFromUrl(decodeURIComponent(import.meta.url))+"lib/x2js.js";window.ESGlobalBridge.requestAvailability(),window.ESGlobalBridge.instance.load(e,t),window.addEventListener("es-bridge-x2js-loaded",this._x2jsLoaded.bind(this))}_x2jsLoaded(e){this._x2js=!0,this.__ready&&(this.auto?this.shadowRoot.querySelector("#rssajax").auto=this.auto:this.initRequest())}firstUpdated(){this.__ready=!0,this._x2js&&(this.auto?this.shadowRoot.querySelector("#rssajax").auto=this.auto:this.initRequest())}disconnectedCallback(){window.removeEventListener(`es-bridge-${name}-loaded`,this._x2jsLoaded.bind(this)),super.disconnectedCallback()}}window.customElements.define(RssItems.tag,RssItems);export{RssItems};