/**
 * Copyright 2019 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as e,css as l}from"../../../lit-element/lit-element.js";import"../simple-modal.js";class SimpleModalTemplate extends t{static get styles(){return[l`
        :host {
          display: none;
          --simple-modal-width: auto;
          --simple-modal-height: auto;
          --simple-modal-min-width: unset;
          --simple-modal-min-height: unset;
          --simple-modal-max-width: unset;
          --simple-modal-max-height: unset;
          --simple-modal-titlebar-color: #444;
          --simple-modal-titlebar-background: #ddd;
          --simple-modal-header-color: #222;
          --simple-modal-header-background: #ccc;
          --simple-modal-content-container-color: #222;
          --simple-modal-content-container-background: #fff;
          --simple-modal-buttons-color: blue;
          --simple-modal-buttons-background: #fff;
          --simple-modal-button-color: var(--simple-modal-buttons-color);
          --simple-modal-button-background: var(
            --simple-modal-buttons-background-color
          );
        }
      `]}static get tag(){return"simple-modal-template"}constructor(){super(),this.title="",this.modal=window.SimpleModal.requestAvailability()}static get properties(){return{modal:{type:Object},title:{type:String}}}render(){return e`
      <slot name="header"></slot> <slot name="content"></slot>
      <slot name="buttons"></slot>
    `}associateEvents(t,e="click",l=!0,o=!0){return t.addEventListener(e,e=>{this.openModal(t,l,o)}),this.modal}openModal(t,e=!0,l=!0){let o=getComputedStyle(this),i={};["--simple-modal-width","--simple-modal-height","--simple-modal-min-width","--simple-modal-min-height","--simple-modal-max-width","--simple-modal-max-height","--simple-modal-titlebar-color","--simple-modal-titlebar-background","--simple-modal-header-color","--simple-modal-header-background","--simple-modal-content-container-color","--simple-modal-content-container-background","--simple-modal-buttons-color","--simple-modal-buttons-background","--simple-modal-button-color","--simple-modal-button-background","--simple-modal-titlebar-button-border","--simple-modal-titlebar-button-padding","--simple-modal-titlebar-button-outline","--simple-modal-titlebar-button-outline-offset","--simple-modal-titlebar-icon-width","--simple-modal-titlebar-icon-height"].forEach(t=>{i[t]=o.getPropertyValue(t)});const a=new CustomEvent("simple-modal-show",{bubbles:e,cancelable:l,composed:!0,detail:{id:this.getAttribute("modal-id"),elements:{header:this._getSlot("header"),content:this._getSlot("content"),buttons:this._getSlot("buttons")},invokedBy:t,modalClass:this.getAttribute("class"),styles:i,clone:!1,title:null!==this.title&&this.title}});window.dispatchEvent(a)}_getSlot(t){let e=this.querySelectorAll('[slot="'+t+'"]');e&&e[0]&&"SLOT"==e[0].tagName&&(e=e[0].assignedNodes({flatten:!0}));let l=document.createElement("div");return e.forEach(t=>{l.appendChild(t.cloneNode(!0))}),null!==e&&l.cloneNode(!0)}}window.customElements.define(SimpleModalTemplate.tag,SimpleModalTemplate);export{SimpleModalTemplate};