/**
 * Copyright 2018 The Pennsylvania State University
 * @license Apache-2.0, see License.md for full text.
 */
import{LitElement as t,html as e,css as i}from"../../lit-element/lit-element.js";window.SimpleToast=window.SimpleToast||{},window.SimpleToast.requestAvailability=()=>(window.SimpleToast.instance||(window.SimpleToast.instance=document.createElement("simple-toast"),document.body.appendChild(window.SimpleToast.instance)),window.SimpleToast.instance);class SimpleToast extends t{static get styles(){return[i`
        :host {
          display: block;
        }

        :host([hidden]) {
          display: none;
        }

        paper-button:not(:defined),
        paper-toast:not(:defined) {
          display: none;
        }

        paper-toast {
          width: var(--simple-toast-width, inherit);
          height: var(--simple-toast-height, inherit);
          color: var(--simple-toast-color, white);
          background-color: var(--simple-toast-bg, black);
          top: var(--simple-toast-top, inherit);
          margin: var(--simple-toast-margin, 16px);
          padding: var(--simple-toast-padding, 16px);
          left: var(--simple-toast-left, inherit);
          bottom: var(--simple-toast-bottom, inherit);
          right: var(--simple-toast-right, inherit);
          border: var(--simple-toast-border, inherit);
          z-index: var(--simple-toast-z-index, inherit);
          font-size: var(--simple-toast-font-size, inherit);
        }
      `]}render(){return e` <paper-toast
      id="toast"
      text="${this.text}"
      duration="${this.duration}"
      ?opened="${this.opened}"
      @opened-changed="${this.openedChanged}"
      .class="${this.classStyle}"
    >
      <slot></slot>
      <paper-button .hidden="${!this.closeButton}" @click="${this.hide}"
        >${this.closeText}</paper-button
      >
    </paper-toast>`}static get properties(){return{...super.properties,opened:{type:Boolean,reflect:!0},text:{type:String},classStyle:{type:String,attribute:"class-style"},closeText:{type:String,attribute:"close-text"},duration:{type:Number},eventCallback:{type:String,attribute:"event-callback"},closeButton:{type:Boolean,reflect:!0,attribute:"close-button"}}}static get tag(){return"simple-toast"}constructor(){super(),this.setDefaultToast()}firstUpdated(){setTimeout(()=>{import("../../@polymer/paper-toast/paper-toast.js"),import("../../@polymer/paper-button/paper-button.js")},0)}connectedCallback(){super.connectedCallback(),window.addEventListener("simple-toast-hide",this.hideSimpleToast.bind(this)),window.addEventListener("simple-toast-show",this.showSimpleToast.bind(this))}disconnectedCallback(){window.removeEventListener("simple-toast-hide",this.hideSimpleToast.bind(this)),window.removeEventListener("simple-toast-show",this.showSimpleToast.bind(this)),super.disconnectedCallback()}hideSimpleToast(t){this.hide()}openedChanged(t){this.opened=t.detail.value}setDefaultToast(){for(this.opened=!1,this.text="Saved",this.classStyle="",this.closeText="Close",this.duration=4e3,this.eventCallback=null,this.closeButton=!0;null!==this.firstChild;)this.removeChild(this.firstChild)}showSimpleToast(t){this.setDefaultToast(),t.detail.duration&&(this.duration=t.detail.duration),t.detail.text&&(this.text=t.detail.text),t.detail.classStyle&&(this.classStyle=t.detail.classStyle),t.detail.closeText&&(this.closeText=t.detail.closeText),t.detail.closeButton&&(this.closeButton=t.detail.closeButton),t.detail.eventCallback&&(this.eventCallback=t.detail.eventCallback),t.detail.slot&&this.appendChild(t.detail.slot),setTimeout(()=>{this.show()},5)}show(t){this.opened=!0}hide(t){if(this.eventCallback){const t=new CustomEvent(this.eventCallback,{bubbles:!0,cancelable:!0,detail:!0,composed:!0});this.dispatchEvent(t)}this.opened=!1}}window.customElements.define(SimpleToast.tag,SimpleToast);export{SimpleToast};