import{LitElement as t,html as o,css as e}from"../../lit-element/lit-element.js";import{SchemaBehaviors as i}from"../schema-behaviors/schema-behaviors.js";class StopNote extends(i(t)){static get styles(){return[e`
        :host {
          display: block;
          width: auto;
          --background-color: #f7f7f7;
          --accent-color: #d32f2f;
          margin-bottom: 20px;
        }

        iron-icon {
          height: 100px;
          width: 100px;
        }

        :host([icon="stopnoteicons:stop-icon"]) {
          --accent-color: #d8261c;
        }

        :host([icon="stopnoteicons:warning-icon"]) {
          --accent-color: #ffeb3b;
        }

        :host([icon="stopnoteicons:confirm-icon"]) {
          --accent-color: #81c784;
        }

        :host([icon="stopnoteicons:book-icon"]) {
          --accent-color: #21a3db;
        }

        .container {
          display: flex;
          width: auto;
        }

        .message_wrap {
          border-right: 7px solid var(--accent-color);
          padding: 10px 25px;
          flex: 1 1 auto;
          background-color: var(--background-color);
        }

        .main_message {
          font-size: 32px;
          margin-top: 10px;
        }

        .secondary_message {
          margin-top: 5px;
          font-size: 19.2px;
          float: left;
        }

        .link a {
          margin-top: 5px;
          font-size: 19.2px;
          float: left;
          clear: left;
          text-decoration: none;
          color: #2196f3;
        }

        .link a:hover {
          color: #1976d2;
        }

        .svg {
          display: flex;
          justify-content: center;
        }

        .svg_wrap {
          background-color: var(--accent-color);
          padding: 5px;
          width: auto;
        }
      `]}render(){return o`
      <div class="container">
        <div class="svg_wrap">
          <div class="svg"><iron-icon icon="${this.icon}"></iron-icon></div>
        </div>
        <div class="message_wrap">
          <div class="main_message">${this.title}</div>
          <div class="secondary_message"><slot name="message"></slot></div>
          ${this.url?o`
                <div class="link">
                  <a href="${this.url}" id="link"> More Information &gt; </a>
                </div>
              `:""}
        </div>
      </div>
    `}static get tag(){return"stop-note"}constructor(){super(),import("../../@polymer/iron-icon/iron-icon.js"),import("./lib/stop-icon.js"),this.url=null,this.icon="stopnoteicons:stop-icon"}static get properties(){return{title:{type:String},url:{type:String},icon:{type:String}}}updated(t){t.forEach((t,o)=>{"url"==o&&this._urlTarget(this[o])})}_urlTarget(t){if(t){if(this._outsideLink(t)){let t=this.shadowRoot.querySelector("#link");t.setAttribute("target","_blank"),t.setAttribute("rel","noopener noreferrer")}}}_outsideLink(t){if(0!=t.indexOf("http"))return!1;var o=location.href,e=location.pathname,i=o.substring(0,o.indexOf(e));return 0!=t.indexOf(i)}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!1,gizmo:{title:"Stop Note",description:"A message to alert readers to specific directions.",icon:"icons:report",color:"orange",groups:["Education","Content"],handles:[{type:"text",title:"label"}],meta:{author:"ELMS:LN"}},settings:{quick:[{property:"title",title:"Title",description:"Enter title for stop-note.",inputMethod:"textfield",required:!0},{property:"url",title:"URL",description:"Enter an external url.",inputMethod:"textfield",required:!0}],configure:[{property:"title",title:"Title",description:"Enter title for stop-note.",inputMethod:"textfield",required:!0},{property:"url",title:"URL",description:"Enter an external url.",inputMethod:"haxupload",required:!0},{slot:"message",title:"Message",description:"Enter a message for stop-note.",inputMethod:"code-editor",required:!0},{property:"icon",title:"Action Icon",description:"Icon used for stop-note",inputMethod:"iconpicker",options:["stopnoteicons:stop-icon","stopnoteicons:warning-icon","stopnoteicons:confirm-icon","stopnoteicons:book-icon"]}],advanced:[]},demoSchema:[{tag:"stop-note",properties:{title:"Hold up there"},content:'<span slot="message"><strong>Read these important things!</strong>\n</span>\n'},{tag:"stop-note",properties:{title:"Warning",icon:"stopnoteicons:warning-icon"},content:'<span slot="message">You can write any warning message you want here.</span>\n'}]}}}window.customElements.define(StopNote.tag,StopNote);export{StopNote};