import{LitElement as e,html as t,css as a}from"../../lit-element/lit-element.js";class ThreadedDiscussion extends e{static get styles(){return[a`
        :host {
          display: block;
          font-size: var(--threaded-discussion-FontSize, 14px);
          line-height: var(--threaded-discussion-LineHeight, 160%);
          color: var(--threaded-discussion-Color, #95989a);
        }
        :host([hidden]) {
          display: none;
        }
        #threads {
          background-color: var(
            --threaded-discussion-threads-BackgroundColor,
            #eaeaea
          );
          padding: 1px;
          width: calc(100% - 2px);
          margin: var(--threaded-discussion-threads-Margin, 0);
        }
        #new-thread {
          background-color: var(
            --threaded-discussion-new-thread-BackgroundColor,
            var(--threaded-discussion-threads-BackgroundColor, #eaeaea)
          );
          padding: 2px 1px;
          width: calc(100% - 2px);
          margin: var(
            --threaded-discussion-new-thread-Margin,
            var(--threaded-discussion-threads-Margin, 0)
          );
        }
        .thread:focus-within,
        #new-thread:focus-within {
          border-left: var(
            --threaded-discussion-thread-focus-BorderLeft,
            4px solid blue
          );
        }
        #new-thread:focus-within {
          border-left: var(--threaded-discussion-new-thread-focus-BorderLeft);
        }
        .thread > *,
        #new-thread > * {
          background-color: var(
            --threaded-discussion-comment-BackgroundColor,
            #fff
          );
        }
        .comment {
          margin: 1px 1px 0;
          padding: var(--threaded-discussion-comment-Padding, 10px) 0;
        }
        .reply-form {
          margin: 0;
          width: calc(
            100% -
              var(
                --threaded-discussion-reply-indent,
                calc(2 * var(--threaded-discussion-comment-Padding, 10px))
              )
          );
        }
        .reply-form,
        .comment-reply {
          margin-left: var(
            --threaded-discussion-reply-indent,
            calc(2 * var(--threaded-discussion-comment-Padding, 10px))
          );
        }
        .comment-header {
          display: flex;
          align-items: stretch;
          justify-content: space-between;
          margin-bottom: var(--threaded-discussion-comment-Padding, 10px);
        }
        .comment-header,
        .comment-body {
          padding: 0 var(--threaded-discussion-comment-Padding, 10px);
        }
        lrndesign-avatar {
          margin-right: var(--threaded-discussion-comment-Padding, 10px);
        }
        .comment-header > div {
          display: flex;
          flex-direction: column;
          justify-content: space-evenly;
          align-items: flex-start;
          flex: 1 1 auto;
        }
        .comment-name {
          margin: 0;
          font-size: var(
            --threaded-discussion-name-FontSize,
            calc(1.1 * var(--threaded-discussion-FontSize, 14px))
          );
          font-weight: var(--threaded-discussion-name-FontWeight, bold);
          font-family: var(--threaded-discussion-name-FontFamily);
          color: var(--threaded-discussion-name-Color, #4b4b4b);
        }
        .comment-date {
          margin: 0;
          font-size: var(
            --threaded-discussion-date-FontSize,
            calc(0.8 * var(--threaded-discussion-FontSize, 14px))
          );
          font-weight: var(--threaded-discussion-date-FontWeight, normal);
          font-family: var(--threaded-discussion-date-FontFamily);
          color: var(
            --threaded-discussion-date-Color,
            var(--threaded-discussion-Color, #95989a)
          );
        }
        .comment-body {
          font-size: var(--threaded-discussion-FontSize, 14px);
        }
      `]}render(){return t`
      <slot name="before-discussion"></slot>
      ${this.latest?"":this.threads}
      <div id="new-thread">
        <slot name="before-new-thread"></slot>
        <threaded-discussion-form
          button-label="${this.commentButtonLabel||"Submit"}"
          class="comment-form"
          @comment-demo="${this._handleDemo}"
          @comment-submitted="${this._handleSubmit}"
          ?demo="${this.demo}"
          field="${this.map.body||"body"}"
          .icon="${this.commentIcon}"
          ?hidden="${this.hidden}"
          ?disabled="${this.disabled}"
          .submit="${this._getPath(this.submit,this.params)}"
          textarea-label="${this.commentTextareaLabel||"Enter comment"}"
        >
        </threaded-discussion-form>
        <slot name="after-new-thread"></slot>
      </div>
      ${this.latest?this.threads:""}
      <slot name="after-discussion"></slot>
    `}get threads(){return t`
      <div id="threads">
        <div class="thread" ?hidden="${!this.__loading}">
          ${this.loadingText}
        </div>
        ${this.sortData(this.__data).map(e=>t`
            <div class="thread">
              ${this.getComment(e)}
              ${(e.replies||[]).map(t=>this.getComment(t,e.id))}
              <threaded-discussion-form
                button-label="${this.replyButtonLabel||"Reply"}"
                class="reply-form"
                @comment-demo="${this._handleDemo}"
                @comment-submitted="${this._handleSubmit}"
                ?demo="${this.demo}"
                field="${this.map.replyBody||this.map.body||"body"}"
                ?disabled="${this.disabled}"
                ?hidden="${this.hidden}"
                .icon="${this.replyIcon}"
                .submit="${this._getPath(this.submit,this._getThreadParams(e.id))}"
                textarea-label="${this.replyTextareaLabel||"Enter reply"}"
                .thread="${e.id}"
              >
              </threaded-discussion-form>
            </div>
          `)}
      </div>
    `}getComment(e,a){return t`
      <div
        aria-describedby="${a||""}"
        class="comment ${a?"comment-reply":""}"
        id="comment-${e.id}"
      >
        <div class="comment-header">
          <lrndesign-avatar
            .accent-color="${e.color}"
            .label="${e.firstName} ${e.lastName}"
            .src="${e.avatar}"
            two-chars
          >
          </lrndesign-avatar>
          <div>
            <p class="comment-name">${e.firstName} ${e.lastName}</p>
            <p class="comment-date">${this._getDate(e.date)}</p>
          </div>
        </div>
        <div class="comment-body">
          ${(e.body||"").split(/[\r\n]+/).map(e=>t` <p>${e}</p> `)}
        </div>
      </div>
    `}static get tag(){return"threaded-discussion"}static get properties(){return{latest:{type:Boolean,attribute:"latest",reflect:!0},commentButtonLabel:{type:String,attribute:"comment-button-label"},commentTextareaLabel:{type:String,attribute:"comment-textarea-label"},commentIcon:{type:String,attribute:"comment-icon"},data:{type:Object},dateLocale:{type:String},dateFormat:{type:Object},demo:{type:Boolean},loadingText:{type:String,attribute:"loading-text"},map:{type:Object},params:{type:Object},replyButtonLabel:{type:String,attribute:"reply-button-label",reflect:!0},replyTextareaLabel:{type:String,attribute:"reply-textarea-label",reflect:!0},replyIcon:{type:String,attribute:"reply-icon",reflect:!0},source:{type:String},submit:{type:String},__data:{type:Array},__loading:{type:Boolean}}}constructor(){super(),this.latest=!1,this.data=[],this.dateLocale="en-US",this.dateFormat={year:"numeric",month:"long",day:"numeric",hour:"numeric",minute:"2-digit"},this.demo=!1,this.map={},this.params={},this.submit=window.location.href,this.__data=[],this.__loading=!1,import("../lrndesign-avatar/lrndesign-avatar.js"),import("../../@polymer/iron-icon/iron-icon.js"),import("../../@polymer/iron-icons/iron-icons.js"),import("./lib/threaded-discussion-form.js")}updated(e){super.updated&&super.updated(e),e.forEach((e,t)=>{["params","source"].includes(t)&&this.source&&(this.__loading=!0,this.fetchDiscussion())})}sortData(e){return e.sort((e,t)=>{let a="string"==typeof e.date?Date.parse(e.date):e.date,i="string"==typeof t.date?Date.parse(t.date):t.date;return this.latest?i-a:a-i})}_handleRawData(e){return this.__loading=!1,this._getArray(e||[]).filter(e=>!this._getMap(e,"thread","replyThread")).map(t=>{let a=this._getMap(t,"id"),i=this._getMap(t,"replies")||(e||[]).filter(e=>this._getMap(e,"thread","replyThread")===a);return{id:a,firstName:this._getMap(t,"firstName"),lastName:this._getMap(t,"lastName"),avatar:this._getMap(t,"avatar"),body:this._getMap(t,"body"),color:this._getMap(t,"color"),date:this._getMap(t,"date"),replies:this._getArray(i).map(e=>({id:this._getMap(e,"id","replyId"),thread:this._getMap(e,"thread","replyThread")||a,firstName:this._getMap(e,"firstName","replyFirstName"),lastName:this._getMap(e,"lastName","replyLastName"),avatar:this._getMap(e,"avatar","replyAvatar"),body:this._getMap(e,"body","replyBody"),color:this._getMap(e,"color","replyColor"),date:this._getMap(e,"date","replyDate")}))}})}_getMap(e,t,a,i){return e[this._mapProp(t,a,i)]}_mapProp(e,t,a){let i=this.map||{};return t=t||e,i[a=a||t]||i[t]||e}_handleSubmit(e){this.fetchDiscussion()}_handleDemo(e){if(e.detail&&e.detail.textarea){let t={},a=this.__data;if(t.id="comment-"+Date.now(),t.firstName="DEMO",t.lastName="USER",t.date=this._getDate(new Date),t.body=e.detail.textarea.value,e.detail.thread){let i=a.filter(t=>t.id===e.detail.thread),s=i?i[0]:void 0;t.thread=e.detail.thread,s?s.replies=[...s.replies,t]:a.push(t)}else t.replies=[],a.push(t);this.__data=[],this.__data=a,e.detail.textarea.value=""}}fetchDiscussion(){fetch(this._getPath(this.source,this.params)).then(e=>e.json()).then(e=>this.__data=this._handleRawData(e))}_getArray(e){return"array"==typeof e?e:Object.keys(e||{}).map(t=>{let a=e[t];return a.id=t,a})}_getDate(e){let t="string"==typeof this.dateFormat?JSON.parse(this.dateFormat):this.dateFormat;return e&&new Date(e)?new Date(e).toLocaleString(this.dateLocale,t):""}_getThreadParams(e){let t=this.params;return t[this._mapProp("id")]=e,t}_getPath(e,t){let a=Object.keys(t||{}).map(e=>`${encodeURI(e)}=${encodeURI(t[e])}`).join("&");return a?`${e}?${a}`:e}}window.customElements.define(ThreadedDiscussion.tag,ThreadedDiscussion);export{ThreadedDiscussion};