define(["../../../vaadin-material-styles/color.js", "../../../vaadin-material-styles/typography.js", "../../../vaadin-material-styles/mixins/required-field.js", "../../../vaadin-material-styles/font-icons.js", "../../../vaadin-material-styles/mixins/field-button.js", "../../../../@polymer/polymer/lib/utils/html-tag.js"], function (_color, _typography, _requiredField, _fontIcons, _fieldButton, _htmlTag) {
  "use strict";

  function _templateObject_e709494001a111ebb416cb2b1003c1c5() {
    var data = babelHelpers.taggedTemplateLiteral(["<dom-module id=\"material-text-field\" theme-for=\"vaadin-text-field\">\n  <template>\n    <style include=\"material-required-field material-field-button\">\n      :host {\n        display: inline-flex;\n        position: relative;\n        padding-top: 8px;\n        margin-bottom: 8px;\n        outline: none;\n        color: var(--material-body-text-color);\n        font-size: var(--material-body-font-size);\n        line-height: 24px;\n        font-family: var(--material-font-family);\n        -webkit-font-smoothing: antialiased;\n        -moz-osx-font-smoothing: grayscale;\n      }\n\n      :host::before {\n        line-height: 32px;\n      }\n\n      /* Strange gymnastics to make fields vertically align nicely in most cases\n         (no label, with label, without prefix, with prefix, etc.) */\n\n      :host([has-label]) {\n        padding-top: 24px;\n      }\n\n      [part=\"label\"]:empty {\n        display: none;\n      }\n\n      [part=\"label\"]:empty::before {\n        content: \"\xA0\";\n        position: absolute;\n      }\n\n      [part=\"input-field\"] {\n        position: relative;\n        top: -0.2px; /* NOTE(platosha): Adjusts for wrong flex baseline in Chrome & Safari */\n        height: 32px;\n        padding-left: 0;\n        padding-right: 0;\n        background-color: transparent;\n        margin: 0;\n      }\n\n      [part=\"input-field\"]::before,\n      [part=\"input-field\"]::after {\n        content: \"\";\n        position: absolute;\n        bottom: 0;\n        left: 0;\n        right: 0;\n        height: 1px;\n        transform-origin: 50% 0%;\n        background-color: var(--_material-text-field-input-line-background-color, #000);\n        opacity: var(--_material-text-field-input-line-opacity, 0.42);\n      }\n\n      [part=\"input-field\"]::after {\n        background-color: var(--material-primary-color);\n        opacity: 0;\n        height: 2px;\n        bottom: 0;\n        transform: scaleX(0);\n        transition: opacity 0.175s;\n      }\n\n      :host([disabled]) [part=\"label\"],\n      :host([disabled]) [part=\"value\"],\n      :host([disabled]) [part=\"input-field\"] ::slotted(input),\n      :host([disabled]) [part=\"input-field\"] ::slotted(textarea),\n      :host([disabled]) [part=\"input-field\"] ::slotted([part=\"value\"]) {\n        color: var(--material-disabled-text-color);\n        -webkit-text-fill-color: var(--material-disabled-text-color);\n      }\n\n      [part=\"value\"],\n      :host([disabled]) [part=\"input-field\"] ::slotted(input),\n      :host([disabled]) [part=\"input-field\"] ::slotted(textarea),\n      /* Slotted by vaadin-select-text-field */\n      [part=\"input-field\"] ::slotted([part=\"value\"]) {\n        outline: none;\n        margin: 0;\n        border: 0;\n        border-radius: 0;\n        padding: 8px 0;\n        width: 100%;\n        height: 100%;\n        font-family: inherit;\n        font-size: 1em;\n        line-height: inherit;\n        color: inherit;\n        background-color: transparent;\n        /* Disable default invalid style in Firefox */\n        box-shadow: none;\n      }\n\n      /* TODO: the text opacity should be 42%, but the disabled style is 38%.\n      Would need to introduce another property for it if we want to be 100% accurate. */\n      [part=\"value\"]::-webkit-input-placeholder {\n        color: var(--material-disabled-text-color);\n        transition: opacity 0.175s 0.05s;\n        opacity: 1;\n      }\n\n      [part=\"value\"]:-ms-input-placeholder {\n        color: var(--material-disabled-text-color);\n      }\n\n      [part=\"value\"]::-moz-placeholder {\n        color: var(--material-disabled-text-color);\n        transition: opacity 0.175s 0.05s;\n        opacity: 1;\n      }\n\n      [part=\"value\"]::placeholder {\n        color: var(--material-disabled-text-color);\n        transition: opacity 0.175s 0.1s;\n        opacity: 1;\n      }\n\n      :host([has-label]:not([focused]):not([invalid]):not([theme=\"always-float-label\"])) [part=\"value\"]::-webkit-input-placeholder {\n        opacity: 0;\n        transition-delay: 0;\n      }\n\n      :host([has-label]:not([focused]):not([invalid]):not([theme=\"always-float-label\"])) [part=\"value\"]::-moz-placeholder {\n        opacity: 0;\n        transition-delay: 0;\n      }\n\n      :host([has-label]:not([focused]):not([invalid]):not([theme=\"always-float-label\"])) [part=\"value\"]::placeholder {\n        opacity: 0;\n        transition-delay: 0;\n      }\n\n      /* IE11 doesn\u2019t show the placeholder when the input is focused, so it\u2019s basically useless for this theme */\n      :host([has-label]) [part=\"value\"]:-ms-input-placeholder {\n        opacity: 0;\n      }\n\n      /* According to material theme guidelines, helper text should be hidden when error message is set and input is invalid */\n      :host([has-helper][invalid][has-error-message]) [part=\"helper-text\"] {\n        display: none;\n      }\n\n      [part=\"label\"] {\n        width: 133%;\n        transition: transform 0.175s, color 0.175s, width 0.175s;\n        transition-timing-function: ease, ease, step-end;\n      }\n\n      :host([has-helper]) [part=\"helper-text\"]::before {\n        content: \"\";\n        display: block;\n        height: 6px;\n      }\n\n      [part=\"helper-text\"],\n      [part=\"helper-text\"] ::slotted(*) {\n        font-size: .75rem;\n        line-height: 1;\n        color: var(--material-secondary-text-color);\n      }\n\n      /* TODO: using unsupported selector to fix IE11 (even thought the label element is scaled down,\n         the 133% width still takes the same space as an unscaled element */\n      ::-ms-backdrop,\n      .vaadin-text-field-container {\n        overflow: hidden;\n      }\n\n      /* Same fix for MS Edge ^^   */\n      @supports (-ms-ime-align:auto) {\n        .vaadin-text-field-container {\n          overflow: hidden;\n        }\n      }\n\n      :host(:hover:not([readonly]):not([invalid])) [part=\"input-field\"]::before {\n        opacity: var(--_material-text-field-input-line-hover-opacity, 0.87);\n      }\n\n      :host([focused]:not([invalid])) [part=\"label\"] {\n        color: var(--material-primary-text-color);\n      }\n\n      :host([focused]) [part=\"input-field\"]::after,\n      :host([invalid]) [part=\"input-field\"]::after {\n        opacity: 1;\n        transform: none;\n        transition: transform 0.175s, opacity 0.175s;\n      }\n\n      :host([invalid]) [part=\"input-field\"]::after {\n        background-color: var(--material-error-color);\n      }\n\n      :host([input-prevented]) [part=\"input-field\"] {\n        color: var(--material-error-text-color);\n      }\n\n      :host([disabled]) {\n        pointer-events: none;\n      }\n\n      :host([disabled]) [part=\"input-field\"] {\n        color: var(--material-disabled-text-color);\n      }\n\n      :host([disabled]) [part=\"input-field\"]::before {\n        background-color: transparent;\n        background-image: linear-gradient(90deg, var(--_material-text-field-input-line-background-color, #000) 0, var(--_material-text-field-input-line-background-color, #000) 2px, transparent 2px);\n        background-size: 4px 1px;\n        background-repeat: repeat-x;\n      }\n\n      /* Only target the visible floating label */\n      :host([has-label]:not([has-value]):not([focused]):not([invalid]):not([theme~=\"always-float-label\"])) [part=\"label\"] {\n        width: 100%;\n        /* IE11 doesn\u2019t work with calc inside the translate function, so we need to have a fixed pixel value instead of 50% + 16px */\n        transform: scale(1) translateY(24px);\n        transition-timing-function: ease, ease, step-start;\n        pointer-events: none;\n        left: auto;\n        right: auto;\n        transition-delay: 0.1s;\n      }\n\n      /* Slotted content */\n\n      [part=\"input-field\"] ::slotted(*:not([part=\"value\"]):not([part$=\"-button\"]):not(input):not(textarea)) {\n        color: var(--material-secondary-text-color);\n      }\n\n      [part=\"clear-button\"]::before {\n        content: var(--material-icons-clear);\n      }\n\n      /* RTL specific styles */\n\n      :host([disabled][dir=\"rtl\"]) [part=\"input-field\"]::before {\n        background-image: linear-gradient(-90deg, var(--_material-text-field-input-line-background-color, #000) 0, var(--_material-text-field-input-line-background-color, #000) 2px, transparent 2px);\n      }\n    </style>\n  </template>\n</dom-module>"], ["<dom-module id=\"material-text-field\" theme-for=\"vaadin-text-field\">\n  <template>\n    <style include=\"material-required-field material-field-button\">\n      :host {\n        display: inline-flex;\n        position: relative;\n        padding-top: 8px;\n        margin-bottom: 8px;\n        outline: none;\n        color: var(--material-body-text-color);\n        font-size: var(--material-body-font-size);\n        line-height: 24px;\n        font-family: var(--material-font-family);\n        -webkit-font-smoothing: antialiased;\n        -moz-osx-font-smoothing: grayscale;\n      }\n\n      :host::before {\n        line-height: 32px;\n      }\n\n      /* Strange gymnastics to make fields vertically align nicely in most cases\n         (no label, with label, without prefix, with prefix, etc.) */\n\n      :host([has-label]) {\n        padding-top: 24px;\n      }\n\n      [part=\"label\"]:empty {\n        display: none;\n      }\n\n      [part=\"label\"]:empty::before {\n        content: \"\xA0\";\n        position: absolute;\n      }\n\n      [part=\"input-field\"] {\n        position: relative;\n        top: -0.2px; /* NOTE(platosha): Adjusts for wrong flex baseline in Chrome & Safari */\n        height: 32px;\n        padding-left: 0;\n        padding-right: 0;\n        background-color: transparent;\n        margin: 0;\n      }\n\n      [part=\"input-field\"]::before,\n      [part=\"input-field\"]::after {\n        content: \"\";\n        position: absolute;\n        bottom: 0;\n        left: 0;\n        right: 0;\n        height: 1px;\n        transform-origin: 50% 0%;\n        background-color: var(--_material-text-field-input-line-background-color, #000);\n        opacity: var(--_material-text-field-input-line-opacity, 0.42);\n      }\n\n      [part=\"input-field\"]::after {\n        background-color: var(--material-primary-color);\n        opacity: 0;\n        height: 2px;\n        bottom: 0;\n        transform: scaleX(0);\n        transition: opacity 0.175s;\n      }\n\n      :host([disabled]) [part=\"label\"],\n      :host([disabled]) [part=\"value\"],\n      :host([disabled]) [part=\"input-field\"] ::slotted(input),\n      :host([disabled]) [part=\"input-field\"] ::slotted(textarea),\n      :host([disabled]) [part=\"input-field\"] ::slotted([part=\"value\"]) {\n        color: var(--material-disabled-text-color);\n        -webkit-text-fill-color: var(--material-disabled-text-color);\n      }\n\n      [part=\"value\"],\n      :host([disabled]) [part=\"input-field\"] ::slotted(input),\n      :host([disabled]) [part=\"input-field\"] ::slotted(textarea),\n      /* Slotted by vaadin-select-text-field */\n      [part=\"input-field\"] ::slotted([part=\"value\"]) {\n        outline: none;\n        margin: 0;\n        border: 0;\n        border-radius: 0;\n        padding: 8px 0;\n        width: 100%;\n        height: 100%;\n        font-family: inherit;\n        font-size: 1em;\n        line-height: inherit;\n        color: inherit;\n        background-color: transparent;\n        /* Disable default invalid style in Firefox */\n        box-shadow: none;\n      }\n\n      /* TODO: the text opacity should be 42%, but the disabled style is 38%.\n      Would need to introduce another property for it if we want to be 100% accurate. */\n      [part=\"value\"]::-webkit-input-placeholder {\n        color: var(--material-disabled-text-color);\n        transition: opacity 0.175s 0.05s;\n        opacity: 1;\n      }\n\n      [part=\"value\"]:-ms-input-placeholder {\n        color: var(--material-disabled-text-color);\n      }\n\n      [part=\"value\"]::-moz-placeholder {\n        color: var(--material-disabled-text-color);\n        transition: opacity 0.175s 0.05s;\n        opacity: 1;\n      }\n\n      [part=\"value\"]::placeholder {\n        color: var(--material-disabled-text-color);\n        transition: opacity 0.175s 0.1s;\n        opacity: 1;\n      }\n\n      :host([has-label]:not([focused]):not([invalid]):not([theme=\"always-float-label\"])) [part=\"value\"]::-webkit-input-placeholder {\n        opacity: 0;\n        transition-delay: 0;\n      }\n\n      :host([has-label]:not([focused]):not([invalid]):not([theme=\"always-float-label\"])) [part=\"value\"]::-moz-placeholder {\n        opacity: 0;\n        transition-delay: 0;\n      }\n\n      :host([has-label]:not([focused]):not([invalid]):not([theme=\"always-float-label\"])) [part=\"value\"]::placeholder {\n        opacity: 0;\n        transition-delay: 0;\n      }\n\n      /* IE11 doesn\u2019t show the placeholder when the input is focused, so it\u2019s basically useless for this theme */\n      :host([has-label]) [part=\"value\"]:-ms-input-placeholder {\n        opacity: 0;\n      }\n\n      /* According to material theme guidelines, helper text should be hidden when error message is set and input is invalid */\n      :host([has-helper][invalid][has-error-message]) [part=\"helper-text\"] {\n        display: none;\n      }\n\n      [part=\"label\"] {\n        width: 133%;\n        transition: transform 0.175s, color 0.175s, width 0.175s;\n        transition-timing-function: ease, ease, step-end;\n      }\n\n      :host([has-helper]) [part=\"helper-text\"]::before {\n        content: \"\";\n        display: block;\n        height: 6px;\n      }\n\n      [part=\"helper-text\"],\n      [part=\"helper-text\"] ::slotted(*) {\n        font-size: .75rem;\n        line-height: 1;\n        color: var(--material-secondary-text-color);\n      }\n\n      /* TODO: using unsupported selector to fix IE11 (even thought the label element is scaled down,\n         the 133% width still takes the same space as an unscaled element */\n      ::-ms-backdrop,\n      .vaadin-text-field-container {\n        overflow: hidden;\n      }\n\n      /* Same fix for MS Edge ^^   */\n      @supports (-ms-ime-align:auto) {\n        .vaadin-text-field-container {\n          overflow: hidden;\n        }\n      }\n\n      :host(:hover:not([readonly]):not([invalid])) [part=\"input-field\"]::before {\n        opacity: var(--_material-text-field-input-line-hover-opacity, 0.87);\n      }\n\n      :host([focused]:not([invalid])) [part=\"label\"] {\n        color: var(--material-primary-text-color);\n      }\n\n      :host([focused]) [part=\"input-field\"]::after,\n      :host([invalid]) [part=\"input-field\"]::after {\n        opacity: 1;\n        transform: none;\n        transition: transform 0.175s, opacity 0.175s;\n      }\n\n      :host([invalid]) [part=\"input-field\"]::after {\n        background-color: var(--material-error-color);\n      }\n\n      :host([input-prevented]) [part=\"input-field\"] {\n        color: var(--material-error-text-color);\n      }\n\n      :host([disabled]) {\n        pointer-events: none;\n      }\n\n      :host([disabled]) [part=\"input-field\"] {\n        color: var(--material-disabled-text-color);\n      }\n\n      :host([disabled]) [part=\"input-field\"]::before {\n        background-color: transparent;\n        background-image: linear-gradient(90deg, var(--_material-text-field-input-line-background-color, #000) 0, var(--_material-text-field-input-line-background-color, #000) 2px, transparent 2px);\n        background-size: 4px 1px;\n        background-repeat: repeat-x;\n      }\n\n      /* Only target the visible floating label */\n      :host([has-label]:not([has-value]):not([focused]):not([invalid]):not([theme~=\"always-float-label\"])) [part=\"label\"] {\n        width: 100%;\n        /* IE11 doesn\u2019t work with calc inside the translate function, so we need to have a fixed pixel value instead of 50% + 16px */\n        transform: scale(1) translateY(24px);\n        transition-timing-function: ease, ease, step-start;\n        pointer-events: none;\n        left: auto;\n        right: auto;\n        transition-delay: 0.1s;\n      }\n\n      /* Slotted content */\n\n      [part=\"input-field\"] ::slotted(*:not([part=\"value\"]):not([part\\$=\"-button\"]):not(input):not(textarea)) {\n        color: var(--material-secondary-text-color);\n      }\n\n      [part=\"clear-button\"]::before {\n        content: var(--material-icons-clear);\n      }\n\n      /* RTL specific styles */\n\n      :host([disabled][dir=\"rtl\"]) [part=\"input-field\"]::before {\n        background-image: linear-gradient(-90deg, var(--_material-text-field-input-line-background-color, #000) 0, var(--_material-text-field-input-line-background-color, #000) 2px, transparent 2px);\n      }\n    </style>\n  </template>\n</dom-module>"]);

    _templateObject_e709494001a111ebb416cb2b1003c1c5 = function _templateObject_e709494001a111ebb416cb2b1003c1c5() {
      return data;
    };

    return data;
  }

  var $_documentContainer = (0, _htmlTag.html)(_templateObject_e709494001a111ebb416cb2b1003c1c5());
  document.head.appendChild($_documentContainer.content);
});